/* JPI TopSpeed C demo: Bouncing figures.          HUR 8/12/89 */
/*                                                             */
/* COPYRIGHT (C) 1989 Jensen and Partners. All Rights Reserved */

#define _JPI_WIN_
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <choose.h>

#define TRAIL  30

extern struct videoconfig cv;

typedef void (*FUN) ( int x1, int y1, int x2, int y2 );

struct { int x1,y1,x2,y2; FUN fun; } Fig [TRAIL];


static void Null ( int x1, int y1, int x2, int y2 )
{
}


static void Diag ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x1, y1 );
  _lineto ( x2, y2 );
}


static void Rect ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x1, y1 );
  _lineto ( x2, y1 );
  _lineto ( x2, y2 );
  _lineto ( x1, y2 );
  _lineto ( x1, y1 );
}


static void Wave ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x1, y1 );
  _lineto ( (x1+x2)/2, y2 );
  _lineto ( x2, y1 );
}


static void Tria ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x1, y1 );
  _lineto ( (x1+x2)/2, y2 );
  _lineto ( x2, y1 );
  _lineto ( x1, y1 );
}


static void Butr ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x1, y1 );
  _lineto ( x1, y2 );
  _lineto ( x2, y1 );
  _lineto ( x2, y2 );
  _lineto ( x1, y1 );
}


static void Cros ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x1, y1 );
  _lineto ( x2, y2 );
  _moveto ( x1, y2 );
  _lineto ( x2, y1 );
}


static void Plus ( int x1, int y1, int x2, int y2 )
{
  int x, y;

  x = (x1+x2)/2;
  y = (y1+y2)/2;
  _moveto ( x1, y );
  _lineto ( x2, y );
  _moveto ( x, y1 );
  _lineto ( x, y2 );
}


static void Star ( int x1, int y1, int x2, int y2 )
{
  int x, y;

  x = (x1+x2)/2;
  y = (y1+2*y2)/3;
  _moveto ( x1, y1);
  _lineto ( x , y2 );
  _lineto ( x2, y1 );
  _lineto ( x1, y  );
  _lineto ( x2, y );
  _lineto ( x1, y1 );
}


static void Elipp( int x1, int y1, int x2, int y2 )
{
  _ellipse ( _GBORDER, min(x1,x2), min(y1,y2), max(x1,x2), max(y1,y2) );
}


static void ZigZ ( int x1, int y1, int x2, int y2 )
{
  int x, x0;

  x  = (2*x1+x2)/3;
  x0 = (x1+2*x2)/3;
  _moveto ( x1, y1);
  _lineto ( x , y2 );
  _lineto ( x0, y1 );
  _lineto ( x2, y2 );
}


static void Romb ( int x1, int y1, int x2, int y2 )
{
  int x, y;

  x = (x1+x2)/2;
  y = (y1+y2)/2;
  _moveto ( x1, y  );
  _lineto ( x , y2 );
  _lineto ( x2, y  );
  _lineto ( x , y1 );
  _lineto ( x1, y  );
}


static void Rays ( int x1, int y1, int x2, int y2 )
{
  _moveto ( x2, (y1+y2)/2 );
  _lineto ( x1, y1 );
  _lineto ( (x1+x2)/2 , y2 );
  _moveto ( x1, y1 );
  _lineto ( x2, y2 );
}


#define  Bounce(c,v,m)  c+=v; if ( c<0 || m<=c ) { v=-v; c+=v; }


void bounce_demo(void)
{
  char q;
  int i, c, p;
  int x1, y1, x2, y2, vx1, vy1, vx2, vy2;
  FUN f, Functions[] = { Diag, Rect, Wave, Tria, Butr, Cros,
                         Plus, Star, Elipp, ZigZ, Romb, Rays };

  clrscr();
  cputs ( "    This routine draws various figures and moves them\n" );
  cputs ( "    around the screen while varying their shape.\n\n" );
  cputs ( "    Press 'F' to change figure type.\n" );
  cputs ( "    Press 'C' to change figure color.\n" );
  cputs ( "    Press 'W' to make background white.\n" );
  cputs ( "    Press 'B' to make background black.\n" );
  cputs ( "    Press <SPACE> to pause at each pattern.\n" );
  cputs ( "    Press any other key to continue free run.\n\n" );
  cputs ( "    Press a key to start...<ESC> to stop\n" );
  q = getch();
  if (q == 27) exit(0);

  Choose ();

  _setcolor ( cv.numcolors-1 );
  _rectangle ( _GFILLINTERIOR, 0, 0, cv.numxpixels, cv.numypixels );

  randomize ();

  for ( i = 0; i < TRAIL; ++i )
    Fig[i].fun = Null;

  x1 = random ( cv.numxpixels );
  y1 = random ( cv.numypixels );
  x2 = random ( cv.numxpixels );
  y2 = random ( cv.numypixels );
  vx1 =  3;
  vy1 =  2;
  vx2 = -3;
  vy2 =  4;
  c = 1;
  f = Diag;

  for ( p = 0; q != 27; p = (p+1) % TRAIL )
  {
    if ( ! random(2000) ) f = Functions [ random ( sizeof(Functions)/sizeof(FUN) ) ];
    if ( ! random( 300) ) c = 1 + random ( cv.numcolors - 1 );
    if ( ! random( 500) ) vx1 = 1 + random ( cv.numxpixels / 80 );
    if ( ! random( 500) ) vy1 = 1 + random ( cv.numypixels / 80 );
    if ( ! random( 500) ) vx2 = 1 + random ( cv.numxpixels / 80 );
    if ( ! random( 500) ) vy2 = 1 + random ( cv.numypixels / 80 );

    Bounce ( x1, vx1, cv.numxpixels );
    Bounce ( y1, vy1, cv.numypixels );
    Bounce ( x2, vx2, cv.numxpixels );
    Bounce ( y2, vy2, cv.numypixels );

    _setcolor ( 0 );
    Fig[p].fun ( Fig[p].x1, Fig[p].y1, Fig[p].x2, Fig[p].y2 );
    _setcolor ( c );
    f ( x1, y1, x2, y2 );
    Fig[p].fun = f;
    Fig[p].x1 = x1;
    Fig[p].y1 = y1;
    Fig[p].x2 = x2;
    Fig[p].y2 = y2;

    if (q == ' ')
      for ( i = 0; i < TRAIL; ++i )
        Fig[i].fun ( Fig[i].x1, Fig[i].y1, Fig[i].x2, Fig[i].y2 );
    if (q == ' ' || kbhit())
    {
      q = getch();
      switch ( q )
      {
        case 'c':
        case 'C': c = 1 + random ( cv.numcolors - 1 );
                  break;
        case 'f':
        case 'F': f = Functions [ random ( sizeof(Functions)/sizeof(FUN) ) ];
                  break;
        case 'w':
        case 'W': _setcolor ( cv.numcolors-1 );
                  _rectangle ( _GFILLINTERIOR, 0, 0, cv.numxpixels, cv.numypixels );
                  break;
        case 'b':
        case 'B': _setcolor ( 0 );
                  _rectangle ( _GFILLINTERIOR, 0, 0, cv.numxpixels, cv.numypixels );
                  break;
      }
    }
    delay ( 5 );
  }
  _setvideomode ( _DEFAULTMODE );
}
