/* Last updated Thu Jul 29 12:15:58 1989                             */

/*-------------------------------------------------------------------------*
*                                                                          *
*  gdemo.c - graphics demonstration program.             		   *
*                                                                          *
*  COPYRIGHT (C) 1989 Jensen and Partners. All Rights Reserved             *
*  Written by Simon Knight.                                                *
*                                                                          *
*--------------------------------------------------------------------------*/

#define _JPI_WIN_
#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <ctype.h>
#include <alloc.h>

#pragma warn(wall => on)

/*****************************************************************************/
/* Type and structure definitions.                                           */
/*****************************************************************************/

struct _pie_info{
    short state;
    short x1, y1, x2, y2;
    short startx, starty;
    short current_x;
    short current_y;
    short fill;
    short color;
};

typedef struct _pie_info *piehandle;

/*****************************************************************************/
/* Function Prototypes.                                                      */
/*****************************************************************************/

#pragma save
#pragma call(near_call => on)
void  draw_logo(int scale, short cols[]);
void  rotate(long *colors);
void  InitPalette(void);
void  AdjustRGB(unsigned short *red, unsigned short *green, unsigned short *blue);
void  PlotRGB(unsigned short x, unsigned short y, unsigned short red,
                                unsigned short green, unsigned short blue);
short randsize(short size);
short randcolor(void);
int   test_key(void);
void  draw_ellipses(void);
void  Ellipses(int scale);
void  Animation(short adapter);
void  Pies(int scale);
void  Bars(int scale);
void  circulate(piehandle p);
piehandle init_pie(short x1, short y1, short x2, short y2,
                   short init_state, short scale, short fill);
void  dispose_pie(piehandle p);
void  *make_domino(int depth, int width);
void  draw_domino(int depth, int width);
void  draw_spots(int number, int start, int depth, int width);
void  draw_circles(int patnum, int start, int depth, int width);
int   move_down(void *image, short *pos, short limit, short xpos, int incr);
int   move_sideways(void *image, short *pos, short limit, int incr);
void draw_lines(void);
int   EGAintro(void);
int   VGAtriangle(void);
int   CGAintro(void);
int   VGAintro(void);
int   EGADemo(void);
int   VGADemo(void);
int   CGADemo(void);
void  clr(void);
void Hercintro(void);
void HercDemo(void);
#pragma restore

/*****************************************************************************/
/* Data Definitions.                                                         */
/*****************************************************************************/


unsigned char patterns[5][8]={ {0x88, 0x44, 0x22, 0x11, 0x88, 0x44, 0x22, 0x11},
                               {0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA},
                               {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
                               {0xFF, 0x40, 0xFF, 0x40, 0xFF, 0x40, 0xFF, 0x40},
                               {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01}
                             };

int Mono=0;

long colors[]={ _BLACK, _BLUE, _GREEN, _CYAN, _RED, _MAGENTA, _BROWN,
                   _WHITE, _GRAY, _LIGHTBLUE, _LIGHTGREEN, _LIGHTCYAN,
                   _LIGHTRED, _LIGHTMAGENTA, _LIGHTYELLOW, _BRIGHTWHITE };

short xvalues[4];
short yvalues[4];

struct videoconfig cv;

/*****************************************************************************/
/* Function Definitions.                                                     */
/*****************************************************************************/

main()

{
    _getvideoconfig((struct videoconfig far *)&cv);
    switch(cv.adapter)
    {
        case _HGC :
            Mono=1;
            HercDemo();
            break;
        case _MDPA :
            printf("A Color Graphics Card Is Not Installed\n");
            exit(0);
        case _CGA :
        case _MCGA :
            CGADemo();
            break;
        case _VGA :
            VGADemo();
            break;
        case _EGA :
            EGADemo();
            break;
        default:
            printf("Graphics Card Not Supported\n");
            exit(0);
    }
    _setvideomode(_DEFAULTMODE);
    return(0);
}

void HercDemo(void)

{
    _setvideomode(_HERCMONO);
    _getvideoconfig((struct videoconfig far *)&cv);
    Hercintro();
    Ellipses(1);
    draw_lines();
    Animation(_HGC);
    Pies(1);
    Bars(1);
    return;
}

int EGADemo(void)

{
    _setvideomode(_ERESCOLOR);
    _getvideoconfig((struct videoconfig far *)&cv);
    EGAintro();
    Ellipses(1);
    draw_lines();
    Animation(_EGA);
    Pies(1);
    Bars(1);
    return(0);
}

int VGADemo(void)

{
    _setvideomode(_ERESCOLOR);
    _getvideoconfig((struct videoconfig far *)&cv);
    EGAintro();
    VGAtriangle();
    Ellipses(1);
    draw_lines();
    Animation(_EGA);
    Pies(1);
    Bars(1);
    return(0);
}

int CGADemo(void)

{
    _setvideomode(_MRES4COLOR);
    _getvideoconfig((struct videoconfig far *)&cv);
    CGAintro();
    Ellipses(2);
    draw_lines();
    Animation(_CGA);
    Pies(2);
    Bars(2);
    return(0);

}



/*****************************************************************************/
/* Dipslay TopSpeed Logo - CGA specific                                      */
/*****************************************************************************/

int CGAintro()

{
    short c[4]={1, 2, 3, 4};

    _clearscreen(_GCLEARSCREEN);
    draw_logo(2, c);
    _settextposition(4, 11);
    _settextcolor(2);
    _outtext((char far *)"TopSpeed C  Graphics");
    _settextposition(25, 1);
    cprintf("Press Any Key To Continue, X To Exit.");
    test_key();
    return(0);
}

/*****************************************************************************/
/* Dipslay TopSpeed Logo - EGA/VGA specific                                  */
/*****************************************************************************/

int EGAintro()

{
    int n, key;
    short c[4]={9, 8, 15, 6};

    cprintf("TopSpeed C Graphics");
    _setactivepage(1);
    _clearscreen(_GCLEARSCREEN);
    draw_logo(1, c);
    _settextposition(4, 23);
    _settextcolor(4);
    _outtext((char far *)"TopSpeed  C  Graphics  Library  Demo");
    _setvisualpage(1);
    _settextcolor(10);
    _settextposition(25, 23);
    cprintf("Press Any Key To Continue, X To Exit");
    key=test_key();
    if(key == 'c')
    {
        n=1;
        while(!kbhit())
        {
            _remappalette(6, colors[(6+n)%16]);
            _remappalette(8, colors[(8+n)%16]);
            _remappalette(9, colors[(9+n)%16]);
            _remappalette(15, colors[(15+n)%16]);
            delay(100);
            ++n;
        }
        getch();
        while(!kbhit())
        {
            _remapallpalette((long far *)colors);
            delay(1000);
            rotate(colors);
        }
        getch();
    }
    _setactivepage(0);
    _setvisualpage(0);
    _clearscreen(_GCLEARSCREEN);
    return(0);
}

void Hercintro()

{
    short c[4]={1, 1, 1, 1};

    _clearscreen(_GCLEARSCREEN);
    draw_logo(1, c);
    test_key();
    _clearscreen(_GCLEARSCREEN);
    return;
}

/*****************************************************************************/
/* Draw TopSpeed Logo - generic                                              */
/*****************************************************************************/

void draw_logo(int scale, short cols[])

{
    short mode;

    _setcolor(cols[0]);
    if(Mono)
        mode=_GBORDER;
    else
        mode=_GFILLINTERIOR;
    _rectangle(mode, 140/scale, 20/scale, 500/scale, 330/scale);
    _setcolor(cols[1]);
    _moveto(225/scale, 110/scale);
    _lineto(320/scale, 140/scale);
    _lineto(415/scale, 110/scale);
    _lineto(460/scale, 125/scale);
    _lineto(460/scale, 225/scale);
    _lineto(365/scale, 255/scale);
    _lineto(365/scale, 285/scale);
    _lineto(320/scale, 300/scale);
    _lineto(180/scale, 255/scale);
    _lineto(180/scale, 190/scale);
    _lineto(225/scale, 205/scale);
    _lineto(225/scale, 235/scale);
    _lineto(270/scale, 250/scale);
    _lineto(270/scale, 190/scale);
    _lineto(180/scale, 160/scale);
    _lineto(180/scale, 125/scale);
    _lineto(225/scale, 110/scale);

    _moveto(180/scale, 125/scale);
    _lineto(320/scale, 170/scale);
    _lineto(460/scale, 125/scale);
    _moveto(320/scale, 170/scale);
    _lineto(320/scale, 300/scale);

    _moveto(365/scale, 190/scale);
    _lineto(415/scale, 175/scale);
    _lineto(415/scale, 210/scale);
    _lineto(365/scale, 225/scale);
    _lineto(365/scale, 190/scale);
    _lineto(415/scale, 210/scale);

    _moveto(225/scale, 205/scale);
    _lineto(270/scale, 190/scale);
    _moveto(225/scale, 235/scale);
    _lineto(270/scale, 220/scale);
    _moveto(180/scale, 190/scale);
    _lineto(225/scale, 175/scale);

    if(!Mono)
    {
        _floodfill(250/scale, 130/scale, cols[1]);
        _floodfill(230/scale, 180/scale, cols[1]);
        _floodfill(260/scale, 240/scale, cols[1]);
        _floodfill(380/scale, 210/scale, cols[1]);
    
        _setcolor(cols[2]);
        _floodfill(200/scale, 230/scale, cols[1]);
        _floodfill(250/scale, 220/scale, cols[1]);
        _floodfill(400/scale, 190/scale, cols[1]);
        _floodfill(440/scale, 190/scale, cols[1]);
    }
    return;
}

void rotate(long *colors)

{
    int n=0;

    colors[15]=colors[0];
    while(n < 15)
    {
        colors[n]=colors[n+1];
        ++n;
    }
    return;
}

/*****************************************************************************/
/* Draw Color Triangle - VGA specific                                        */
/*****************************************************************************/

VGAtriangle()

{
    unsigned short x, y;
    unsigned short red, green, blue;

    InitPalette();
    x=0;
    while(x < 256)
    {
        y=0;
        while(y < 200)
        {
            red=x;
            green=(y*255)/200;
            if((red+green) < 255)
            {
                blue=255-(red+green);
                AdjustRGB(&red, &green, &blue);
                PlotRGB(x, y, red, green, blue);
            }
            ++y;
        }
        ++x;
    }
    _settextcolor(10);
    _settextposition(25, 5);
    cprintf("Hit Any Key To Continue,X To Exit.");
    test_key();
    _setvideomode(_ERESCOLOR);
    return(0);
}

void InitPalette(void)

{
    unsigned short i=0;
    unsigned short red, green, blue;
    long color;
    long colors[256];

    _setvideomode(_MRES256COLOR);
    while(i < 256)
    {
        red  =(i&0xE0)>>2;
        green=(i&0x1C)<<1;
        blue =(i&0x03)<<4;
        color= (((long)blue)<<16) | (((long)green)<<8) | (red);
        colors[i]=color;
        ++i;
    }
    _remapallpalette((long far *)colors);
    return;
}

void AdjustRGB(unsigned short *red, unsigned short *green, unsigned short *blue)

{
    unsigned short r, g, b;
    unsigned short nr, ng, nb;

    r=*red;
    g=*green;
    b=*blue;
    if((r >= b) && (r >= g))
    {
        nr=255;
        ng=(g*255)/r;
        nb=(b*255)/r;
    }
    else if((g >= r) && (g >= b))
    {
        ng=255;
        nr=(r*255)/g;
        nb=(b*255)/g;
    }
    else
    {
        nb=255;
        ng=(g*255)/b;
        nr=(r*255)/b;
    }
    *red=nr;
    *green=ng;
    *blue=nb;
    return;
}

void PlotRGB(unsigned short x, unsigned short y, unsigned short red,
                    unsigned short green, unsigned short blue)

{
    unsigned short r, g, b, color;

    r=red&0xE0;
    g=(green&0xE0)>>3;
    b=(blue&0xC0)>>6;
    color=r|g|b;
    _setcolor(color);
    _setpixel(x+20, y);
    return;
}

/*****************************************************************************/
/* Draw Series of Ellipses - generic                                         */
/*****************************************************************************/

void Ellipses(int scale)

{
    _setviewport(0, 0, cv.numxpixels, cv.numypixels);
    _clearscreen(_GCLEARSCREEN);
     draw_ellipses();
    _clearscreen(_GCLEARSCREEN);
    _rectangle(_GBORDER, 49/scale, 24/scale, 501/scale, 291/scale);
    _setviewport(50/scale, 25/scale, 500/scale, 290/scale);
     draw_ellipses();
    _setviewport(0, 0, cv.numxpixels, cv.numypixels);
    return;
}

void draw_ellipses(void)

{
    int n, f;
    short x1, x2, y1, y2;
    short c;

    n=0;
    c=1;
    f=_GFILLINTERIOR;
    while(n++ < 100)
    {
        if(kbhit())
            break;
        _setcolor(c);
        _setfillmask((unsigned char far *)patterns[random(5)]);
        x1=random(cv.numxpixels);
        y1=random(cv.numypixels);
        x2=x1+random(cv.numxpixels-x1);
        y2=y1+random(cv.numypixels-y1);
        if(f == _GFILLINTERIOR)
            f=_GBORDER;
        else
            f=_GFILLINTERIOR;
        _ellipse(f, x1, y1, x2, y2);
        if(++c == cv.numcolors)
            c=1;
    }
    if(!Mono)
    {
        _settextposition(25, 1);
        cprintf("Press Any Key To Continue, X To Exit");
    }
    test_key();
    return;
}


/*****************************************************************************/
/* Draw Opening Pies - generic                                               */
/*****************************************************************************/

void Pies(int scale)

{
    piehandle p[5];
    int n=0;

    xvalues[0]=cv.numxpixels-1;
    xvalues[1]=cv.numxpixels-1;
    xvalues[2]=0;
    xvalues[3]=0;
    yvalues[0]=cv.numypixels-1;
    yvalues[1]=0;
    yvalues[2]=0;
    yvalues[3]=cv.numypixels-1;
    _clearscreen(_GCLEARSCREEN);
    p[0]=init_pie(30, 30, 150, 180, 0, scale, _GBORDER);
    p[1]=init_pie(450, 30, 550, 180, 1, scale, _GFILLINTERIOR);
    p[2]=init_pie(30, 200, 150, 300, 2, scale, _GFILLINTERIOR);
    p[3]=init_pie(450, 200, 550, 300, 3, scale, _GBORDER);
    p[4]=init_pie(200, 130, 400, 210, 0, scale, _GFILLINTERIOR);

    if(!Mono)
    {
        _settextposition(25, 1);
        cprintf("Press Any Key To Continue, X To Exit");
    }
    while(!kbhit())
    {
        if(n == 5)
            n=0;
        circulate(p[n]);
        ++n;
    }
    test_key();
    n=0;
    while(n < 5)
    {
        dispose_pie(p[n]);
        ++n;
    }
    _clearscreen(_GCLEARSCREEN);
    _setfillmask((unsigned char far *)patterns[2]);
    return;
}


piehandle init_pie(short x1, short y1, short x2, short y2,
                   short init_state, short scale, short fill)

{
    piehandle p;

    p=malloc(sizeof(struct _pie_info));
    if(p == NULL)
    {
        _setvideomode(_DEFAULTMODE);
        cprintf("Out of Memory\n");
        abort();
    }
    p->x1=x1/scale;
    p->y1=y1/scale;
    p->x2=x2/scale;
    p->y2=y2/scale;
    p->current_x=xvalues[init_state];
    p->current_y=yvalues[init_state];
    p->startx=xvalues[init_state];
    p->starty=yvalues[init_state];
    p->state=init_state;
    p->fill=fill;
    if(Mono)
        p->color=1;
    else
        p->color=random(cv.numcolors-2)+1;
    _pie(fill, p->x1, p->y1, p->x2, p->y2, p->current_x, p->current_y, p->current_x, p->current_y);
    return(p);
}

void dispose_pie(piehandle p)

{
    free(p);
    return;
}

void circulate(piehandle p)

{
    _setcolor(0);
    _setfillmask((unsigned char far *)patterns[2]);
    _rectangle(_GFILLINTERIOR, p->x1, p->y1, p->x2, p->y2);
    _setcolor(p->color);
    switch(p->state)
    {
        case 0:
            if(p->current_y > 0)
            {
                p->current_y-=4;
                break;
            }
            ++(p->state);
        case 1:
            if(p->current_x > 0)
            {
                p->current_x-=8;
                break;
            }
            ++(p->state);
        case 2:
            if(p->current_y < cv.numypixels)
            {
                p->current_y+=4;
                break;
            }
            ++(p->state);
        case 3:
            if(p->current_x < cv.numxpixels)
            {
                p->current_x+=8;
                break;
            }
            p->state=0;
    }
    if(p->fill == _GFILLINTERIOR)
        _setfillmask((unsigned char far *)patterns[random(5)]);
    _pie(p->fill, p->x1, p->y1, p->x2, p->y2, p->current_x, p->current_y,
                   p->startx, p->starty);
    return;
}

/*****************************************************************************/
/* Animation Functions - generic                                             */
/*****************************************************************************/

void Animation(short adapter)

{
    short col_position[11];
    short row_position[3];
    int count, width, depth, incr;
    int max_row, max_col, clear;
    int current_row, current_col;
    void *image;

    _clearscreen(_GCLEARSCREEN);
    _setcolor(cv.numcolors-1);
    _setfillmask((unsigned char far *)patterns[2]);
    if((adapter == _EGA) || (adapter == _HGC))
    {
        width=50;
        depth=100;
        max_row=2;
        max_col=9;
        clear=20;
        incr=10;
    }
    else
    {
        width=50;
        depth=90;
        max_row=1;
        max_col=4;
        clear=10;
        incr=5;
    }
    count=0;
    while(count <= max_col)
    {
        col_position[count]=count*(width+10);
        ++count;
    }
    count=0;
    while(count <= max_row)
    {
        row_position[count]=count*(depth+clear);
        ++count;
    }
    current_col=max_col;
    current_row=max_row;

    while(current_col >= 0)
    {
        image=make_domino(depth, width);
        if(current_col > 0)
        {
            if(move_sideways(image, col_position, current_col, incr))
                break;
        }
        if(current_row > 0)
        {
            if(move_down(image, row_position, current_row, col_position[current_col], incr))
                break;
            --current_row;
        }
        else
        {
            --current_col;
            current_row=max_row;
        }
        free(image);
        if(kbhit())
            break;
    }
    if(!Mono)
    {
        _settextposition(25, 1);
        cprintf("Press Any Key To Continue, X To Exit.");
    }
    test_key();
    return;
}

void *make_domino(int depth, int width)

{
    void *buffer;
    long size;

    size=_imagesize(0, 0, width, depth);
    buffer=malloc((size_t) size);
    if(buffer == NULL)
    {
        _setvideomode(_DEFAULTMODE);
        cprintf("Out Of Memory\n");
        abort();
    }
    draw_domino(depth, width);
    _getimage(0, 0, width, depth, (char far *)buffer);
    return(buffer);
}

void draw_domino(int depth, int width)

{
    int spots;

    _rectangle(_GBORDER, 0, 0, width, depth);
    _moveto(0, depth/2);
    _lineto(width, depth/2);
    spots=random(7);
    draw_spots(spots, 0, depth, width);
    spots=random(7);
    draw_spots(spots, depth/2, depth, width);
    return;
}

void draw_spots(int number, int start, int depth, int width)

{
    short pattern[3];
    int n;

    if(number == 0)
        return;
    switch(number)
    {
        case 1:
            pattern[0]=1;
            pattern[1]=0;
            break;
        case 2:
            pattern[0]=2;
            pattern[1]=0;
            break;
        case 3:
            pattern[0]=2;
            pattern[1]=1;
            pattern[2]=0;
            break;
        case 4:
            pattern[0]=4;
            pattern[1]=0;
            break;
        case 5:
            pattern[0]=4;
            pattern[1]=1;
            pattern[2]=0;
            break;
        case 6:
            pattern[0]=6;
            pattern[1]=0;
            break;
    }
    n=0;
    while(pattern[n])
    {
        draw_circles(pattern[n], start, depth, width);
        ++n;
    }
    return;
}

void draw_circles(int patnum, int start, int depth, int width)

{
    int n=0;
    short x, y, xpos, ypos;
    static struct xycoord spotlist[6][6]={
        { {2, 2} },
        { {1, 1}, {3, 3} },
        { {0, 0} },
        { {1, 1}, {3, 1}, {1, 3}, {3, 3} },
        { {0, 0} },
        { {1, 1}, {3, 1}, {1, 2}, {3, 2}, {1, 3}, {3, 3}}
    };

    while((x=spotlist[patnum-1][n].xcoord) != 0)
    {
        xpos=(width>>2)*x;
        y=spotlist[patnum-1][n].ycoord;
        ypos=(depth>>3)*y+start;
        _ellipse(_GFILLINTERIOR, xpos-2, ypos-2, xpos+2, ypos+2);
        if(++n == 6)
            break;
    }
    return;
}


int move_sideways(void *image, short *pos, short limit, int incr)

{
    int x=0, y=0;
    int ret=0;

    while(x < pos[limit])
    {
        _putimage(x, y, (char far *)image, _GXOR);
        x+=incr;
        _putimage(x, y, (char far *)image, _GPSET);
        if(kbhit())
        {
            test_key();
            ret=1;
            break;
        }
    }
    return(ret);
}

int move_down(void *image, short *pos, short limit, short xpos, int incr)

{
    int y=0;
    int ret=0;

    while(y < pos[limit])
    {
        _putimage(xpos, y, (char far *)image, _GXOR);
        y+=incr;
        _putimage(xpos, y, (char far *)image, _GPSET);
        if(kbhit())
        {
            test_key();
            ret=1;
            break;
        }
    }
    return(ret);
}

/*****************************************************************************/
/* Bar and Pie Graph Functions - generic                                     */
/*****************************************************************************/

void Bars(int scale)

{
    short x1, y1;
    short x2, y2;
    short x3, y3;
    short x4, y4;
    unsigned char new_mask[8];

    _setviewport(0, 0, cv.numxpixels, cv.numypixels);
    _clearscreen(_GCLEARSCREEN);
    x1=320/scale;
    y1=20/scale;
    x2=600/scale;
    y2=280/scale;
    x4=300/scale;
    y4=260/scale;
    x3=620/scale;
    y3=260/scale;
    _setcolor(max(4%cv.numcolors, 1));
    _pie(_GFILLINTERIOR, x1, y1, x2, y2, x3, y3, x4, y4);

    x1=320/scale;
    y1=40/scale;
    x2=600/scale;
    y2=300/scale;
    x3=300/scale;
    y3=280/scale;
    x4=620/scale;
    y4=280/scale;
    _setcolor(max(3%cv.numcolors, 1));
    _pie(_GBORDER, x1, y1, x2, y2, x3, y3, x4, y4);


    new_mask[0]=0x88;
    new_mask[1]=0x44;
    new_mask[2]=0x22;
    new_mask[3]=0x11;
    new_mask[4]=0x88;
    new_mask[5]=0x44;
    new_mask[6]=0x22;
    new_mask[7]=0x11;
    _setfillmask((unsigned char far *)new_mask);
    x1=19/scale;
    y1=10/scale;
    x2=x1;
    y2=321/scale;
    x3=600/scale;
    y3=y2;

    _moveto(x1, y1);
    _lineto(x2, y2);
    _lineto(x3, y3);
    if(!Mono)
    {
        _settextposition(25, 13/scale);
        _outtext((char far *)"Bar Graphs and Pie Charts");
    }
    _setcolor(max(1%cv.numcolors, 1));
    x1=20/scale;
    y1=20/scale;
    x2=59/scale;
    y2=320/scale;
    _cube(_GFILLINTERIOR, _GTOP, x1, y1, x2, y2, 20/scale);

    _setcolor(max(2%cv.numcolors, 1));
    x1=60/scale;
    y1=120/scale;
    x2=99/scale;
    y2=320/scale;
    _cube(_GFILLINTERIOR, _GTOP, x1, y1, x2, y2, 20/scale);

    _setcolor(max(3%cv.numcolors, 1));
    x1=100/scale;
    y1=80/scale;
    x2=139/scale;
    y2=320/scale;
    _cube(_GFILLINTERIOR, _GTOP, x1, y1, x2, y2, 20/scale);

    _setcolor(max(4%cv.numcolors, 1));
    x1=140/scale;
    y1=200/scale;
    x2=179/scale;
    y2=320/scale;
    _cube(_GFILLINTERIOR, _GTOP, x1, y1, x2, y2, 20/scale);

    getch();
    return;
}

/*****************************************************************************/
/* Miscellaneous Functions - generic                                         */
/*****************************************************************************/

short randcolor(void)

{
    short color;

    color=random(cv.numcolors);
    if(color == 0)
        color=cv.numcolors-1;
    return(color);
}

int test_key(void)

{
    int c;

    c=getch();
    if(tolower(c) == 'x')
    {
        _setvideomode(_DEFAULTMODE);
        exit(0);
    }
    return(c);
}

void draw_lines(void)

{
    short i, x, y, col;
    short max_x, max_y;
    short top, left, bottom, right;
    int limit;

    _clearscreen(_GCLEARSCREEN);
    top=0;
    left=0;
    bottom=cv.numypixels - 1;
    right =cv.numxpixels - 1;
    max_x=cv.numxpixels - 1;
    max_y=cv.numypixels - 1;
    limit=cv.numcolors-1;
    col=0;
    for (i = 0; i <= limit; ++i)
    {
        _setcolor(++col);
        _setcliprgn(left, top, right, bottom);
        top+=4;
        left+=4;
        bottom-=4;
        right-=4;
        for (x = 0; x <= max_x; x += 4)
        {
            _moveto(x, 0);
            _lineto(max_x - x,max_y);
        }
        for (y = 0; y <= max_y; y += 2)
        {
            _moveto(max_x,y);
            _lineto(0, max_y - y);
        }
    }
    _settextposition(25, 1);
    _setcliprgn(0, 0, cv.numxpixels-1, cv.numypixels-1);
    if(!Mono)
        cprintf("Press Any Key To Continue, X To Exit.");
    test_key();
    _clearscreen(_GCLEARSCREEN);
    return;
}
