#include <textwin.hpp>
#include <highscr.hpp>
#include <stdio.h>
#include <string.h>
#ifdef __OS2__
#include "os2glue.hpp"
#else
#include <bios.h>
#endif

HighScoreTable::HighScoreTable(char *file,char size)
{ FILE *infile=fopen(file,"rb");
  tablesize=size;
  data=new person [size];
  strcpy(filename,file);
  unsigned rin=0;
  if (infile)
    rin=fread(data,sizeof(person),size,infile);
  if (rin!=size)
    for (char i=0;i<size;i++)
    { strcpy(data[i].name,"Nobody");
      data[i].score=0;
    }
  fclose(infile);
  dirty=0;
  recent=-1;
}

HighScoreTable::~HighScoreTable()
{ if (dirty)
  { FILE *outfile=fopen(filename,"wb");
    if (outfile)
      fwrite(data,sizeof(person),tablesize,outfile);
  }
}

void HighScoreTable::Display()
{ char tableY=(20-tablesize)/2;
  window tab(22,tableY,62,tableY+tablesize+5,DOUBLEFRAME,White,Blue,
             Blue,LightGray);
  tab.settitle("High Scores",CenterUpperTitle);
  clrscr();
  for (char i=0;i<tablesize;i++)
    cprintf("  %-20s  %8ld\n",data[i].name,data[i].score);
  if (recent>0)
  { gotoxy(10,tablesize+2);
    cprintf("Your score %8ld\n",recent);
  }
  gotoxy(8,tablesize+3);
  cputs("Press a key to continue");
  bioskey(0);
}

void HighScoreTable::AddValue(long ThisScore)
{ for (char i=0;i<tablesize;i++)
    if (ThisScore>data[i].score)
    { dirty=1;
      memmove(data+i+1,data+i,(tablesize-i-1)*sizeof(person));
      window hs(20,10,61,15,DOUBLEFRAME,Blue,LightGray,Red,LightGray);
      hs.settitle("Name Entry",CenterUpperTitle);
      clrscr();
      cputs("You have achieved one of the high scores");
      cputs(" Please enter your name (20 chars max)  ");
      gotoxy(5,3);
      char temp[23];
      temp[0]=20;
      cgets(temp);
      strcpy(data[i].name,temp+2);
      data[i].score=ThisScore;
      break;
    }
  recent=ThisScore;
}