/* JPI TopSpeed C demo: JPI Logo.                  HUR 6/11/89 */
/*                                                             */
/* COPYRIGHT (C) 1989 Jensen and Partners. All Rights Reserved */

#define _JPI_WIN_
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <math.h>
#include <choose.h>

extern struct videoconfig cv;

typedef struct { long x,y,z; } spacepoint;
typedef struct { int  w,h;   } screenpoint;
typedef struct { int  p,q;   } linesegment;

long t11,t12,t13,t21,t22,t23,t31,t32,t33,d;


spacepoint Points[] = { { 0, 0, 0 },
                        { 0, 0, 4 },
                        { 3, 0, 4 },
                        { 3, 0, 1 },
                        { 1, 0, 1 },
                        { 1, 0, 0 },
                        { 1, 0, 2 },
                        { 1, 0, 3 },
                        { 2, 0, 3 },
                        { 2, 0, 2 },

                        { 0, 3, 0 },
                        { 0, 3, 2 },
                        { 0, 2, 2 },
                        { 0, 2, 1 },
                        { 0, 1, 1 },
                        { 0, 1, 3 },
                        { 0, 3, 3 },
                        { 0, 3, 4 },

                        { 1, 1, 4 },
                        { 3, 1, 4 },
                        { 3, 1, 1 },
                        { 1, 1, 1 },
                        { 1, 1, 2 },
                        { 1, 1, 3 },
                        { 2, 1, 3 },
                        { 2, 1, 2 },

                        { 1, 3, 0 },
                        { 1, 3, 2 },
                        { 1, 2, 2 },
                        { 1, 2, 1 },
                        { 1, 3, 3 },
                        { 1, 3, 4 } };

linesegment Lines[] = { {  0,  1 },
                        {  1,  2 },
                        {  2,  3 },
                        {  3,  4 },
                        {  4,  5 },
                        {  5,  0 },
                        {  6,  7 },
                        {  7,  8 },
                        {  8,  9 },
                        {  9,  6 },

                        {  0, 10 },
                        { 10, 11 },
                        { 11, 12 },
                        { 12, 13 },
                        { 13, 14 },
                        { 14, 15 },
                        { 15, 16 },
                        { 16, 17 },
                        { 17,  1 },

                        { 18, 19 },
                        { 19, 20 },
                        { 20, 21 },
                        { 21, 18 },
                        { 23, 24 },
                        { 24, 25 },
                        { 25, 22 },

                        {  5, 26 },
                        { 26, 27 },
                        { 27, 28 },
                        { 28, 29 },
                        { 29, 21 },
                        { 23, 30 },
                        { 30, 31 },
                        { 31, 18 },

                        {  2, 19 },
                        {  3, 20 },
                        {  4, 21 },
                        {  6, 22 },
                        {  7, 23 },
                        {  8, 24 },
                        {  9, 25 },

                        { 10, 26 },
                        { 11, 27 },
                        { 12, 28 },
                        { 13, 29 },
                        { 14, 21 },
                        { 15, 23 },
                        { 16, 30 },
                        { 17, 31 } };

#define Np (sizeof(Points)/sizeof(spacepoint))
#define Nl (sizeof(Lines)/sizeof(linesegment))


static int isqrt ( long s )
{
  unsigned int  r,t;
  unsigned long t2,rt,a;

  if ( s < 0 ) a = -s;
  else         a = +s;
  t  = 0x8000U;
  t2 = 0x8000UL * 0x8000UL;
  r  = 0;
  rt = 0;
  for (;;)
  {
    if (t2 + rt <= a)
    {
      a -= t2 + rt;
      r += t;
      rt += t2 + t2;
    }
    t >>= 1;
    if (t == 0) break;
    rt >>= 1;
    t2 >>= 2;
  }
  return r;
}


#define F 1000

static void Solve ( spacepoint A, spacepoint B, spacepoint E,
                    long l1,      long l2,      long l3 )
{
  t11 = l1 * (B.y * E.z - E.y * B.z) / F;
  t12 = l1 * (E.x * B.z - B.x * E.z) / F;
  t13 = l1 * (B.x * E.y - E.x * B.y) / F;
  t21 = l2 * (E.y * A.z - A.y * E.z) / F;
  t22 = l2 * (A.x * E.z - E.x * A.z) / F;
  t23 = l2 * (E.x * A.y - A.x * E.y) / F;
  t31 = l3 * (A.y * B.z - B.y * A.z) / F;
  t32 = l3 * (B.x * A.z - A.x * B.z) / F;
  t33 = l3 * (A.x * B.y - B.x * A.y) / F;
  d /= F;
}


static void Calculate ( spacepoint O, spacepoint E, long la, long lb )
{
  spacepoint A,B;
  long       le;

  E.x -= O.x;
  E.y -= O.y;
  E.z -= O.z;

  A.x = -E.y;
  A.y = +E.x;
  A.z = 0;

  B.x = E.y * A.z - A.y * E.z;
  B.y = E.z * A.x - A.z * E.x;
  B.z = E.x * A.y - A.x * E.y;

  d = isqrt ( A.x * A.x + A.y * A.y + A.z * A.z );
  A.x = A.x * la / d;
  A.y = A.y * la / d;
  A.z = A.z * la / d;

  d = isqrt ( B.x * B.x + B.y * B.y + B.z * B.z );
  B.x = B.x * lb / d;
  B.y = B.y * lb / d;
  B.z = B.z * lb / d;

  d = + A.x * B.y * E.z + B.x * E.y * A.z + E.x * A.y * B.z
      - A.x * E.y * B.z - B.x * A.y * E.z - E.x * B.y * A.z ;

  le = E.x * E.x + E.y * E.y + E.z * E.z;

  Solve ( A, B, E, la*la, lb*lb, le );
}

static screenpoint Map ( spacepoint O, spacepoint P )
{
  spacepoint T;
  screenpoint Q;

  P.x -= O.x;
  P.y -= O.y;
  P.z -= O.z;
  T.x = (t11 * P.x + t12 * P.y + t13 * P.z) / d;
  T.y = (t21 * P.x + t22 * P.y + t23 * P.z) / d;
  T.z = (t31 * P.x + t32 * P.y + t33 * P.z) / d;

  T.x = T.x * cv.numxpixels / (cv.numxpixels - T.z / 2);
  T.y = T.y * cv.numypixels / (cv.numypixels - T.z / 2);

  Q.w = cv.numxpixels / 2 + (int)T.x;
  Q.h = cv.numypixels / 2 - (int)T.y;
  return Q;
}


static void Line ( screenpoint P1, screenpoint P2, int color )
{
  _setcolor ( color );
  _moveto ( P1.w, P1.h );
  _lineto ( P2.w, P2.h );
}


#define PAUSE


void logo_demo()
{
  spacepoint E,O;
  screenpoint Old[Np],New[Np];
  double u,v,d;
  int i,c;
  char C;

  clrscr();
  cputs ( "    This program draws the JPI logo and tumbles it\n" );
  cputs ( "    around a bit. Hidden line removal is left as an\n" );
  cputs ( "    exercise for the reader...\n\n" );
  cputs ( "    Use <SPACE> to stop at each view.\n" );
  cputs ( "    Use any other key to resume free run.\n\n" );
  cputs ( "    Press a key to start...<ESC> to stop\n" );
  C = getch();
  if (C == 27) exit(0);

  Choose ();

  randomize();

  O.x = 0;
  O.y = 0;
  O.z = 2;

  for ( i = 0; i < Np; ++i )
    New[i].w = New[i].h = 0;

  d = (double)((cv.numxpixels+cv.numypixels) / 10);
  u = 3.8;
  c = 0;

  for (;;)
  {
    if (c == 0 && !random(100))
      c = (1 + cv.numcolors / 4) * (2 + random(5));
    if (c > 0 && !--c)
    {
      for ( i = 0; i < 8 && !kbhit(); ++i )
        delay ( 500 );
      if (kbhit()) C = getch();
      if (kbhit() || C == ' ') if ((C = getch()) == 27) break;
      _clearscreen ( _GCLEARSCREEN );
    }
    v = 1.47 * u;
    E.x = (long)(d * cos(u) * cos(v) );
    E.y = (long)(d * sin(u) );
    E.z = (long)(d * sin(v) );
    if (E.x != O.x || E.y != O.y)
    {
      Calculate ( O, E, cv.numxpixels / 8, 5 * cv.numypixels / 32 );
      for ( i = 0; i < Np; ++i )
      {
        Old[i] = New[i];
        New[i] = Map ( O, Points[i] );
      }
      if (!c)
        for ( i = 0; i < Nl; ++i )
          Line ( Old[Lines[i].p], Old[Lines[i].q], 0 );
      for ( i = 0; i < Nl; ++i )
        Line ( New[Lines[i].p], New[Lines[i].q], 1 + (c/5) % (cv.numcolors-1) );
    }
    u += 0.06;
    if (kbhit() || C == ' ') if ((C = getch()) == 27) break;
  }

  _setvideomode( _DEFAULTMODE );
}
