/* JPI TopSpeed C demo: Drunken Maze.             HUR 27/10/89 */
/*                                                             */
/* COPYRIGHT (C) 1989 Jensen and Partners. All Rights Reserved */

#define _JPI_WIN_
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <choose.h>

#define loop  while (1)

#define WIDTH  150
#define HEIGHT 100

#pragma warn ( wait => off )

#pragma data ( seg_name => null )   /* put static data in DGROUP */

extern struct videoconfig cv;

unsigned Step, Width, Height, Color;
short    Free[WIDTH][HEIGHT];

static void Grid ()
{
  unsigned I;

  for ( I = 0; I <= Width; ++I )
  {
    _moveto ( I * Step , 0             );
    _lineto ( I * Step , Height * Step );
  }
  for ( I = 0; I <= Height; ++I )
  {
    _moveto ( 0            , I * Step );
    _lineto ( Width * Step , I * Step );
  }
}

static void Vertical ( int W, int H )
{
  _moveto ( W * Step ,  H    * Step+1 );
  _lineto ( W * Step , (H+1) * Step-1 );
}

static void Horizontal ( int W, int H )
{
  _moveto (  W    * Step+1 , H * Step );
  _lineto ( (W+1) * Step-1 , H * Step );
}


void maze_demo()
{
  int I,J,I0,J0,D,E,Ok;

  clrscr();
  cputs ( "    This program generates random mazes on the screen.\n" );
  cputs ( "    We then place a hapless drunk inside...\n\n" );
  cputs ( "    Press a key to start...<ESC> to stop\n" );
  if (getch() == 27) exit(0);

  Choose ();

  Color = cv.numcolors - 1;
  randomize ();
  loop
  {
    do
    {
      Step   = 7 + random ( cv.numypixels / 30 ) * random ( 10 );
      Width  = (cv.numxpixels-1) / Step;
      Height = (cv.numypixels-1) / Step;
    }
    while (Width > WIDTH || Height > HEIGHT);
    _setcolor ( Color );
    Grid ();
    _setcolor ( 0 );
    for ( I = 0; I < Width; ++I )
      for ( J = 0; J < Height; ++J )
        Free[I][J] = 1;
    I0 = 0;
    J0 = 0;
    E = 0;
    while ( ! kbhit() )
    {
      I = I0;
      J = J0;
      Free[I][J] = 0;
      do
      {
        if ( random ( 1 + Height / 8 ) == 0 ) E = random ( 4 );
        for ( D = E; D < E+4; ++D )
        {
          switch ( D & 3 )
          {
            case 0: if ( Ok = (I < Width-1 && Free[I+1][J]) )
                    {
                      ++I;
                      Vertical ( I, J );
                    }
                    break;
            case 1: if ( Ok = (I > 0 && Free[I-1][J]) )
                    {
                      Vertical ( I, J );
                      --I;
                    }
                    break;
            case 2: if ( Ok = (J < Height-1 && Free[I][J+1]) )
                    {
                      ++J;
                      Horizontal ( I, J );
                    }
                    break;
            case 3: if ( Ok = (J > 0 && Free[I][J-1]) )
                    {
                      Horizontal ( I, J );
                      --J;
                    }
                    break;
          }
          if ( Ok )
          {
            Free[I][J] = 0;
            break;
          }
        }
      }
      while ( Ok );
      while ( I0 < Width )
      {
        while ( J0 < Height && ! Free[I0][J0] )
          ++J0;
        if ( J0 < Height ) break;
        J0 = 0;
        ++I0;
      }
      if ( I0 == Width ) break;
      if ( J0 > 0 ) Horizontal ( I0, J0 );
      else          Vertical   ( I0, J0 );
    }
    I0 = (Width  / 2) * Step + Step / 2;
    J0 = (Height / 2) * Step + Step / 2;
    D = 0;
    E = 1 + random ( 1 + Step / 3 );
    while ( ! kbhit () )
    {
      _setcolor ( 1 );
      _setpixel ( I0, J0 );
      if ( random ( E ) == 0 ) D = random ( 4 );
      I = I0;
      J = J0;
      switch ( D )
      {
        case 0: --I; break;
        case 1: --J; break;
        case 2: ++I; break;
        case 3: ++J; break;
      }
      delay ( cv.numypixels / 200 );
      if (Color > 2) _setcolor ( 2 ); /* Paint in color... */
      else           _setcolor ( 0 ); /* ...but not in BW. */
      _setpixel ( I0, J0 );
      if ( _getpixel ( I, J ) != Color )
      {
        I0 = I;
        J0 = J;
      }
    }
    if ( getch () == 27 ) break;
    _clearscreen ( _GCLEARSCREEN );
  }
  _setvideomode( _DEFAULTMODE );
}
