/* Contained herein is the interface to a fairly simplistic vertical menu.
It should be noted that this is an demonstration file and has therefore been
written to show of features of the C++ language. It will be considered a
little OTT by C++ purists. */

/* Note also that a certain simplicity has been maintained to aid readability
and that this simplicity has resulted in some lack of efficiency in certain
areas */

#define ScreenWidth 80
#define ScreenDepth 25
#pragma link(menu)
#include <textwin.hpp>
#include <string.h>
typedef long menufunc();

/* One would usually derive MenuItem from a list class. However I am actually
going to build the list manupulator into the class to give it a bit of body */

class MenuItem
{   private:
    unsigned char Quick;
    char *heading;
    long Datum;
    menufunc *func;
    class MenuItem *next;
    MenuItem(unsigned char Q,char *name,long retval,menufunc *f);
    ~MenuItem();
    void operator+=(MenuItem &it);   // Add menuitem to end of list
    MenuItem &operator[](char x);
    char operator[](unsigned char x); // Find by Selected character
    char operator[](long D);  // This returns the number of the item matching D
                              // -ve if not found
    friend class Menu;
};

class Menu
{ private:
    MenuItem *head;
    char nitems;
    char maxlen;
    char x1,y1; // X-Y coords of top left corner. -1 ==> dynamically center
    Color back,fore,highback,highfore,selback,selfore,highselback,highselfore;
    void blank();
    void draw(char cpos);
    void outline(MenuItem &x,char Current);
  public:
    Menu()
    { blank();
    }
    Menu(char x,char y)
    { blank();
      x1=x;
      y1=y;
    }
    ~Menu();
    void additem(char * x); // Add item using position as datum
    void additem(char * x,menufunc *func); // Add item with procedure
    void additem(char * x,unsigned char c);
    void additem(char * x,menufunc *func,unsigned char c);
    long operator()(long starting); // Execute menu
};