/* Brief program to demonstrate the use of the precise_unsigned maths class.
This program will compute factorials up to 100 and raise 2 to powers up to
1024 with total precision. Higher numbers can be coped with in the large data
memory models */

/* PS A factorial means the product of the number and all smaller natural
numbers. Eg 6![Six factorial]=6*5*4*3*2*1=720.
      A power is a number times by itself that many times.
      Eg 2^6 (2 to the power 6) = 2*2*2*2*2*2 = 64
*/


#include <precise.hpp>

/* This is neat and works but is inefficient
precise_unsigned factorial(precise_unsigned &x)
{ if (x==1)
    return 1;
  else
    return x*factorial(x-1);
} */

precise_unsigned factorial(precise_unsigned &x)
{ precise_unsigned ac(1);
  for (precise_unsigned t=x; t>0; t-=1)
    ac*=t;
  return ac;
}

void main()
{ long x;
  cout << "Demonstration of Precise Unsigned Arithmetic\n" << flush;
  do
  { cout << "What number would you like a factorial for?(1-100)" << flush;
    cin >> x;
    cout << endl << flush;
    if (x<0)
      cout << "I need a positive number twit! Try again" << endl << flush;
    else
      break;
  } while (1);
  cout << factorial(x) << endl;
  do
  { cout << "To what power would you like two raised?(1-1024)" << flush;
    cin >> x;
    cout << endl << flush;
    if (x<0)
      cout << "I need a positive number twit! Try again" << endl << flush;
    else
      break;
  } while (1);
  precise_unsigned ac(1);
  for (int i=0;i<x;i++)
    ac+=ac;
  cout << ac << endl;
  cout << "This was just a brief demo of the power of the unsigned maths class" << endl;
  cout << "To find out more you should delve into the code";
}