#include <stdlib.h>
#include <mem.h>
#include <string.h>
#include "precise.hpp"

signed char digit::carry=0;

char precise_unsigned::compare(precise_unsigned const&y) const// -1 if host less 1 if host greater
{ if (bufuse!=y.bufuse)
    return bufuse>y.bufuse?1:-1;
  for (int i=bufuse-1;i>=0;i--)
  { char diff=char(buffer[i])-char(y.buffer[i]);
    if (diff)
      return diff;
  }
  return 0;
}

void precise_unsigned::copy(precise_unsigned &x)
{ buflen=x.buflen;
  bufuse=x.bufuse;
  if (buflen)
  { buffer=new digit[buflen];
#ifdef debug
  mem_out+=buflen;
#endif
  memcpy(buffer,x.buffer,bufuse);
  }
  else
    buffer=0;
}

void precise_unsigned::inc_space(unsigned need)
{ if (need<=buflen) return;
  unsigned x=need-buflen;
  if (x<10)
    x=10;
  digit *temp=new digit [buflen+x];
#ifdef debug
  mem_out+=buflen+x;
#endif
  if (buffer)
  { memcpy(temp,buffer,bufuse);
    delete [] buffer;
#ifdef debug
    mem_out-=buflen;
#endif
  };
  buffer=temp;
  buflen+=x;
}

precise_unsigned::precise_unsigned(long x)
{ char temp[18];
  char l,i;
  buflen=0;
  bufuse=0;
  buffer=0;
  ltoa(x,temp,10);
  inc_space(l=strlen(temp));
  bufuse=l;
  for (i=l;i;i--)
    buffer[i-1]=temp[l-i]-'0';  // Copy and reverse string
}

void precise_unsigned::operator+=(precise_unsigned &x)
{ unsigned accum=bufuse>=x.bufuse;
  unsigned joint=accum?x.bufuse:bufuse;
  unsigned maxneeded=accum?bufuse:x.bufuse;
  inc_space(maxneeded+1);
  digit::carry=0;
  for (unsigned i=0;i<joint;i++)
    buffer[i]+=x.buffer[i];
  digit *cont=(accum?buffer:x.buffer)+i;
  for (i=0;i<maxneeded-joint;i++)
    buffer[i+joint]=cont[i]+0;
  if (digit::carry)
  { buffer[maxneeded]=digit::carry;
    bufuse=maxneeded+1;
  }
  else
    bufuse=maxneeded;
}

//NB The operator assumes a +ve result
void precise_unsigned::operator-=(precise_unsigned &x)
{ digit::carry=0;
  for (unsigned i=0;i<x.bufuse;i++)
    buffer[i]-=x.buffer[i];
  for (;i<bufuse;i++)
    buffer[i]-=0;
  while (bufuse && !buffer[bufuse-1]) // Find leading zeroes and strip
    bufuse--;
}

void precise_unsigned::operator*=(precise_unsigned &x)
{ precise_unsigned ac(0);
  for (unsigned i=0;i<x.bufuse;i++)
  { precise_unsigned temp(*this);
    temp*=x.buffer[i];
    temp.pow10(i);
    ac+=temp;
  }
  *this=ac;
}

void precise_unsigned::operator*=(unsigned char x)
{ if (x==10)
  { this->pow10(1);
  }
  else if (x>10)
  { precise_unsigned temp(x);
    *this*=temp;
  }
  else
  { inc_space(bufuse+1);
    digit::carry=0;
    digit dval(x);
    for (unsigned i=0;i<bufuse;i++)
      buffer[i]*=dval;
    if (digit::carry)
    { buffer[bufuse]=digit(digit::carry);
      bufuse++;
    }
  }
}

ostream& operator<<(ostream &out,precise_unsigned &x)
{ char *temp=new char [x.bufuse+1];
#ifdef debug
  mem_out+=x.bufuse+1;
#endif
  if (!x.bufuse)
    out<<"0";
  else
  { for (unsigned i=0;i<x.bufuse;i++)
      temp[i]=char(x.buffer[x.bufuse-i-1])+'0';
    temp[x.bufuse]=0;
    out << temp;  // This way width is picked up from standard operators
  }
#ifdef debug
  mem_out-=x.bufuse+1;
#endif
  delete [] temp;
  return out;
}

precise_unsigned operator+(precise_unsigned &x,precise_unsigned &y)
{ precise_unsigned temp(x);
  temp+=y;
  return temp;
}
precise_unsigned operator-(precise_unsigned &x,precise_unsigned &y)
{ precise_unsigned temp(x);
  temp-=y;
  return temp;
}
precise_unsigned operator*(precise_unsigned &x,precise_unsigned &y)
{ precise_unsigned temp(x);
  temp*=y;
  return temp;
}
