{=========================================================
== JPI-TopSpeed ISO Pascal with Objects                 ==
== demo program:                                        ==
==                                                      ==
==   PasWin Demonstration: PasWin and PasProc           ==
==                                                      ==
=========================================================}
Program WinDemoP(OUTPUT);

(*%F _OS2*)
IMPORT PasWin,PasProc,PasDos;
(*%E*)
(*%T _OS2*)
IMPORT PasWin,PasProc,Kbd,PasDos,Vio;
(*%E*)

CONST
  Scroll=4;
  THE_COWS_COME_HOME=FALSE;

VAR
  IsBW : BOOLEAN ;
  WholeScreen:PasWin.PopUpWin;

TYPE KBFlagSet = BITSET;

(*%F _OS2*)
FUNCTION KBFlags : KBFlagSet ;
VAR R : PasDos.Registers;
BEGIN
   R.AH := 2 ;
   PasDos.Intr(16H,R);
   KBFlags := [R.AL] ;
END;
(*%E*)

(*%T _OS2*)
FUNCTION KBFlags : KBFlagSet ;
VAR
  ks : Kbd.KBDINFO;
  CurFlags: KBFlagSet;
BEGIN
  ks.b := SIZE(ks);
  IF Kbd.GetStatus(ks,0)=0 THEN
    CurFlags := ks.state;
  KBFlags:=CurFlags ;
END;
(*%E*)

PROCEDURE CheckScrollLock;
VAR
  kf : KBFlagSet;
BEGIN
  PasProc.Lock;
  WHILE (PasDos.Scroll IN PasDos.KBFlags) DO {nothing};
  PasProc.Unlock;
END;

PROCEDURE SetC ( cc,bwc : PasWin.Color ) ;
BEGIN
  IF IsBW THEN cc := bwc;
  PasWin.foreground(cc) ;
END;



PROCEDURE Intro ;
(* Display startup and demonstration description *)

TYPE W   = RECORD x,y : WORD END ;
     WW  = ARRAY[0..29] OF W ;
CONST
 wwDEF = WW( W(0,0)  ,W(5,0) ,W(10,0),W(15,0),W(20,0),
          W(10,2) ,W(10,4),W(10,6),W(10,8),W(10,10),
          W(5,10) ,W(0,10),W(35,4),W(35,2),W(35,0),
          W(40,0), W(45,0),W(50,2),W(50,4),W(45,6),
          W(40,6), W(35,6),W(35,8),W(35,10),W(65,0),
          W(65,2), W(65,4),W(65,6),W(65,8),W(65,10)
        ) ;

PROCEDURE IntroText ;
BEGIN
  SetC(PasWin.White,PasWin.LightGray);
  WRITELN;
  WRITE('       This is a demonstration of the ');
  SetC(PasWin.Yellow,PasWin.White);    WRITE('PasWin') ;
  SetC(PasWin.White,PasWin.LightGray); WRITE(' and ') ;
  SetC(PasWin.Yellow,PasWin.White) ;   WRITE('PasProc') ;
  SetC(PasWin.White,PasWin.LightGray); WRITE(' Modules') ;
  WRITELN ;
  WRITELN ;
  SetC(PasWin.LightGray,PasWin.LightGray);
  WRITE('           5 time-sliced processes are created, which output to');WRITELN;
  WRITE('           and move 4 windows');WRITELN;
  WRITELN ;
  SetC(PasWin.White,PasWin.White);
  WRITE('     Press any key to start, Esc to finish and ScrollLock to freeze ');
END;

VAR
   DescWin: PasWin.PopUpWin ;
   title   : ARRAY[0..39] OF CHAR ;
   Win     : ARRAY[0..29] OF PasWin.PopUpWin ;
   i,j,wn  : INT16 ;
   num     : ARRAY[0..6] OF CHAR ;
   b,up    : BOOLEAN ;
   delay,X1,Y1: WORD ;
   exit,
   change  : BOOLEAN ;
   FrameBack,FrameFore,BackGround,ForeGround:PasWin.Color;
   direction : boolean;
CONST
   targetX = 32 ;
   targetY = 5 ;
  procedure showall;
    var I:integer;
  begin
    for i:=0 to 29 do
      if win[i].hidden then
        win[i].popup;
  end;
  procedure hideall;
    var i:integer;
  begin
    for i:=29 downto 0 do
      if not win[i].hidden then
        win[i].hide;
  end;
BEGIN
  PasWin.CursorOff;
  FOR i := 0 TO 29 DO BEGIN
    IF i<30 THEN BEGIN
      IF IsBW THEN
        IF ODD(i) THEN BEGIN
          Background := PasWin.Black ;
          Foreground := PasWin.White ;
        END
        ELSE BEGIN
          Background := PasWin.LightGray ;
          Foreground := PasWin.Black ;
        END
      ELSE BEGIN
        Background := (i MOD 8):>PasWin.Color;
        Foreground := (15-i MOD 8):>PasWin.Color;
      END ;
      X1 := wwdef[i].x ; Y1 := wwdef[i].y ;
    END ;
    IF NOT IsBW AND (Background=PasWin.Black) THEN
      FrameBack  := PasWin.Green
    ELSE
      FrameBack  := Background ;
    (* PasWin.Color(ORD(Foreground)MOD 8) *) ;
    IF FrameBack=PasWin.LightGray THEN FrameFore  := PasWin.Black
    ELSE FrameFore  := PasWin.LightGray ;
    Win[i].Open(X1+1,Y1+1,8,2,Foreground,BackGround) ;
    Win[i].FrameDraw(PasWin.SingleFrame,FrameFore,FrameBack,FALSE);
    WRITE('TopSpeed');
    WRITE(' Pascal');
  END ;
  DescWin.Open(0,15,75,9,PasWin.White,PasWin.Black);
  DescWin.FrameWrite(' JPI TopSpeed Pascal : PasWin Demonstration ',true,5,PasWin.Blue,PasWin.LightGray);
  IntroText ;
  delay := 1000 ;
  i := 29;
  direction:=false;
  WHILE NOT PasDos.KeyPressed DO BEGIN
    CheckScrollLock ;
    IF delay>100 THEN delay:=delay-20
    ELSE IF delay>1 THEN delay:=delay-1;
    PasDos.Delay(delay) ;
    IF direction THEN
      Win[i].PopUp
    ELSE
      Win[i].hide;
    if direction then
      i:=i+1
    else
      i:=i-1 ;
    if i<0 then begin
      i:=0;
      direction:=not direction
    end;
    if i>29 then begin
      i:=29;
      direction:=not direction
    end;
  END;
  FOR i := 29 DOWNTO 0 DO BEGIN
    PasDos.Delay(10) ;
    Win[i].Close;
  END ;
  IF PasDos.RdKey=CHR(27) THEN HALT;
END;

(* Actual demo starts here *)
(* ----------------------- *)

VAR
    W1,W2,W3,W4     : PasWin.PopUpWin;
    DS              : PasProc.SIGNAL ;
    Initialize      : BOOLEAN ;

(* PasProces *)


(* P1 prints out numbers in Hex, Dec and Binary *)

  PROCEDURE P1;
  VAR S : CONVSTRING;
      i : WORD;
      b : BOOLEAN ;
  BEGIN
    W1.MakeFocus;
    REPEAT
      FOR i := 0 TO 1000 DO BEGIN
        IntToStr(i,S,2,b); WRITE(S:16);
        WRITE('   ') ;
        IntToStr(i,S,16,b); WRITELN(S:5);
        CheckScrollLock;
      END;
    UNTIL THE_COWS_COME_HOME
  END;

(* P2 displays out a sideways barchart *)

  PROCEDURE P2;
  VAR i,j : WORD;
      V : ARRAY[1..9] OF WORD ;

    PROCEDURE DrawBar ( x,y : WORD ; val : WORD ; on : BOOLEAN ) ;
    BEGIN
      IF ODD(y) THEN
        IF IsBW THEN PasWin.foreground(PasWin.White)
                ELSE PasWin.foreground(PasWin.Red)
      ELSE
        PasWin.foreground(PasWin.LightGray) ;
      IF val>0 THEN BEGIN
        val:=val-1 ;
        PasWin.GotoXY(x+val DIV 2,y) ;
        IF on THEN
          IF ODD(val) THEN WRITE('') ELSE WRITE('')
        ELSE
          IF ODD(val) THEN WRITE('') ELSE WRITE(' ')
      END
    END;

  BEGIN
    W2.MakeFocus;
    i := 0 ;
    FOR i := 1 TO 9 DO BEGIN
      V[i] := RANDOM(50) ;
      FOR j := 0 TO V[i] DO
        DrawBar(1,i,j,TRUE) ;
    END ;
    REPEAT
      FOR i := 1 TO 9 DO BEGIN
        IF i<W2.RIGHT-W2.LEFT-2 THEN
          IF RANDOM(2)=0 THEN BEGIN
            IF V[i]<50 THEN BEGIN V[i]:=V[I]+1 ; DrawBar(1,i,V[i],TRUE) END
          END
          ELSE
            IF V[i]>0 THEN BEGIN DrawBar(1,i,V[i],FALSE) ; V[i]:=V[I]-1 END;
        CheckScrollLock
      END
    UNTIL THE_COWS_COME_HOME
  END;

(* P3 displays a character grid with randomly changing pallette colours *)

  PROCEDURE P3;
  VAR
      X,Y,D : WORD;
      CH : CHAR;
  BEGIN
    CH := '*' ;
    D := 0 ;
    W3.MakeFocus;
    REPEAT
      FOR X := 1 TO 8 DO
        FOR Y := 1 TO 8 DO BEGIN
          PasWin.GotoXY(X,Y);
          PasWin.ForeGround(((Y+D) MOD 8):>PasWin.Color);
          PasWin.BackGround(((X+D) MOD 8):>PasWin.Color);
          WRITE(CH);
          PasWin.GotoXY(1,10);
          WRITE(x:2,',',Y:2);
          CheckScrollLock ;
        END;
      D:=D+1 ;
    UNTIL THE_COWS_COME_HOME
  END;

(* P4 displays some text *)

  PROCEDURE P4;
  VAR i : WORD ;
  BEGIN
    W4.MakeFocus ;
    REPEAT
      WRITE('This is a test of 5 time-sliced processes,');
      WRITE(' and also of PasWin writing, moving, rearranging.');
      W4.Fore:= PasWin.White ;
      IF IsBW THEN
        W4.Back:= PasWin.Black ;
      WRITE(' Press any key to terminate, ScrollLock to freeze.  ');
      W4.Fore:= PasWin.Black ;
      IF IsBW THEN
        W4.Back:= PasWin.LightGray;
      PasProc.Delay(1);
      CheckScrollLock ;
    UNTIL PasDos.KeyPressed;
    PasProc.SEND(DS);
    PasProc.StopScheduler ;
    PasProc.Delay(10000);
  END ;

PROCEDURE Demo ;
VAR
   k : CHAR;
   ForeGround,BackGround:PasWin.Color;
BEGIN
   RANDOMIZE ;
   Initialize := TRUE ;
   PasWin.CursorOff ;
   PasWin.Clear(PasWin.Clear_Screen);
   Foreground := PasWin.White ;
   IF IsBW THEN
     Background := PasWin.Black
   ELSE
   Background := PasWin.Red ;
    W1.Open(1,2,35,6,ForeGround,BackGround);
      Foreground := PasWin.White ;
      Background := PasWin.Blue ;
      IF IsBW THEN BEGIN
         Background := PasWin.Black ;
      END ;
    W2.Open(50,2,30,10,ForeGround,BackGround) ;
      ForeGround:= PasWin.Yellow ;
      BackGround:= PasWin.Black ;
      IF IsBW THEN begin
         ForeGround:= PasWin.LightGray ;
         BackGround:= PasWin.Black ;
      END ;
    W3.Open(40,5,10,11,ForeGround,BackGround);
      Foreground := PasWin.Black ;
      Background := PasWin.LightGray ;
    W4.Open(15,15,60,8,Foreground,BackGround) ;
    PasProc.StartScheduler ;
    PasProc.Init(DS) ;
    PasProc.StartProcess(P1,2000,1) ;
    PasProc.StartProcess(P2,2000,1) ;
    PasProc.StartProcess(P3,2000,1) ;
    PasProc.StartProcess(P4,2000,1) ;
    PasProc.WAIT(DS) ;
    PasProc.StopScheduler ;
    PasWin.CursorOn ;
    WHILE PasDos.KeyPressed DO k := PasDos.RdKey;
END;

(*%F _OS2*)
PROCEDURE CheckBW ;
VAR
  R : PasDos.Registers ;
BEGIN
     R.AH := 15 ;
     PasDos.Intr(10H,R) ;
     IsBW :=  (R.AL = 0)OR(R.AL = 2)OR(R.AL = 5)OR(R.AL = 6)OR(R.AL = 7) ;
END;
(*%E*)

(*%T _OS2*)
PROCEDURE CheckBW;
VAR
  mode    : Vio.MODEINFO;
  r       : WORD;
TYPE
  sb = SET OF 0..7;
BEGIN
   mode.b := SIZE(mode);
   r := Vio.GetMode(mode,0);
   IsBW := (NOT (0 IN (mode.ttype:>sb)))OR(mode.color<=2)OR(2 IN (mode.ttype:>sb)) ;
END ;
(*%E*)


BEGIN
  WholeScreen.Open(1,1,78,23,PasWin.White,PasWin.Black);
  WholeScreen.FrameDraw(PasWin.DOUBLEFRAME,PasWin.Black,PasWin.Black,FALSE);
  WholeScreen.MakeFocus;
  CheckBW ;
  Intro;
  WholeScreen.MakeFocus;
  Demo;
END.
