#ifndef findex_Windows
#define findex_Windows
#ifndef pascal_type
#define pascal_type
typedef unsigned char boolean;
#define true 1
#define false 0
typedef unsigned char byte;
typedef unsigned int word;
#endif
#pragma link(winkey)

extern byte norm_screen,invert_screen,exclaim_screen;
/* Header files for all screen, keyboard and Window management */

class Window {
  public:
    int     top_left_row,top_left_col,width,height,cu_row,cu_col;
    boolean boxed;
    byte    attr;
    Window  *next;
    unsigned *under;
    boolean showing;
  public:
    Window(byte a,int y,int x=0,int w=80,int h=1,boolean box=false);
    Window(byte a,int y,int x,int w,int h,Window& w);
    ~Window();
    void clear();
    void change_attr(byte a) {attr=a;}
    void print_word(char *word);
    void resize(int y,int x=0,int w=80,int h=1,char b=2); // 2=> no change
    void cursor();
    void cursor_follow(boolean on=true);
    void move_cursor(int y,int x)
    { cu_row+=y;
      cu_col+=x;
      cursor();
    }
    void cursor(int y,int x)
    { cu_row=y;
      cu_col=x;
      cursor();
    }
    void scroll(int amount);
    void newline();
    byte pop_up();
    void pop_down();
    friend class whole_screen;
};

class whole_screen {
private:
  Window my_Window;
  Window **tail;	//Place to add new Windows
public:
  whole_screen(byte attr,int x,int y,int wid,int hei)
               : my_Window(attr,y,x,wid,hei)
    { tail=&my_Window.next; }
  void add_Window(Window &w);
  void display();
};

class key_handler {
private:
  struct key_record
  { int length;
    int text[10];
  } quick[10],current;
  boolean recording;
  byte buffer_pos;
  byte recording_into;
  char *file_name;
  Window *info_win;
public:
  key_handler();
  key_handler(char *s);
  void view_macros(Window &text_win);
  int get_key();
  void macro_def(unsigned Fn);
  void save_macros();
  char edit_string(Window &within,char *buffer, int max_len); // 0 if escaped
};

#define filenamelength 64
extern void display_message(char *message_string);
extern void display_info(const char *message_string);
extern char display_query(char *message_string);
extern char get_filename(key_handler &key,char *prompt,char *name,char *ext,boolean exists); // 1 if successful
enum curstate {turn_on,turn_off,release};
extern void cursorstate(curstate show);

#endif
