/* A simple program to list the comdef records in a Microsoft object/library file */
/* They are output as 'C' declarations which can be compiled (using TopSpeed C)
   and linked in to resolve unresolveds which will otherwise occur.
   All variables are assumed to be arrays of char, this could cause
   type-safe linking warnings to be generated if the variables are referenced
   from a TopSpeed C object file. To fix this the declarations should be edited
   as appropriate. Also there may be duplicate declarations - these should be
   deleted.
*/

#include <stdio.h>
#pragma warn( wall => on )

long microfunny( FILE * f, int * Len ){
  int len = *Len;
  long res;
  int b;

  b = getc(f); len--;
  switch (b) {
    case 0x81: {
      res = getc(f); len--;
      res = res + 256L * (long) getc(f); len--;
      break;
    }
    case 0x84: {
      res = getc(f); len--;
      res = res + 256L * (long) getc(f); len--;
      res = res + 256L * 256L * (long) getc(f); len--;
      break;
    }
    case 0x88: {
      res = getc(f); len--;
      res = res + 256L * (long) getc(f); len--;
      res = res + (256L * 256L) * (long) getc(f); len--;
      res = res + (256L * 256L * 256L) * (long) getc(f); len--;
      break;
    }
    default: {
      res = b;
      break;
    }
  }
  *Len = len;
  return res;
}

int main( int argc, char * argv[] ){
  FILE * f;
  int typ,len;

  if (argc != 2) {
    printf("Try again: xcomdef <object file>");
    return 1;
  }
  /*printf( "Reading %s\n", argv[1] );*/

  f = fopen( argv[1], "rb" );

  puts("#pragma name( prefix=>\"\" )\n" );

  while( ( typ = getc(f) ) != -1 ) {
    if ( typ != 0 ) {
      len = getc(f);
      len = len + 256*getc(f);

      /*printf("typ=%x len=%x\n",typ,len);*/
      switch ( typ ) {
#if 0
        case 0x90 : {
          int slen, i, gi, si;
          char name[256];

          while (len > 1){
            gi = getc(f); len--;
            si = getc(f); len--;

            slen = getc(f); len--;
            for (i=0;i<slen;i++){
              name[i] = getc(f); len--;
            }
            name[i] = 0;
            getc(f); len--; /* offset */
            getc(f); len--;
            getc(f); len--; /* type index */
            printf("public %s \n", name );
          }
        }
#endif

        case 0xB0 : {
          int slen, i, segtype;
          long varlen;
          char name[256];

          while (len > 1){
            slen = getc(f); len--;
            for (i=0;i<slen;i++){
              name[i] = getc(f); len--;
            }
            name[i] = 0;
            getc(f); len--; /* type index */
            segtype = getc(f); len--;
            varlen = microfunny( f, &len );
            if (segtype==0x61) {
              /* far variable */
              varlen *= microfunny( f, &len );
            }
            if (segtype==0x61) {
              printf("char far %s [%ld]; \n", name, varlen );
            } else {
              printf("char %s [%ld]; \n", name, varlen );
            }
          }
          break;
        }
      }
      while (len--) {
        getc(f);
      }
    }
  }
  return 0;
}