/* Release 3.00 */

/*-------------------------------------------------------------------------*
*                                                                          *
*  alloc.h -  header file for memory allocation functions.                 *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _ALLOC_INC_
#define _ALLOC_INC_

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

#ifndef NULL
#ifndef _fptr
#define NULL   0
#else
#define NULL   0L
#endif
#endif

struct _heapinfo  {
    int *  _pentry;
    size_t _size;
    int    _useflag;
};

#ifndef __STDC__
struct _fheapinfo  {
    int far * _pentry;
    size_t    _size;
    int       _useflag;
};

struct _nheapinfo  {
    int near * _pentry;
    size_t     _size;
    int        _useflag;
};
#endif

#define _HEAPOK 	     0
#define _HEAPEMPTY 	    -1
#define _HEAPBADBEGIN       -2
#define _HEAPBADNODE        -3
#define _HEAPOVERFLOW       -4
#define _HEAPEND	    -5
#define _HEAPBADPTR         -6

#ifdef __cplusplus
extern "C" {
#endif

void *         calloc(size_t _num, size_t _size);
void	       free(void *_block);
void *         malloc(size_t _size);
void *         realloc(void *_block, size_t _size);
size_t         stackavail(void);

#pragma save
#pragma call(reg_saved=>(di,si,ds,st1,st2), reg_param=>(ax))
void *         alloca(size_t size);
#pragma restore
char *         sbrk(int incr);

#ifndef __STDC__
void far *     _fcalloc(size_t num, size_t _size);
void           _ffree(void far *_block);
void far *     _fmalloc(size_t _size);
void far *     _frealloc(void far *_block, size_t _size);

void near *    _ncalloc(size_t num, size_t _size);
void           _nfree(void near *_block);
void near *    _nmalloc(size_t _size);
void near *    _nrealloc(void near *_block, size_t _size);

#ifndef _WINDOWS
void           hfree(void huge *_block);
void huge *    halloc(unsigned long _size);
void huge *    hrealloc(void huge *_block, unsigned long _size);
#endif
#endif

#ifndef _WINDOWS
int            _msize(void *_buffer);
size_t         _memmax(void);
size_t         _memavl(void);
int            _heapchk(void);
int            _heapset(int _fill);
int            _heapwalk(struct _heapinfo *_entry);
void *         _expand(void *buffer, size_t _size);
unsigned       _freect(size_t _size);

#ifndef _fptr
unsigned       coreleft(void);
#else
unsigned long  coreleft(void);
#endif

/* Beware, these are declared as TurboC but really return huge pointers */
void far *     farmalloc(unsigned long num);
void far *     farcalloc(unsigned long num, unsigned long size);
void far *     farrealloc(void far *block, unsigned long num);
void           farfree(void far *block);

#ifndef __STDC__
int            _nheapchk(void);
int            _nheapset(int _fill);
int            _nheapwalk(struct _nheapinfo *_nearentry);
void near *    _nexpand(void near *buffer, size_t _size);
int            _fmsize(void far *_buffer);
int            _nmsize(void near *_buffer);

int            _fheapchk(void);
int            _fheapset(int _fill);
int            _fheapwalk(struct _fheapinfo *_farentry);
void far *     _fexpand(void far *buffer, size_t _size);
unsigned       nearcoreleft(void);
unsigned long  farcoreleft(void);
#endif
#endif

#ifdef __cplusplus
}
#endif

#endif