/* Release 3.00 */

/*-------------------------------------------------------------------------*
*                                                                          *
*  conio.h -  header file for console input and output.                    *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _CONIO_INC_
#define _CONIO_INC_


#ifdef _CLIP_WIN_

#pragma project("#set cwindow='borland'")

struct text_info {
    unsigned char winleft;
    unsigned char wintop;
    unsigned char winright;
    unsigned char winbottom;
    unsigned char attribute;
    unsigned char normattr;
    unsigned char currmode;
    unsigned char screenheight;
    unsigned char screenwidth;
    unsigned char curx;
    unsigned char cury;
};

enum text_modes { LASTMODE=-1, BW40=0, C40, BW80, C80, MONO=7, FONT8x8=256};

#ifndef _BGI_COLORS
#define _BGI_COLORS

enum COLORS {
    BLACK,		    /* dark colors */
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,		    /* light colors */
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};

#endif

#define BLINK           128     /* blink bit */

#ifndef _WINDOWS
#ifdef __cplusplus
extern "C" {
#endif
extern  unsigned char directvideo;
extern  int _wscroll;
void    clreol(void);
void    clrscr(void);
void    delline(void);
int     gettext(int _left, int _top, int _right, int _bottom, void *_destin);
void    gettextinfo(struct text_info *_r);
void    gotoxy(int _x, int _y);
void    highvideo(void);
void    insline(void);
void    lowvideo(void);
int     movetext(int _left, int _top, int _right, int _bottom,
                            int _destleft, int _desttop);
void    normvideo(void);
int     puttext(int _left, int _top, int _right, int _bottom,
                           const void *_source);
void    textattr(int _newattr);
void    textbackground(int _newcolor);
void    textcolor(int _newcolor);
void    textmode(int _newmode);
int     wherex(void);
int     wherey(void);
void    window(int _left, int _top, int _right, int _bottom);
#ifdef __cplusplus
}
#endif
#endif
#endif

#ifdef _JPI_WIN_
#include <window.h>
#endif

#ifndef _WINDOWS
#ifdef __cplusplus
extern "C" {
#endif
char *  cgets(char *_str);
void	cputs(const char *_str);
int	cprintf(const char *_format, ...);
int	cscanf(const char *_format, ...);
int	getch(void);
int	getche(void);
int	kbhit(void);
int	putch(int _ch);
int	ungetch(unsigned _ch);
#ifdef __cplusplus
}
#endif
#endif

#ifndef _PORTIO_DEF
#define _PORTIO_DEF
#if (defined _IL_MTF) | ( defined __STDC__)

#ifdef __cplusplus
extern "C" {
#endif
unsigned char inportb(int _portid);
void          outportb(int _portid, unsigned char _value);
unsigned int  inportw(int _portid);
void          outportw(int _portid, unsigned int _value);
void          geninterrupt(int _interruptnum);
void          _disable(void);
void          _enable(void);
#ifdef __cplusplus
}
#endif

#define inp(portid)       inportb(portid)
#define outp(portid, v)   outportb(portid, v)
#define inpw(portid)      inportw(portid)
#define outpw(portid, v)  outportw(portid, v)
#else
#pragma save

#ifndef _fcall
#define RET 0xC3
#else
#define RET 0xCB
#endif


#pragma call(reg_param=>(dx,ax),reg_saved=>(bx,cx,si,di,es,ds,st1,st2), inline=>on)
static void __outportb__(int _port, unsigned char _byte) =
{
   0xEE, RET         /* out dx,al */
};

static unsigned char __inportb__(int _port) =
{
   0xEC, RET         /* in  dx,al */
};

static void __outportw__(int _port, unsigned _word) =
{
   0xEF, RET         /* out dx,ax */
};

static unsigned int __inportw__(int _port) =
{
   0xED, RET         /* in  dx,ax */
};

static void _enable(void)=
{
   0xFB, RET
};

static void _disable(void)=
{
   0xFA, RET
};

#pragma restore

#define inportb(portid)     __inportb__(portid)     /* Byte IN instruction */
#define outportb(portid, v) __outportb__(portid,v)  /* Byte OUT instruction */
#define inportw(portid)     __inportw__(portid)     /* Word IN instruction */
#define outportw(portid, v) __outportw__(portid,v)  /* Word OUT instruction */

/* some compilers use inp, outp for inportb, outportb */

#define inp(portid)       __inportb__(portid)
#define outp(portid, v)   __outportb__(portid, v)
#define inpw(portid)      __inportw__(portid)
#define outpw(portid, v)  __outportw__(portid, v)
#endif
#endif

#endif
