/* Release 3.00 */

/*-------------------------------------------------------------------------*
*                                                                          *
*  dos.h -  structure, union, macro and function definitions for MSDOS and *
*  Intel IAPX86 family.                                                    *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/
#ifndef _DOS_INC_
#define _DOS_INC_

#ifndef __STDC__
#ifdef __cplusplus
extern "C" {
#endif
extern	char *           _env_var[64];
#define environ          _env_var
extern	unsigned int	 _osmajor;
extern	unsigned int	 _osminor;
extern  unsigned         _psp;
extern  unsigned int     _stklen;
extern  int              _argc;
extern  char            *_argv[32];
#ifdef __cplusplus
}
#endif
#endif

#define FA_NORMAL	0x00		/* normal file */
#define FA_RDONLY	0x01		/* Read only attribute */
#define FA_HIDDEN	0x02		/* Hidden file */
#define FA_SYSTEM	0x04		/* System file */
#define FA_LABEL	0x08		/* Volume label */
#define FA_DIREC	0x10		/* Directory */
#define FA_ARCH 	0x20		/* Archive */


struct WORDREGS {
    unsigned int ax, bx, cx, dx, si, di, cflag, flags;
};

struct BYTEREGS {
    unsigned char al, ah, bl, bh, cl, ch, dl, dh;
};

union  REGS {
   struct WORDREGS x;
   struct BYTEREGS h;
};

struct SREGS {
    unsigned int es;
    unsigned int cs;
    unsigned int ss;
    unsigned int ds;
};

struct REGPACK {
    unsigned  r_ax, r_bx, r_cx, r_dx;
    unsigned  r_bp, r_si, r_di, r_ds, r_es, r_flags;
};

struct find_t {
    char reserved[21];
    char attrib;
    unsigned wr_time;
    unsigned wr_date;
    long size;
    char name[13];
};

struct	country {
	int	co_date;
	char	co_curr[5];
	char	co_thsep[2];
	char	co_desep[2];
	char	co_dtsep[2];
	char	co_tmsep[2];
	char	co_currstyle;
	char	co_digits;
	char	co_time;
	long	co_case;
	char	co_dasep[2];
	char	co_fill[10];
};


struct dosdate_t {
    unsigned char day;          /* 1-31 */
    unsigned char month;        /* 1-12 */
    unsigned int year;          /* 1980-2099 */
    unsigned char dayofweek;    /* 0-6, 0=Sunday */
};

struct dostime_t {
    unsigned char hour;     /* 0-23 */
    unsigned char minute;   /* 0-59 */
    unsigned char second;   /* 0-59 */
    unsigned char hsecond;  /* 0-99 */
};

struct diskfree_t {
    unsigned total_clusters;
    unsigned avail_clusters;
    unsigned sectors_per_cluster;
    unsigned bytes_per_sector;
};

#define _HARDERR_IGNORE     0   /* Ignore the error */
#define _HARDERR_RETRY      1   /* Retry the operation */
#define _HARDERR_ABORT      2   /* Abort program issuing Interrupt 23h */
#define _HARDERR_FAIL       3   /* Fail the system call in progress */

#define _A_NORMAL       0x00    /* Normal file - No read/write restrictions */
#define _A_RDONLY       0x01    /* Read only file */
#define _A_HIDDEN       0x02    /* Hidden file */
#define _A_SYSTEM       0x04    /* System file */
#define _A_VOLID        0x08    /* Volume ID file */
#define _A_SUBDIR       0x10    /* Subdirectory */
#define _A_ARCH         0x20    /* Archive file */


#define FP_SEG(fp) ((unsigned)(((unsigned long)(fp))>>16))
#define FP_OFF(fp) ((unsigned)(fp))


#ifdef __cplusplus
extern "C" {
#endif
int     bdos(int _dosfunc, unsigned int _dosdx, unsigned int _dosal);
int     bdosptr(int _dosfunc, void * _dsdx, unsigned int _dosal);
int     int86(int _intno, const union REGS * _inregs, union REGS * _outregs);
int     int86x(int _intno, const union REGS * _inregs, union REGS * _outregs,
	                                         struct SREGS * _segregs);
int     intdos(const union REGS * _inregs, union REGS * _outregs);
int     intdosx(const union REGS * _inregs, union REGS * _outregs,
                                      struct SREGS * _segregs);
#ifndef _WINDOWS
unsigned  _dos_allocmem(unsigned _size, unsigned * _seg);
#endif
unsigned  _dos_close(int _handle);
unsigned  _dos_creat(const char * _path, unsigned _attrib, int * _handle);
unsigned  _dos_creatnew(const char * _path, unsigned _attrib, int * _handle);
unsigned  _dos_findfirst(const char * _path, unsigned _attrib, struct find_t * _buffer);
unsigned  _dos_findnext(struct find_t * _buffer);
#ifndef _WINDOWS
unsigned  _dos_freemem(unsigned _seg);
#endif
void      _dos_getdate(struct dosdate_t * _buffer);
void      _dos_getdrive(unsigned * _drive);
unsigned  _dos_getdiskfree(unsigned _drive, struct diskfree_t * _buffer);
unsigned  _dos_getfileattr(const char * _path, unsigned * _attr);
unsigned  _dos_getftime(int _handle, unsigned * _date, unsigned * _time);
void      _dos_gettime(struct dostime_t * _buffer);
#ifndef _WINDOWS
void      _dos_keep(unsigned _retcode, unsigned _paras);
#endif
unsigned  _dos_open(const char * _path, unsigned _mode, int * _handle);
unsigned  _dos_setblock(unsigned _size, unsigned _seg, unsigned * _maxsize);
unsigned  _dos_setdate(const struct dosdate_t * _buffer);
void      _dos_setdrive(unsigned _drive, unsigned * _maxdrives);
unsigned  _dos_setfileattr(const char * _path, unsigned _attr);
unsigned  _dos_setftime(int _handle, unsigned _date, unsigned _time);
unsigned  _dos_settime(const struct dostime_t * _buffer);
#ifdef __cplusplus
}
#endif

#ifndef _FFBLK_DEF
#define _FFBLK_DEF

struct ffblk {
    char ff_reserved[21];
    char ff_attrib;
    int  ff_ftime;
    int  ff_fdate;
    long ff_fsize;
    char ff_name[13];
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
int       findfirst(const char * _path, struct ffblk * _buffer, int _attrib);
int       findnext(struct ffblk * _buffer);
#ifdef __cplusplus
}
#endif

#ifndef __STDC__
#define MK_FP(seg,off) ((void far *) (char <(seg)> *)(off))

#ifdef __cplusplus
extern "C" {
#endif

void (interrupt far * _dos_getvect(unsigned _intnum))();
unsigned              _dos_read(int _handle, void far * _buffer,
                                unsigned _num, unsigned * _numread);
unsigned              _dos_write(int _handle, const void far * _buffer,
                                unsigned _num, unsigned * _numwrit);

#ifndef _WINDOWS
void    _chain_intr(void ( interrupt far * _handler)());
void    _dos_setvect(unsigned _intnum , void ( interrupt far * _handler)());
void    _harderr(void (far * _handler)());
void    _hardresume(int _code);
void    _hardretn(int _code);
void    harderr(void (far * _handler)());
void    hardresume(int _code);
void    hardretn(int _code);
#endif
#ifdef __cplusplus
}
#endif
#endif


#ifdef __cplusplus
struct doserror {
    int exterror;
    unsigned char _class;
    unsigned char action;
    unsigned char locus;
};
#else
struct doserror {
    int exterror;
    unsigned char class;
    unsigned char action;
    unsigned char locus;
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
int           dosexterr(struct doserror * _errbuf);
void          segread(struct SREGS * _segbuf);
#ifdef __cplusplus
}
#endif

#ifdef _PTM
#define poke(a,b,c)  (*((int  far *)MK_FP((a),(b))) = (int)(c))
#define pokeb(a,b,c) (*((char far *)MK_FP((a),(b))) = (char)(c))
#define peek(a,b)    (*((int  far *)MK_FP((a),(b))))
#define peekb(a,b)   (*((char far *)MK_FP((a),(b))))
#else
int     peek(unsigned _segment, unsigned _offset);
char    peekb(unsigned _segment, unsigned _offset);
void    poke(unsigned _segment, unsigned _offset, int _value);
void    pokeb(unsigned _segment, unsigned _offset, char _value);
#endif

#define geninterrupt __genint__

#ifndef _PORTIO_DEF
#define _PORTIO_DEF

#if (defined _IL_MTF) | ( defined __STDC__)

#ifdef __cplusplus
extern "C" {
#endif
unsigned char  inportb(int _portid);
void           outportb(int _portid, unsigned char _value);
unsigned int   inportw(int _portid);
void           outportw(int _portid, unsigned int _value);
void           _disable(void);
void           _enable(void);
#ifdef __cplusplus
}
#endif

#define inp(portid)      inportb(portid)
#define outp(portid, v)  outportb(portid, v)
#define inpw(portid)      inportw(portid)
#define outpw(portid, v)  outportw(portid, v)
#define enable() _enable()
#define disable() _disable()
#else
#pragma save

#ifndef _fcall
#define RET 0xC3
#else
#define RET 0xCB
#endif


#pragma call(reg_param=>(dx,ax),reg_saved=>(bx,cx,si,di,es,ds,st1,st2), inline=>on)
static void __outportb__(int _port, unsigned char _byte) =
{
   0xEE, RET         /* out dx,al */
};

static unsigned char __inportb__(int _port) =
{
   0xEC, RET         /* in  dx,al */
};

static void __outportw__(int _port,int unsigned _word) =
{
   0xEF, RET         /* out dx,ax */
};

static unsigned int __inportw__(int _port) =
{
   0xED, RET         /* in  dx,ax */
};

static void _enable(void)=
{
   0xFB, RET
};

static void _disable(void)=
{
   0xFA, RET
};

#pragma restore

#define inportb(portid) __inportb__(portid)       /* Byte IN instruction */
#define outportb(portid, v) __outportb__(portid,v)/* Byte OUT instruction */
#define inportw(portid) __inportw__(portid)       /* Word IN instruction */
#define outportw(portid, v) __outportw__(portid,v)/* Word OUT instruction */

/* some compilers use inp, outp for inportb, outportb */

#define inp(portid)      __inportb__(portid)
#define outp(portid, v)  __outportb__(portid, v)
#define inpw(portid)      __inportw__(portid)
#define outpw(portid, v)  __outportw__(portid, v)
#endif
#endif

#define NFDS	20			/* Maximum number of fds */

struct	fcb	{
	char	fcb_drive;		/* 0 = default, 1 = A, 2 = B */
	char	fcb_name[8];		/* File name */
	char	fcb_ext[3];		/* File extension */
	short	fcb_curblk;		/* Current block number */
	short	fcb_recsize;		/* Logical record size in bytes */
	long	fcb_filsize;		/* File size in bytes */
	short	fcb_date;		/* Date file was last written */
	char	fcb_resv[10];		/* Reserved for DOS */
	char	fcb_currec;		/* Current record in block */
	long	fcb_random;		/* Random record number */
};

struct	xfcb	{
	char		xfcb_flag;	/* Contains 0xff to indicate xfcb */
	char		xfcb_resv[5];	/* Reserved for DOS */
	char		xfcb_attr;	/* Search attribute */
	struct	fcb	xfcb_fcb;	/* The standard fcb */
};

struct	dfree	{
	unsigned df_avail;
	unsigned df_total;
	unsigned df_bsec;
	unsigned df_sclus;
};

struct	fatinfo {
	char	fi_sclus;
	char	fi_fatid;
	int	fi_nclus;
	int	fi_bysec;
};

struct	devhdr	{
	long		dh_next;	/* Next device pointer */
	short		dh_attr;	/* Attributes */
	unsigned short	dh_strat;	/* Driver strategy routine */
	unsigned short	dh_inter;	/* Driver interrupt routine */
	char		dh_name[8];	/* Device name */
};

#ifndef _TMT_DEF
#define _TMT_DEF
struct date {
    int da_year;
    unsigned char da_day;
    unsigned char da_mon;
};

struct time {
    unsigned char ti_hour;
    unsigned char ti_min;
    unsigned char ti_sec;
    unsigned char ti_hund;
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
#ifndef _WINDOWS
int        absread(int _drive, int _nsects, int _lsect, void * _buffer);
int        abswrite(int _drive, int _nsects, int _lsect, const void * _buffer);
int        allocmem(unsigned _size, unsigned * _segp);
int        freemem(unsigned _segx);
void       keep(unsigned char _status, unsigned _size);
int        setblock(unsigned _segx, unsigned _newsize);
#endif
struct country * country(int _code, struct country * _cp);
void       ctrlbrk(int (* _handler)(void));
int        getcbrk(void);
void       getdate(struct date * _dptr);
void       getdfree(unsigned char _drive, struct dfree * _dtable);
void       getfat(unsigned char _drive, struct fatinfo * _dtable);
void       getfatd(struct fatinfo * _dtable);
unsigned   getpsp(void);
void       gettime(struct time * _tptr);
int        getverify(void);
void       intr(int _intno, struct REGPACK * _preg);
void       nosound(void);
char *     parsfnm(const char * _cmdline, struct fcb * _fcb, int _opt);
int        randbrd(struct fcb * _fcb, int _rcnt);
int        randbwr(struct fcb * _fcb, int _rcnt);
int        setcbrk(int _val);
void       setdate(const struct date * _dptr);
void       settime(const struct time * _tptr);
void       setverify(int _value);
void       sleep(unsigned _secs);
void       sound(unsigned _freq);
#ifndef __STDC__
char far * getdta(void);
void       setdta(char far * _dta);
#ifndef _WINDOWS
void       setvect(int _interruptno, void (interrupt far * _isr) ());
#endif
void (interrupt far *getvect(int _interruptno))();
#endif

#ifndef _WINDOWS
void          SetInProgramFlag(unsigned char State);
unsigned char GetInProgramFlag(void);
void          DisableBreakCheck(void);
void          EnableBreakCheck(void);
#endif
#ifdef __cplusplus
}
#endif

#endif


