/* Release 3.00 */

/*-------------------------------------------------------------------------*
*                                                                          *
*  fior.h -  header file for Modula-2 redirected file IO procedures        *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2FIOR_INC
#define _M2FIOR_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)

#ifdef __cplusplus
extern "C" {
#endif
int  FIOR$OpenTextFile(unsigned nameH, const char *name);
void FIOR$ReadTextLn (unsigned lineH, char *line);
void FIOR$CloseTextFile(void);
void FIOR$ExpandPath(unsigned pathH, const char *path,
                     unsigned fullpH, char *fullpath);
void FIOR$SplitPath(unsigned pathH, const char *path, unsigned headH,
                    char *head, unsigned tailH, char *tail);
void FIOR$MakePath(unsigned pathH, char *path, unsigned headH,
                   const char *head, unsigned tailH, const char *tail);
void FIOR$AddExtension(unsigned sH, char *s, unsigned extH, char *ext);
void FIOR$RemoveExtension(unsigned sH, char *s);
void FIOR$ChangeExtension(unsigned sH, char *s, unsigned extH, char *ext);
int  FIOR$IsExtension(unsigned sH, char *s, unsigned extH, char *ext);

/* Redirected calls */

int  FIOR$FindPath(unsigned nameH, const char *name, unsigned fnameH,
                   char *fullname);
int  FIOR$FindNewPath(unsigned nameH, const char *name, unsigned fnameH,
                      char *fullname);
int  FIOR$FindExePath(unsigned pathH, const char *path, int ovl,
                      unsigned outH, char *outpath);
int  FIOR$Open(unsigned nameH, const char *name);
int  FIOR$Create(unsigned nameH, const char *name);
int  FIOR$OpenRW(unsigned nameH, const char *name);
int  FIOR$Erase(unsigned nameH, const char *name);
int  FIOR$IOresult(void);

/* Date stuff */

void FIOR$ReadRedirectionFile(unsigned nameH, const char *name);
void FIOR$Init(void);
#ifdef __cplusplus
}
#endif
#pragma restore
#endif