/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  io.h -  Definitions for low level I/O functions.                        *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _IO_INC_
#define _IO_INC_

struct	ftime	{
	unsigned	ft_tsec	 : 5;	/* Two second interval */
	unsigned	ft_min	 : 6;	/* Minutes */
	unsigned	ft_hour	 : 5;	/* Hours */
	unsigned	ft_day	 : 5;	/* Days */
	unsigned	ft_month : 4;	/* Months */
	unsigned	ft_year	 : 7;	/* Year */
};

#define HANDLE_MAX	20U
#define SEEK_SET         0
#define SEEK_CUR         1
#define SEEK_END         2

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned int     _openfd[HANDLE_MAX];

int      access(const char *_path, int _access);
int      chmod(const char *_path, int _mode);
int      _chmod(const char *_path, int _func, int _mode);
int      chsize(int _handle, long _size);
int      _close(int _handle);
int      close(int _handle);
int      _creat(const char *_path, int _permission);
int      creatnew(const char *_path, int _mode);       /* DOS 3.0 or later */
int      creattemp(const char *_path, int _amode);     /* DOS 3.0 or later */
int      _creat_new(const char *_path, int _permission);
int      _creat_trunc(const char *_path, int _permission);
int      creat(const char *_path, int _access);
int      dup(int _handle);
int      dup2(int _oldhandle, int _newhandle);
int      eof(int _handle);
int      _dup(int _handle);
int      _dup2(int _oldhandle, int _newhandle);
#ifndef __cplusplus
int      _eof(int _handle);
#endif
long     filelength(int _handle);
int      _filedrive(int _handle);
int      getftime(int _handle, struct ftime *_ftimep);
int      ioctl(int _handle, int _func, ...);
int      isatty(int _handle);
int      lock(int _handle, long _offset, long _length);
int      locking(int _handle, int _mode, long _numgth);
long     lseek(int _handle, long _offset, int _fromwhere);
char *   mktemp(char *_base);
int      _open(const char *_path, int _oflags);
int      open(const char *_path, int _access,... /*unsigned mode*/);
int      _read(int _handle, void *_buf, unsigned _num);
int      read(int _handle, void *_buf, unsigned _num);
int      setftime(int _handle, struct ftime *_ftimep);
int      setmode(int _handle, unsigned _mode);
int      sopen(const char *_path, int _access, int _shflag, ... /*unsigned mode*/);
long     tell(int _handle);
unsigned umask(unsigned _cmask);
int      unlink(const char *_path);
int      unlock(int _handle, long _offset, long _length);
int      _write(int _handle, const void *_buf, unsigned _num);
int      write(int _handle, const void *_buf, unsigned _num);
#ifdef __cplusplus
}
#endif


#endif
