/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  lib.h -  header file for Modula-2 general purpose procedures            *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2LIB_INC
#define _M2LIB_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)

typedef void (far *PROC)(void);

typedef void *ADDRESS;

#ifndef _JMPTYPE_DEF
#define _JMPTYPE_DEF
typedef struct {
    unsigned  j_sp;	   /* saved X086 registers */
    unsigned  j_ss;
    unsigned  j_flag;
    unsigned  j_cs;
    unsigned  j_ip;
    unsigned  j_bp;
    unsigned  j_di;
    unsigned  j_es;
    unsigned  j_si;
    unsigned  j_ds;
} jmp_buf[1];
#endif

struct Registers {
    unsigned ax;
    unsigned bx;
    unsigned cx;
    unsigned dx;
    unsigned bp;
    unsigned si;
    unsigned di;
    unsigned ds;
    unsigned es;
    unsigned Flags;
};

#ifdef __cplusplus
extern "C" {
#endif
void       Lib$QSort(unsigned N, int (* Less)(int, int), void (* Swap)(int, int));
void       Lib$HSort(unsigned N, int (* Less)(int, int), void (* Swap)(int, int));

void       Lib$RANDOMIZE(void);
unsigned   Lib$RANDOM(unsigned Range);
float      Lib$RAND(void);

void       Lib$MathError(double R, unsigned SH, const char *S);
void       Lib$MathError2(double R1, double R2, unsigned SH, const char *S);

unsigned   Lib$Execute(unsigned NameH, const char *Name, unsigned CommandLineH,
                   const char *CommandLine, void *StoreAddr, unsigned StoreLen);

char far * Lib$Environment(unsigned N);
unsigned   Lib$ParamCount(void);
void       Lib$ParamStr(unsigned SH, char *S, unsigned N);

void       Lib$Move(void *Source, void *Dest, unsigned Count);
void       Lib$WordMove(void *Source, void *Dest, unsigned WordCount);
void       Lib$Fill(void *Dest, unsigned Count, unsigned short Value);
void       Lib$WordFill(void *Dest, unsigned WordCount, unsigned Value);
unsigned   Lib$ScanR(void *Dest, unsigned Count, unsigned short Value);
unsigned   Lib$ScanL(void *Dest, unsigned Count, unsigned short Value);
unsigned   Lib$ScanNeR(void *Dest, unsigned Count, unsigned short Value);
unsigned   Lib$ScanNeL(void *Dest, unsigned Count, unsigned short Value);
unsigned   Lib$Compare(void *Source, void *Dest, unsigned Len);


void       Lib$Dos(struct Registers *R);
void       Lib$Intr(struct Registers *R, unsigned I);
unsigned   Lib$DosExec(unsigned nameH, const char *name, void *paramblock);


#pragma save
#pragma call(reg_saved=>())
unsigned   Lib$SetJmp(jmp_buf Lbl);
#pragma call(reg_saved=>(ax,bx,cx,dx,si,di,ds,es,st1,st2))
void       Lib$LongJump(jmp_buf Lbl, unsigned result);
#pragma restore

void       Lib$UserBreak(void);
void       Lib$DisableBreakCheck(void);
void       Lib$EnableBreakCheck(void);
void       Lib$FatalError(unsigned SH, const char *S);
void       Lib$SetReturnCode(unsigned short code);

void       Lib$Delay(unsigned Time);
void       Lib$Sound(unsigned FreqHz);
void       Lib$NoSound(void);
unsigned   Lib$HashString(unsigned SH, const char *S, unsigned Range);


void       Lib$Terminate(PROC P, PROC *C);
#ifdef __cplusplus
}
#endif
#pragma restore

#endif
