/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  mem.h -  memory manipulation definitions and function prototypes.       *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _MEM_INC_
#define _MEM_INC_

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

#ifndef NULL
#ifndef _fptr
#define NULL   0
#else
#define NULL   0L
#endif
#endif

#if (!((defined _INLINE) & (defined __LANG_EXT__))) || (defined __STDC__)
#ifdef __cplusplus
extern "C" {
#endif
int	    memcmp(const void *_s1, const void *_s2, size_t _num);
void *      memcpy(void *_dest, const void *_source, size_t _num);
void *      memset(void *_s, int _c, size_t _num);
#ifdef __cplusplus
}
#endif
#else
#include <inline.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif
void *      memccpy(void *_dest, const void *_source, int _c, size_t _num);
void *      memchr(const void *_s, int _c, size_t _num);
int	    memicmp(const void *_s1, const void *_s2, size_t _num);
void *      memmove(void *_dest, const void *_source, size_t _num);
void	    movedata(unsigned _sseg, unsigned _soff, unsigned _dseg,
		     unsigned _doff, size_t _num);
void	    movmem(void *src, void *_dest, unsigned _length);
void	    setmem(void *_dest, unsigned _length, char _value);

void *      memwmove(void *_dest, const void *_source, size_t _num);
void *      memwset(void *_s, int _c, size_t _num);
void *      memwcpy(void *_dest, const void *_source, size_t _num);

#ifndef __STDC__
int         far _fmemcmp(const void far *_s1, const void far *_s2, size_t _n);
void far *  far _fmemcpy(void far *_dest, const void far *_source, size_t _n);
void far *  far _fmemset(void far *_s, int _c, size_t _n);
void far *  far _fmemccpy(void far *_dest, const void far *_source, int _c, size_t _n);
void far *  far _fmemchr(const void far *_s, int _c, size_t _n);
int         far _fmemicmp(const void far *_s1, const void far *_s2, size_t _n);
void far *  far _fmemmove(void far * _dest, const void far *_source, size_t _num);
#endif

#ifndef __STDC__
void huge * hmemccpy(void huge *_dest, const void huge *_source, int _c, size_t n);
void huge * hmemchr(const void huge *_s, int _c, size_t n);
int         hmemcmp(const void huge *_s1, const void huge *_s2, size_t n);
void huge * hmemcpy(void huge *_dest, const void huge *_source, size_t n);
int         hmemicmp(const void huge *_s1, const void huge *_s2, size_t n);
void huge * hmemset(void huge *_s, int _c, size_t n);

#ifdef _HUGE_
#define  memccpy hmemccpy
#define  memchr  hmemchr
#define  memcmp  hmemcmp
#define  memcpy  hmemcpy
#define  memicmp hmemicmp
#define  memset  hmemset
#endif
#endif
#ifdef __cplusplus
}
#endif
#endif
