/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  mio.h -  header file for Modula-2 IO procedures                         *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2IO_INC
#define _M2IO_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)

#define  MaxRdLength 256

typedef int WrStrType;
typedef int RdStrType;

#ifndef _CHARSET_DEF
#define _CHARSET_DEF
typedef int CHARSET;
#endif

#ifdef __cplusplus
extern "C" {
#endif
extern short int IO@RdLnOnWr;
extern short int IO@Prompt;
extern WrStrType IO@WrStrRedirect;
extern RdStrType IO@RdStrRedirect;
extern CHARSET   IO@Separators;
extern short int IO@OK;
extern short int IO@ChopOff;
extern short int IO@Eng;

void             IO$WrChar(short int V);
void             IO$WrBool(short int V, int Length);
void             IO$WrShtInt(short int V, int Length);
void             IO$WrInt(int V, int Length);
void             IO$WrLngInt(long V, int Length);
void             IO$WrShtCard(unsigned short V, int Length);
void             IO$WrCard(unsigned V, int Length);
void             IO$WrLngCard(unsigned long V, int Length);
void             IO$WrShtHex(unsigned short V, int Length);
void             IO$WrHex(unsigned V, int Length);
void             IO$WrLngHex(unsigned long V, int Length);
void             IO$WrReal(float V, unsigned Precision, int Length);
void             IO$WrLngReal(double V, unsigned Precision, int Length);
void             IO$WrFixReal(double V, unsigned Precision, int Length);
void             IO$WrFixLngReal(double V, unsigned Precision, int Length);

void             IO$WrStr(unsigned SH, const char *S);
void             IO$WrStrAdj(unsigned SH, const char *S, int Length);
void             IO$WrCharRep(char V, unsigned Count);
void             IO$WrLn(void);

char             IO$RdChar(void);
short            IO$RdBool(void);
short            IO$RdShtInt(void);
int              IO$RdInt(void);
long             IO$RdLngInt(void);
unsigned short   IO$RdShtCard(void);
unsigned         IO$RdCard(void);
unsigned long    IO$RdLngCard(void);
unsigned short   IO$RdShortHex(void);
unsigned         IO$RdHex(void);
unsigned long    IO$RdLngHex(void);
float            IO$RdReal(void);
double           IO$RdLngReal(void);

void             IO$RdStr(unsigned VH, char *V);
void             IO$RdItem(unsigned VH, char *V);
void             IO$RdLn(void);
short int        IO$EndOfRd(short int Skip);

short int        IO$KeyPressed(void);
char             IO$RdKey(void);

void             IO$RedirectInput(unsigned FileNameH, const char *FileName);
void             IO$RedirectOutput(unsigned FileNameH, const char *FileName);

unsigned char    IO$ThreadOK(void);

#ifdef __cplusplus
}
#endif

#pragma restore
#endif
