/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  mlang.h -  Multi language header file.                                  *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _MLANG_INC_
#define _MLANG_INC_

#ifndef NULL
#ifndef _fptr
#define NULL   0
#else
#define NULL   0L
#endif
#endif

#pragma save

/* Any Modules used from within C compilation units will NOT be initialised
   unless imported by a Modula2 main module, or one of its imports. If your
   main module is in C then the InitModules function must be called from
   the function main().
*/

#ifdef __cplusplus
extern "C" {
#endif
void InitModules(char InitData1[], ...);
#ifdef __cplusplus
}
#endif

/* Converts string s to pascal dynamic string passtr */
char *StrToPas(char *passtr, const char *s);

/* Takes List of Module Initialisation Identifier Arrays, terminated by
   NULL pointer. e.g.

   InitModules(FIO$, Lib$, MyModule$, NULL);
*/

/* The following declarations are the initialisation idents for the library
   modules.
*/

/* You should make a similar declaration for any of your modules that have
   initialisation code, i.e. module(init_code=>on, implementation=>on), the
   default.  e.g.

#pragma save
#pragma name(prefix=>"")          (* Must not have _ prefix *)
extern char MyModule$[];
#pragma restore

*/

#pragma name(prefix=>"")

#ifdef __cplusplus
extern "C" {
#endif
extern char FIO$[];
extern char FloatExc$[];
extern char ShtHeap$[];
extern char Str$[];
extern char BiosIO$[];
extern char FIOR$[];
extern char FormIO$[];
extern char Graph$[];
extern char LIM$[];
extern char MATHLIB$[];
extern char MsMouse$[];
extern char IO$[];
extern char Lib$[];
extern char SYSTEM$[];
extern char Storage$[];
extern char Window$[];

extern char PasLib$[];
extern char PasDos$[];
extern char PasRed$[];
extern char PasProc$[];
#ifdef __cplusplus
}
#endif
#pragma restore
#endif
