/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  mprocess.h -  header file for Modula-2 process procedures               *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2PROC_INC
#define _M2PROC_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)

#ifndef _PROCTYPE_DEF
#define _PROCTYPE_DEF
typedef void far *SIGNAL;
#endif

#ifdef __cplusplus
extern "C" {
#endif
void Process$StartScheduler(void);
/* start the time sliced scheduler */

void Process$StopScheduler(void);
/* stops the time sliced scheduler */

void Process$StartProcess(void (far *P)(void), unsigned N, unsigned Pr);
/* Start a new process */

void Process$StopProcess(void);
/* Stops current thread */


void Process$SEND(SIGNAL s);
/* Send a signal */

void Process$WAIT(SIGNAL s);
/* Wait for signal */

void Process$Notify(SIGNAL s);
/*
   Causes a task waiting on signal s to be scheduled when possible,
   (e.g. at next time slice).
   If no-one is waiting on s then the call has NO effect.
   This call CANNOT cause reschedule, so may be used by an interrupt
   handler to safely notify another process of an events occurance.
*/

int Process$Awaited(SIGNAL s);
/* Returns if any process are waiting on signal */

void Process$Init(SIGNAL *s);
/* Initialize a signal */


void Process$Delay(unsigned T);
/* delays for at least T timeslices */

void Process$Lock(void);
/*
   Critical region lock. Prevents the current process from
   being de-scheduled by timeslicing, until a call to Unlock.
   Calls to Lock may be nested.
*/

void Process$Unlock(void);
/* Unlock procedure, always paired with a call to Lock. */
#ifdef __cplusplus
}
#endif

#pragma restore
#endif
