/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  ovluser.h  - MSDOS Segment based Overlay and DLL Loader                 *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _OVERLAY_INC
#define _OVERLAY_INC

#ifdef __cplusplus
extern "C" {
#endif

/* Overlay system error codes */

#define LOADER_ERROR_INVALID_ENTRY          1
#define LOADER_ERROR_TOO_MANY_MODULES       2
#define LOADER_ERROR_WRONG_MODULE_VERSION   3
#define LOADER_ERROR_MODULE_CORRUPT         4
#define LOADER_ERROR_STACK_CORRUPT          5
#define LOADER_ERROR_MODULE_NOT_FOUND       6
#define LOADER_ERROR_FIXUP_INCORRECT        7
#define LOADER_ERROR_EMS_ERROR              8
#define LOADER_ERROR_NOT_DLL                9
#define LOADER_ERROR_STACK_TRACE           10
#define LOADER_ERROR_MODULE_INIT_FAILED    11
#define LOADER_ERROR_FILE_NOT_FOUND        12
#define LOADER_ERROR_OUT_OF_MEMORY         13
#define LOADER_ERROR_FILE_READ             14
#define LOADER_ERROR_FILE_WRITE            15
#define LOADER_ERROR_STACK_OVERFLOW        16
#define LOADER_ERROR_CODE_FIXUP            17
#define LOADER_ERROR_TOO_MANY_SEGMENTS     18
#define LOADER_ERROR_INVALID_LOAD          19
#define LOADER_ERROR_CMEM_ERROR            20
#define LOADER_ERROR_INVALID_IMPORT        21
#define LOADER_ERROR_NO_ENTRYPOINTS        22
#define LOADER_ERROR_ILLEGAL_TRANSFORM     23
#define LOADER_ERROR_SWAP_FILE             24
#define LOADER_ERROR_ILLEGAL_ADDITIVE      25

#pragma save, call(reg_param=>(ax,bx,cx,dx))
#pragma name(prefix=>"Loader$")

typedef void (*ExitHandler)(char *, unsigned);
typedef int (*MemHandler)(unsigned);

#define LOADER_MANUAL      1
#define LOADER_AUTO        2

#define LOADER_SUCCESS         0
#define LOADER_FAIL            1
#define LOADER_RESIDENT        2
#define LOADER_UNLOADED        3
#define LOADER_INVALID_SEG     4
#define LOADER_INVALID_MODULE  5

unsigned LoadModule  (const char *ModName);
void     UnLoadModule(const char *ModName);
void   * GetProcAddr (unsigned ModNo, const char *ProcName);

void     UserFlush(void);

void     SetExitHandler(ExitHandler P);
void     SetMemHandler(MemHandler P);
void     SetMode(unsigned Mode);

unsigned LoadSeg(unsigned SegNo, char *ModName);
void     UnloadSeg(unsigned SegNo, char *ModName);
void     Terminate(void);
void     Reset(void);

#pragma restore

#ifdef __cplusplus
}
#endif
#endif