/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  pasdos.h -  header file for PasDos                                      *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _PASDOS_INC
#define _PASDOS_INC

#pragma project("#set tspas='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)
#pragma name(upper_case=>on)

#ifdef __cplusplus
extern "Pascal" {
#endif

extern void (*PASDOS$RunTimeError)(long, unsigned, unsigned char, char *);


union Regsiters {
  struct words {  unsigned       AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags; } wordregs;
  struct bytes {  unsigned char  AL,AH,BL,BH,CL,CH,DL,DH; } byteregs;
};

typedef void (*ProcType)(void);

#define  ZeroFlag  0x40;

unsigned PASDOS$ParamCount(void);

unsigned PASDOS$SysErrno(void);

unsigned PASDOS$EnvCount(void);

void     PASDOS$Exec(unsigned char Psize, const char *Path, unsigned char Csize, const char *Command);

unsigned PASDOS$DosExitCode(void);

void     PASDOS$SetExitCode(unsigned code);

void     PASDOS$GetDate(unsigned *Year, unsigned *Month, unsigned *Day, unsigned *DayOfWeek);

void     PASDOS$SetDate(unsigned Year, unsigned Month, unsigned Day);

void     PASDOS$GetTime(unsigned *Hour, unsigned *Minute, unsigned *Second, unsigned *Hund);

void     PASDOS$SetTime(unsigned Hour, unsigned Minute, unsigned Second, unsigned Hund);

void     PASDOS$Intr(unsigned char IntNo, union Registers *Regs);

void     PASDOS$MsDos(union Registers *Regs);

unsigned char PASDOS$GetInProgramFlag(void);

void     PASDOS$SetInProgramFlag(unsigned char f);

void     PASDOS$ExecuteHaltChain(void);

void     PASDOS$Terminate(ProcType P, ProcType *C);

typedef char CommandStr[128];
#pragma save, data(near_ptr => off)
typedef CommandStr *CommandType;
#pragma restore

#pragma save, call(near_call=>off)

typedef void (* HardHandler)(unsigned, unsigned, void far *);
#pragma restore

void PASDOS$harderr(HardHandler handler);
void PASDOS$hardresume(unsigned code);
void PASDOS$hardretn(unsigned code);

unsigned char PASDOS$ProtectedMode(void);

typedef enum {cpu_Unknown,cpu_V20,cpu_V30,cpu_8088,cpu_8086,
             cpu_80188,cpu_80186,
             cpu_80286,cpu_80386} CpuKind;

typedef enum {fpu_none,fpu_8087,fpu_80287,fpu_80387} FpuKind;

typedef struct {
  unsigned char cpu;  /* CpuKind */
  unsigned char fpu;  /* FpuKind */
} CpuRec;

void CpuId (CpuRec *r);

void PASDOS$EnableBreakCheck(void);
void PASDOS$DisableBreakCheck(void);
void PASDOS$Delay(unsigned ms);

extern char PASDOS$LastChar;
extern unsigned char PASDOS$LastScan;

unsigned char PASDOS$KeyPressed(void);
char          PASDOS$RdKey(void);
char          PASDOS$RdChar(void);

#define RShift  0x01
#define LShift  0x02
#define Ctrl    0x04
#define Alt     0x08
#define Scroll  0x10
#define Cap     0x20
#define Ins     0x30

unsigned PASDOS$KBFlags(void);

#define  ReadOnly  0x01
#define  Hidden    0x02
#define  SysFile   0x04
#define  VolumeID  0x08
#define  Directory 0x10
#define  Archive   0x20
#define  AnyFile   0x3F

typedef struct {

  char Fill[21];
  unsigned char Attr;
  long Time;
  long Size;
  char Name[13];
} SearchRec;


void PASDOS$FindFirst(unsigned char size, const char *Path, unsigned Attr, SearchRec *S);
void PASDOS$FindNext(SearchRec *S);

void PASDOS$ChDir(unsigned char size, const char *s);
void PASDOS$GetDir(unsigned char d, unsigned char size, char *s);
void PASDOS$MkDir(unsigned char size, const char *s);
void PASDOS$RmDir(unsigned char size, const char *s);

#ifdef __cplusplus
}
#endif

#pragma restore
#endif
