/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  pasred.h -  header file for PasRed                                      *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _PASRED_INC
#define _PASRED_INC

#pragma project("#set tspas='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)
#pragma name(upper_case=>on)

#ifdef __cplusplus
extern "C" {
#endif

typedef char PathStr[81];
typedef char ExtStr[4];

#define Null 0xFFFF;

extern PathStr PASRED$LastPath;
extern int     PASRED$TextFile;

void PASRED$ExpandPath(unsigned char psize, const PathStr path,
                       unsigned char fsize, PathStr fullpath);

void PASRED$SplitPath (unsigned char psize, const PathStr path,
                       unsigned char hsize, PathStr head,
                       unsigned char tsize, PathStr tail);

void PASRED$MakePath  (unsigned char psize, PathStr path,
                       unsigned char hsize, const PathStr head,
                       unsigned char tsize, const PathStr tail);

void PASRED$AddExtension (unsigned char size, PathStr s, unsigned char esize, ExtStr ext) ;
void PASRED$RemoveExtension (unsigned char size, PathStr s) ;
void PASRED$ChangeExtension (unsigned char size, PathStr s, unsigned char esize, ExtStr ext) ;
unsigned char PASRED$IsExtension(unsigned char size, const PathStr s, unsigned char esize, ExtStr ext);

unsigned char PASRED$FindPath   (unsigned char  nsize, const PathStr name,
                                 unsigned char fsize, PathStr fullname);

unsigned char PASRED$FindNewPath(unsigned char  nsize, const PathStr name,
                                 unsigned char fsize, PathStr fullname);

unsigned char PASRED$FindExePath(unsigned char  psize, const PathStr path,
                                 unsigned char ovl,
                                 unsigned char osize, PathStr outpath);

void PASRED$ReadRedirectionFile (unsigned char  size, const PathStr name);

void PASRED$Init(void);

#ifdef __cplusplus
}
#endif

#pragma restore
#endif