/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  pragma.h -  useful pragma definitions .                                 *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _PRAGMA_INC_

#define _PRAGMA_INC_

/* This pragma defines the JPI calling convention for non overlay programs */
/* usage - #pragma _JPI_CALL */
#define _JPI_CALL call(reg_saved=>(ax,bx,cx,dx,di,si,ds,st1,st2),\
                       reg_param=>(ax,bx,cx,dx,st0,st6,st5,st4,st3),\
                       reg_return=>(ax,dx,st0),standard_float=>off,\
                       opt_var_arg=>on,c_conv=>off)

/* This pragma defines the JPI calling convention for overlay programs */
/* usage - #pragma _JPI_CALL_OVL */
#define _JPI_CALL_OVL call(reg_saved=>(ax,bx,cx,dx,di,si,ds,st1,st2),\
                           reg_param=>(ax,bx,cx,dx,st0,st6,st5,st4,st3),\
                           reg_return=>(ax,dx,st0),standard_float=>off,\
                           opt_var_arg=>off,c_conv=>off)

/* This pragma defines the cdecl calling convention */
/* usage - #pragma _CDECL_CALL */
#define _CDECL_CALL call(reg_saved=>(di,si,ds),\
                    reg_param=>(),\
                    reg_return=>(ax,dx),standard_float=>on,\
                    opt_var_arg=>off,c_conv=>on)

/* This pragma defines the cdecl naming convention */
/* usage - #pragma _CDECL_NAME */
#define _CDECL_NAME name(prefix =>"_",upper_case=>off)

/* This pragma defines the pascal calling convention */
/* usage - #pragma _PASCAL_CALL */
#define _PASCAL_CALL call(reg_saved=>(di,si,ds),\
                     reg_return=>(ax,dx),standard_float=>on,\
                     reg_param=>(),c_conv=>off)

/* This pragma defines the pascal naming convention */
/* usage - #pragma _PASCAL_NAME */
#define _PASCAL_NAME name(prefix =>"",upper_case=>on)

/* This pragma defines the OS2 calling convention */
/* usage - #pragma _OS2_CALL */
/* NB Although OS2 calls are documented as preserving bx,cx and dx some bugs */
/* in OS2 cause these registers to be corrupted */
#define _OS2_CALL call(reg_saved=>(di,si,ds,st1,st2),\
                       near_call=>off, \
                       reg_param=>(),c_conv=>off)

/* This pragma defines the OS2 naming convention */
/* usage - #pragma _OS2_NAME */
#define _OS2_NAME name(prefix =>"",upper_case=>on)

/* This macro can be used to define the JPI calling convention default */
/* register preservation list */
/* Usage - #pragma call(reg_saved=>(_JPI_SAVE)) */
#define _JPI_SAVE ax,bx,cx,dx,di,si,ds,st1,st2

/* This macro can be used to define the standard calling convention default */
/* register preservation list */
/* Usage - #pragma call(reg_saved=>(_STD_SAVE)) */
#define _STD_SAVE di,si,ds,st1,st2

/* This macro can be used to define the standard calling convention default */
/* register preservation list for a procedure that uses floating point */
/* Usage - #pragma call(reg_saved=>(_STD_FLOAT)) */
#define _STD_FLOAT di,si,ds

/* This macro can be used to define the full register preservation list for */
/* a procedure that preserves all registers */
/* Usage - #pragma call(reg_saved=>(_JPI_SAVE,_EXTRA_SAVE)) */
#define _EXTRA_SAVE es,st0,st3,st4,st5,st6

/* This macro can be used to define the default register parameter list for */
/* a procedure using JPI calling convention */
/* Usage - #pragma call(reg_param=>(_JPI_PARAM)) */
#define _JPI_PARAM ax,bx,cx,dx,st0,st6,st5,st4,st3

/* This macro can be used to define the default register return list for */
/* a procedure using JPI calling convention */
/* Usage - #pragma call(reg_return=>(_JPI_RETURN)) */
#define _JPI_RETURN ax,bx,st0

#endif