/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  search.h -  search and sort function prototypes.			   *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _SEARCH_INC_
#define _SEARCH_INC_

#ifndef NULL
#ifndef _fptr
#define NULL   0
#else
#define NULL   0L
#endif
#endif

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

#ifdef __cplusplus
extern "C" {
#endif
void   * bsearch(const void *_key, const void *_base,
		       size_t _num, size_t _width,
		       int ( *_compare)(const void *_e1, const void *_e2));
void	 qsort(void *_base, size_t _num, size_t _width,
              int (  *_compare)(const void *_e1, const void *_e2));
char   * lfind(const char *_key, const char *_base,
	       unsigned *_num, unsigned _width,
	       int ( *_compare)(const void *_e1, const void *_e2));
char   * lsearch(const char *_key, char *_base,
		 unsigned *_num, unsigned _width,
		 int ( *_compare)(const void *_e1, const void *_e2));

#ifndef __STDC__
void huge * hbsearch(const void *_key, const void huge *_base,
		     size_t _num, size_t _width,
		     int ( *_compare)(const void huge *_e1, const void huge *_e2));
void	    hqsort(void huge *_base, size_t _num, size_t _width,
		   int (  *_compare)(const void huge *_e1, const void huge *_e2));
char huge * hlfind(const char *_key, const char huge *_base,
		   unsigned *_num, unsigned _width,
		   int ( *_compare)(const void huge *_e1, const void huge *_e2));
char huge * hlsearch(const char *_key, char huge *_base,
		     unsigned *_num, unsigned _width,
		     int ( *_compare)(const void huge *_e1, const void huge *_e2));
		
#ifdef _HUGE_
#define qsort(_base, _num, _width, _compare)   hqsort(_base, _num, _width, _compare)
#define lsearch(_key, _base, _num, _width, _compare) hlsearch(_key, _base, _num, _width, _compare)
#define bsearch(_key, _base, _num, _width, _compare) blsearch(_key, _base, _num, _width, _compare)
#define lfind(_key, _base, _num, _width, _compare)   hlfind(_key, _base, _num, _width, _compare)
#endif
#endif
#ifdef __cplusplus
}
#endif
#endif
