/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  storage.h -  header file for Modula-2 memory management procedures      *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2STORAGE_INC
#define _M2STORAGE_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma name(prefix=>"")

typedef struct _FarHeapRec {
    unsigned size;
    struct _FarHeapRec far *next;
} FarHeapRec;

typedef struct _NearHeapRec {
    unsigned size;
    struct _NearHeapRec near *next;
} NearHeapRec;

typedef void far *FarDataAddress;
typedef void near *NearDataAddress;

#ifdef __cplusplus
extern "C" {
#endif
extern int  Storage@ClearOnAllocate;
extern int  Storage@Check;

void         Storage$FarAllocate(FarDataAddress *A, unsigned size);
void         Storage$FarDeallocate(FarDataAddress *A, unsigned size);
void         Storage$FarAvailable(unsigned size);
void         Storage$NearAllocate(NearDataAddress *A, unsigned size);
void         Storage$NearDeallocate(NearDataAddress *A, unsigned size);
int          Storage$NearAvailable(unsigned size);
FarHeapRec * Storage$FarMakeHeap(unsigned Source, unsigned Size);
void         Storage$FarHeapAllocate(FarHeapRec *Source, FarDataAddress *A,
                                     unsigned Size);
unsigned     Storage$FarHeapAvail(FarHeapRec *Source);
unsigned     Storage$FarHeapTotalAvail(FarHeapRec *Source);
void         Storage$FarHeapDeallocate(FarHeapRec *Source, FarDataAddress *A,
                                       unsigned Size);
int          Storage$FarHeapChangeAlloc(FarHeapRec *Source, FarDataAddress *A,
                                        unsigned OldSize, unsigned NewSize);
void         Storage$FarHeapChangeSize(FarHeapRec *Source, FarDataAddress *A,
                                       unsigned OldSize, unsigned NewSize);
NearHeapRec *Storage$NearMakeHeap(NearDataAddress Source, unsigned Size);
void         Storage$NearHeapAllocate(NearHeapRec *Source, NearDataAddress *A,
                                      unsigned Size);
unsigned     Storage$NearHeapAvail(NearHeapRec *Source);
unsigned     Storage$NearHeapTotalAvail(NearHeapRec *Source);
void         Storage$NearHeapDeallocate(NearHeapRec *Source, NearDataAddress *A,
                                        unsigned Size);
int          Storage$NearHeapChangeAlloc(NearHeapRec *Source, NearDataAddress *A,
                                         unsigned OldSize, unsigned NewSize);
void         Storage$NearHeapChangeSize(NearHeapRec *Source, NearDataAddress *A,unsigned OldSize, unsigned NewSize);

unsigned     Storage$SegAllocate(unsigned Size);

void         Storage$SegDeallocate(unsigned Sel, unsigned Size);
                                        
#ifdef __cplusplus
}
#endif
#pragma restore
#endif
