/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  string.h -  Definitions for string and memory functions.                *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _STRING_INC_
#define _STRING_INC_

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

#ifndef NULL
#ifndef _fptr
#define NULL   0
#else
#define NULL   0L
#endif
#endif

#if (!((defined _INLINE) & (defined __LANG_EXT__))) || (defined __STDC__)
#ifdef __cplusplus
extern "C" {
#endif
int     memcmp(const void *_s1, const void *_s2, size_t _n);
void *  memcpy(void *_dest, const void *_source, size_t _n);
void *  memset(void *_s, int _c, size_t _n);
char *  strcat(char *_dest, const char *_source);
int     strcmp(const char *_s1, const char *_s2);
char *  strcpy(char *_dest, const char *_source);
size_t  strlen(const char *_s);
char *  strset(char *_s, int _ch);
#ifdef __cplusplus
}
#endif
#else
#include <inline.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif
void *  memccpy(void *_dest, const void *_source, int _c, size_t _n);
void *  memchr(const void *_s, int _c, size_t _n);
int     memicmp(const void *_s1, const void *_s2, size_t _n);
void *  memmove(void *_dest, const void *_source, size_t _n);
void    movedata(unsigned _sseg, unsigned _soff, unsigned _dseg,
                 unsigned _doff, size_t _n);
void    movmem(void *_src, void *_dest, unsigned length);
void    setmem(void *_dest, unsigned length, char val);

void *  memwcpy(void *_dest, const void *_source, size_t _n);
void *  memwmove(void *_dest, const void *_source, size_t _n);
void *  memwset(void *_s, int _c, size_t _n);

char *  stpcpy(char *_dest, const char *_source);
char *  strchr(const char *_s, int _c);
int     strcoll(const char *_s1, const char *_s2);
size_t  strxfrm(char *_s1, const char *_s2, size_t _n);
size_t  strcspn(const char *_s1, const char *_s2);
char *  strdup(const char *_s);
char *  strerror(int _errnum);
int     stricmp(const char *_s1, const char *_s2);
char *  strlwr(char *_s);
char *  strncat(char *_dest, const char *_source, size_t _n);
int     strncmp(const char *_s1, const char *_s2, size_t _n);
char *  strncpy(char *_dest, const char *_source, size_t _n);
int     strnicmp(const char *_s1, const char *_s2, size_t _n);
char *  strnset(char *_s, int _ch, size_t _n);
char *  strpbrk(const char *_s1, const char *_s2);
char *  strrchr(const char *_s, int _c);
char *  strrev(char *_s);
size_t  strspn(const char *_s1, const char *_s2);
char *  strstr(const char *_s1, const char *_s2);
char *  strtok(char *_s1, const char *_s2);
char *  strupr(char *_s);
char *  _strerror (const char *_s);

#ifndef __STDC__
int         far _fmemcmp(const void far *_s1, const void far *_s2, size_t _n);
void far *  far _fmemcpy(void far *_dest, const void far *_source, size_t _n);
void far *  far _fmemset(void far *_s, int _c, size_t _n);

char far *  far _fstrcat(char far *_dest, const char far *_source);
int         far _fstrcmp(const char far *_s1, const char far *_s2);
char far *  far _fstrcpy(char far *_dest, const char far *_source);
size_t      far _fstrlen(const char far *_s);
char far *  far _fstrset(char far *_s, int _ch);

void far *  far _fmemccpy(void far *_dest, const void far *_source, int _c, size_t _n);
void far *  far _fmemchr(const void far *_s, int _c, size_t _n);
int         far _fmemicmp(const void far *_s1, const void far *_s2, size_t _n);

char far *  far _fstpcpy(char far *_dest, const char far *_source);
char far *  far _fstrchr(const char far *_s, int _c);
int         far _fstrcoll(const char far *_s1, const char far *_s2);
size_t      far _fstrxfrm(char far *_s1, const char far *_s2, size_t _n);
size_t      far _fstrcspn(const char far *_s1, const char far *_s2);
char far *  far _fstrdup(const char far *_s);
char near * far _nstrdup(const char far *_s);
int         far _fstricmp(const char far *_s1, const char far *_s2);
char far *  far _fstrlwr(char far *_s);
char far *  far _fstrncat(char far *_dest, const char far *_source, size_t _n);
int         far _fstrncmp(const char far *_s1, const char far *_s2, size_t _n);
char far *  far _fstrncpy(char far *_dest, const char far *_source, size_t _n);
int         far _fstrnicmp(const char far *_s1, const char far *_s2, size_t _n);
char far *  far _fstrnset(char far *_s, int _ch, size_t _n);
char far *  far _fstrpbrk(const char far *_s1, const char far *_s2);
char far *  far _fstrrchr(const char far *_s, int _c);
char far *  far _fstrrev(char far *_s);
size_t      far _fstrspn(const char far *_s1, const char far *_s2);
char far *  far _fstrstr(const char far *_s1, const char far *_s2);
char far *  far _fstrtok(char far *_s1, const char far *_s2);
char far *  far _fstrupr(char far *_s);
#endif
#ifdef __cplusplus
}
#endif

/* compatibility with other compilers */
#define strcmpi(s1,s2)		stricmp(s1,s2)
#define strncmpi(s1,s2,n)	strnicmp(s1,s2,n)

#endif
