#include <process.h>

class task {

public:

      task(void (* proc)(void), unsigned stack_size, int priority);
      // this constructor is like StartProcess
      task(unsigned stack_size=2000, int priority=0);
      // this constructor assumes that thread_proc is to be used
      ~task();

  void start();
  // start thread
  void stop();
  // stop thread
  void transfer_to(task &);
  // transfer to new task
  PROCESS task_id();
  // return thread id
protected:

  virtual thread_proc() { while(1); }
  // thread process
private:
  void (*proc_func)(void);
  int thread_no;

};

class semaphore {

public:

      semaphore();
      ~semaphore();

  int set(int status = 1);
  // unconditionally sets semaphore
  int wait(int msecs = -1);
  // waits for semaphore to be cleared
  int set_and_wait(int msecs = -1);
  // unconditionally sets semaphore and waits for it to be cleared
  int request(int tics = 0);
  // waits for semaphore to be cleared and then sets
  int clear();
  // clears semaphore

private:

  long sem;
}