/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  textwin.hpp -  header file for OOP window interface.                    *
*                                                                          *
*  COPYRIGHT (C) 1990..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _TEXTWIN_INC_
#define _TEXTWIN_INC_

#pragma project("#set cwindow='jpi'")

#define _JPI_WIN_
#include <conio.h>

class window {

public:

    window(window& W);
    window(wintype WT);
    window(windef& WD);
    window(abscoord X1, abscoord Y1, abscoord X2, abscoord Y2,
           Color fore=LightGray, Color back=Black);  // no frame
    window(abscoord X1, abscoord Y1, abscoord X2, abscoord Y2,
           framestr  frame,
           Color framefore=LightGray, Color frameback=Black,
           Color fore=LightGray, Color back=Black);
  virtual ~window();

  void  operator=(window& W);
  void  settitle(char _NewTitle[], TitleMode _Mode );
  void  setframe(framestr _Frame, Color _Fore,
                        Color _Back);
  void  use();
  void  putontop();
  void  putbeneath(window&);
  void  hide();
  void  change(abscoord _X1, abscoord _Y1, abscoord _X2, abscoord _Y2 );
  void  close();
  int   isused();
  int   istop();
  int   obscuredat(relcoord _X, relcoord _Y);
  void  convertcoords(relcoord _X, relcoord _y, abscoord& _XO, abscoord& _YO);
  void  info(windef& _WD);
  wintype handle() { return h; }


protected:

  void check_win();
  wintype h;

};

class palettewindow : public window {

public:

    palettewindow(PaletteDef _Pal, windef& WD);
    palettewindow(PaletteDef _Pal,
                  abscoord X1, abscoord Y1, abscoord X2, abscoord Y2,
                  Color fore=LightGray, Color back=Black);  // no frame
    palettewindow(PaletteDef _Pal,
                  abscoord X1, abscoord Y1, abscoord X2, abscoord Y2,
                  framestr  frame,
                  Color framefore=LightGray, Color frameback=Black,
                  Color fore=LightGray, Color back=Black);

  void  setpalette(PaletteDef _Pal);
  int   palettecolorused(int _pc);

};


extern int (* WinErrHandler)();

extern window FullScreen;

#endif