/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  time.h - structure and function definitions for time.                   *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _TIME_INC_
#define _TIME_INC_

#ifndef  _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

#ifndef _TIME_T
#define _TIME_T
#ifndef _TIME_DEF
#define _TIME_DEF
typedef long  time_t;
#endif
typedef long  clock_t;
#define CLK_TCK 100
#define CLOCKS_PER_SEC 100


#ifndef NULL
#ifndef _fptr
#define NULL   0
#else
#define NULL   0L
#endif
#endif

#ifndef _TM_DEF
#define _TM_DEF
struct  tm   {
   int  tm_sec;
   int  tm_min;
   int  tm_hour;
   int  tm_mday;
   int  tm_mon;
   int  tm_year;
   int  tm_wday;
   int  tm_yday;
   int  tm_isdst;
};
#endif

#ifndef _TMT_DEF
#define _TMT_DEF
struct date {
    int da_year;
    unsigned char da_day;
    unsigned char da_mon;
};

struct time {
    unsigned char ti_hour;
    unsigned char ti_min;
    unsigned char ti_sec;
    unsigned char ti_hund;
};


#endif

#ifndef _UTMT_DEF
#define _UTMT_DEF
struct utm {  int u_sec;
              int u_min;
	      int u_hour;
	      int u_day;
              int u_mon;
	      int u_year;
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
char *       asctime(const struct tm *_tblock);
char *       ctime(const time_t *_timer);
clock_t      clock(void);
double       difftime(time_t _time2, time_t _time1);
struct tm *  gmtime(const time_t *_timer);
struct tm *  localtime(const time_t *_timer);
time_t       mktime(struct tm *_timeptr);
size_t       strftime(char *_s, size_t _maxsize, const char *_format,
                      const struct tm *_timeptr);
time_t       time(time_t *_timer);
int          stime(time_t *_tp);
void         tzset(void);
void         settime(const struct time *_tptr);
void         gettime(struct time *_tptr);
void         setdate(const struct date *_dptr);
void         getdate(struct date *_dptr);
char *       _strdate(char *_dt);
char *       _strtime(char *_tm);
int          utime(char *_path, struct utm *_time);
time_t       get_utime(int _handle);
int          _filetime(int _handle, struct utm *_ubuf);

extern time_t  timezone;
extern int daylight;
#ifdef __cplusplus
}
#endif
#endif
#endif