(* Release 3.00 *)
(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*%F _fdata *)
(*# call(seg_name => null) *)
(*# data(seg_name => null) *)
(*%E *)
(*# module(implementation=>off) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT PasCore;

IMPORT PasLib,PasDos,CoreIO,CoreFile,CoreSig(*%T _mthread *), PasProc, CoreProc (*%E *)(*%T _OS2 *), Dos(*%E *);

var
  LastTempExt: packed array [1..8] of char;

(**************************** Internal string functions *******************************)

procedure sptr_to_string{(var tname: namestring; sp: address)};
var
  n: word;
  c: char;
  p: StrPtr;
label
  555;
begin
  n := 1;
  p := sp;
  while (n < 80) do
    begin
    c := p^[n-1];
    if ord(c) = 0 then
      goto 555;
    tname[n]:= c;
    n := n+1
    end;
555:
  tname[0]:=chr(n-1);
end;

procedure ca_to_string{(var tname: namestring; cname: packed array[i..j:word]of char)};
var
  n, r: word;
begin
  n := 1;
  r := i;
  while (n < 80) and (r <= j) do
    begin
    tname[n]:=cname[r];
    n := n+1;
    r := r+1
    end;
  tname[0]:=chr(n-1);
end;

(********************************* I/O Extensions **************************)

procedure NotSupported;

begin
  PasDos.RunTimeError(CoreSig._FatalErrorPos, 0FAH, 'OS2 Library: Function Not Supported');
end;

procedure ErrorCheck{(Code: word; ErrNum: word; Msg, Name: namestring)};

var
    ErrMsg: string[255];
    pos: integer;
begin
    if ErrNum = 0 then
      ErrNum := PasDos.SysErrno;
    if IOcheck then
        begin
        ErrMsg := Msg+Name+'. ';
        pos:=CoreSig._FatalErrorPos;
        PasDos.RunTimeError(pos, Code+0A0H, ErrMsg)
        end;
    SetIOR(ErrNum);
end ;

function IsEOF{(var f: filetype): boolean};

begin
    IsEOF := ((f.mode = wm) or (CoreFile._F_EOF in (f.stream:>FileInf)^.flag)) or ((TextFile in f.state) and ((f.bufferptr:>CharPtr)^ = chr(CtlZ)))
end;

procedure FindEof{(var f: filetype)};

var
  lres: integer;
  res, size, n: int16;
  dum: array [0..127] of byte;
begin
  lres := CoreIO.lseek(f.handle, 0, 2);
  if lres > 128 then
    begin
    size := CoreIO.lseek(f.handle, -128, 2);
    size := 128;
    end
  else
    begin
    size := CoreIO.lseek(f.handle, 0, 0);
    size := lres;
    end;
  res := CoreIO._read(f.handle, adr(dum), size);
  if res <> size then
    ErrorCheck(0EH, 0, 'FindEof : ', PasDos.NilStr);

  n := 0;
  while (dum[n] <> 01AH) and (n < 128) do
    n := n + 1;
  lres := CoreIO.lseek(f.handle, (-size + n), 2);
end;

function FlsBuf{(FI: FileInf; CRT: boolean): int16};

var
  Wnum: word;
  res: int16;
label
  999;
begin
  if FI^.Size = 0 then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0EDH, 'FlsBuf: Stream Not Buffered');
  if (FI^.Flag = []) or ((FI^.Flag * [CoreFile._F_ERR, CoreFile._F_EOF, CoreFile._F_IN]) <> []) then
    begin
    FlsBuf := -1;
    goto 999
    end;
  if (CoreFile._F_RST in FI^.Flag) then          (* set up reset buffer for output *)
    begin
    FI^.Flag := FI^.Flag - [CoreFile._F_RST];
    FI^.Flag := FI^.Flag + [CoreFile._F_OUT];
    FI^.Cnt := FI^.Size;
    FI^.Ptr := FI^.Base;
    FlsBuf := -2;  			   (* return - buffer wasn't full *)
    goto 999
    end;
  if FI^.Cnt < 0 then
    FI^.Cnt := 0;
  Wnum := FI^.Size - FI^.Cnt;
  if Wnum = 0 then
  begin
      FlsBuf := 0;
      goto 999
  end	;
  if CRT then
    res := PasDos.write(FI^.Handle, FI^.Base, Wnum)
  else
    res:= CoreIO._write(FI^.Handle, FI^.Base, Wnum);
  if res = -1 then
    begin
    FI^.Flag := FI^.Flag + [CoreFile._F_ERR];
    FI^.Cnt := 0;
    FlsBuf := -1;
    goto 999
    end;
  FI^.Cnt := FI^.Size; 		           (* set buffer pointers *)
  FI^.Ptr := FI^.Base;
  FI^.Flag := FI^.Flag + [CoreFile._F_OUT];              (* set output flag *)
  FlsBuf := Wnum;
999:
end ;

function FilBuf{(FI: FileInf; CRT: boolean): int16};

var
  NumRead: int16;
label
  999;
begin
  if FI^.Size = 0 then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0EEH, 'FilBuf: Stream Not Buffered');
  if (FI^.Flag = []) or ((FI^.Flag * [CoreFile._F_ERR, CoreFile._F_OUT]) <> []) then
    begin
    FilBuf:= -1;
    goto 999
    end;
  if (CoreFile._F_EOF in FI^.Flag) then
    begin
    FilBuf := 0;
    goto 999
    end;
  if (CoreFile._F_RST in FI^.Flag) then
    FI^.Flag := FI^.Flag - [CoreFile._F_RST];
  if CRT then
    NumRead := PasDos.read(FI^.Handle, FI^.Base, FI^.Size)
  else
    NumRead := CoreIO._read(FI^.Handle, FI^.Base, FI^.Size);
  FI^.Ptr := FI^.Base;
  if (NumRead = -1) and (NumRead <> FI^.Size) then
    begin
    FI^.Flag := FI^.Flag + [CoreFile._F_ERR];
    FI^.Cnt := 0;
    FilBuf := -1;
    goto 999
    end;
  FI^.Cnt := NumRead;			  (* reset pointers *)
  FI^.Flag := FI^.Flag + [CoreFile._F_IN];         (* set input flag *)
  if NumRead = 0 then
    begin
    FI^.Flag := FI^.Flag + [CoreFile._F_EOF];      (* end of file *)
    CoreFile._openfd[FI^.Handle] := CoreFile._openfd[FI^.Handle] + [CoreIO._O_EOF];
    FilBuf := 0;
    goto 999
    end;
  FilBuf := NumRead;
999:
end ;


procedure ReadFileItem{(var f: filetype; var S: string[high]; CL: CHARSET)};

var
  c: char;
  i, L: int16;
label
  777;
begin
  i := 1;
  repeat
    begin
    if IsEof(f) then goto 777;
    c := (f.bufferptr:>CharPtr)^;
    get(f);
    end
    until not (c in Seps);
  if not (c in CL) then
    goto 777;
  L := high;
  while true do
    begin
    S[i] := c;
    i := i+1;
    if i > L then
      goto 777;
    c := (f.bufferptr:>CharPtr)^;
    if (not(c in CL)) then
      goto 777;
    get(f);
    end;
777:
  S.length := i - 1;
end ;

procedure ReadDeviceItem{(var f : filetype; var S: string[high]; CL: CHARSET)};
var
  c: char;
  i, L: int16;
label
  777;
begin
  i := 1;
  repeat
    begin
    get(f);
    c := (f.bufferptr:>CharPtr)^;
    end
    until not (c in Seps);
    L := high;
  while true do
    begin
    if ( not (c in CL)) then
      goto 777;
    S[i] := c;
    i := i+1;
    if i > L then
      goto 777;
    get(f);
    c := (f.bufferptr:>CharPtr)^;
    end;
777:
  S.length := i - 1;
end ;

procedure RdLn{(var f: filetype)};

begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  while not ((EOLinBuffer in f.state) or IsEOF(f)) do
    get(f);
  if not IsEOF(f) then
    get(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure WrLn{(var f: filetype)};

begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  (f.bufferptr:>CharPtr)^:= chr(0DH);
  put(f);
  (f.bufferptr:>CharPtr)^:= chr(0AH);
  put(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;


procedure Open{(var f: filetype; FMode: word)};

var
  fn: DosPathStr;
  H: int16;
  mode: bitset;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  SetIOR(0);
  StrToZ(f.name,fn);
  mode := [CoreIO.O_BINARY];
  if (FMode and 1) = 1 then
    mode := mode + [CoreIO.O_WRONLY]
  else if (FMode and 2) = 2 then
    mode := mode + [CoreIO.O_RDWR];
  H := CoreIO._pasopen(adr(fn), FMode);
  if H <> -1 then
    begin
    CoreFile._openfd[H] := mode;
    if CoreIO.isatty(H) <> 0 then
      begin
      CoreFile._openfd[h] := CoreFile._openfd[H] + [CoreIO.O_DEVICE];
      f.state := f.state + [Device]
      end
    end
  else
    ErrorCheck(2, 0, 'Open : ', (f.name:>namestring));
  f.handle := H;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure Create{(var f: filetype)};
var
  fn: DosPathStr;
  H: int16;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  SetIOR(0);
  StrToZ(f.Name, fn);
  H := CoreIO._pascreate(adr(fn));
  if H <> -1 then
    CoreFile._openfd[H] := [CoreIO.O_RDWR, CoreIO.O_BINARY]
  else
    ErrorCheck(5, 0, 'Create : ', (f.name:>namestring));
  f.handle := H;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure CloseFile{(var f: filetype)};
var
  BI: FileInf;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  SetIOR(0);
  Flush(f);
  BI := (f.stream:>FileInf);
  BI^.Flag := [];
  Paslib._deallocate(BI^.base, 0);
  CoreFile._openfd[f.handle] := [];
  if CoreIO._close(f.handle) = -1 then
    ErrorCheck(0, 0, 'Close : ', PasDos.NilStr);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure Reset{(var f : filetype)};

var
  dis: integer;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if (f.mode = wm) and (TextFile in f.state) and (not(EOLinBuffer in f.state)) then
    WrLn(f);
  Flush(f);
  CoreFile._openfd[f.handle] := CoreFile._openfd[f.handle] - [CoreIO._O_EOF];
  (f.stream:>FileInf)^.flag := (f.stream:>FileInf)^.flag - [CoreFile._F_EOF];
  f.state := f.state - [EOLinBuffer];
  dis := CoreIO.lseek(f.handle, 0, CoreIO.SEEK_SET);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

function  GetTempFileName{(var Name: namestring): boolean};

var
    n, p: int16;
    fn: DosPathStr;
label
    555, 999;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
    n:=length(Name)-8;
    if n < 0 then
      begin
      GetTempFileName := false;
      goto 999
      end;	
    p:=0;
    n := n+1;
    while p < 8 do		       (* append previous extension *)
      begin
      Name[n]:=LastTempExt[p+1];
      p := p+1;
      n := n+1
      end;
    n := n-5;
    p := 3;			       (* if yes increment counters *)
    repeat
      begin
      while true do
        begin
        if Name[n] < '9' then
          begin
          Name[n] := succ(Name[n]);
          LastTempExt[p+1] := succ(LastTempExt[p+1]);
          goto 555
          end;
        if p >= 0 then
          begin
          Name[n]:='0';
          n := n-1;
          LastTempExt[p+1]:='0';
          p := p-1
          end
        else
          begin
          GetTempFileName := false;
          goto 999
          end;
        end;
      end;
555:
      StrToZ(Name, fn);
      until CoreIO._exists(adr(fn)) = 0;
    GetTempFileName := true;
999:
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;


procedure CreateTemp{(var f: filetype)};

var
  h: int16;
begin
  f.name := 'PTMPXXXX.XXX';
  if GetTempFileName(f.name) then
    Create(f)
  else
    begin
    ErrorCheck(1FH, 0, 'CreateTemp : ', (f.name:>namestring));
    f.handle := -1
    end;
end;

procedure AssignBuffer{(var f: filetype)};

  function FindFreeStream: FileInf;

  var
    n: word;
  label
    999;
  begin
    n := 0;
(*%T _mthread *)
    PasProc.Lock;
(*%E *)
    while n < CoreFile._open_max do
      begin
      if CoreFile._iob[n].Flag = [] then
        begin
(*%T _mthread *)
        PasProc.Unlock;
(*%E *)
        FindFreeStream := (ADR(CoreFile._iob[n]):>FileInf);
        goto 999
        end;
      n := n+1
      end;
(*%T _mthread *)
    PasProc.Unlock;
(*%E *)
    FindFreeStream := nil;
999:
  end ;

var
  BI: FileInf;
  BufferSize: word;
label
  999;
begin
  SetIOR(0);
  BI := FindFreeStream;
  if f.objectsize > IOBufferSize then
    BufferSize := f.objectsize
  else
    BufferSize := ( IOBufferSize DIV f.objectsize)  * f.objectsize;
  if BI = nil then
    begin
    ErrorCheck(0BH, CoreIO.EMFILE, 'AssignBuffer : No Free Streams', PasDos.NilStr);
    goto 999
    end;
  Paslib._allocate(BI^.Ptr, BufferSize);
  if BI^.Ptr = nil then
    begin
    ErrorCheck(0BH, CoreIO.ENOMEM, 'AssignBuffer : Out Of Memory', PasDos.NilStr);
    BI^.Size := 0
    end
  else
    BI^.Size := BufferSize;
  BI^.Base := BI^.Ptr;
  f.bufferptr := BI^.Ptr;
  BI^.Cnt := 0;
  BI^.Pback := 0;
  BI^.Handle := f.handle;
  if (Device in f.state) then
    BI^.Flag := [CoreFile._F_DEV]
  else
    BI^.Flag := [];
  if (CoreIO.O_RDWR in CoreFile._openfd[f.handle]) or (CoreIO.O_WRONLY in CoreFile._openfd[f.handle]) then
    BI^.Flag := BI^.Flag + [CoreFile._F_READ, CoreFile._F_WRIT]
  else
    BI^.Flag := BI^.Flag + [CoreFile._F_READ];
  if (CoreIO.O_APPEND in CoreFile._openfd[f.handle]) then
    BI^.Flag := BI^.Flag + [CoreFile._F_APP];
  BI^.Flag := BI^.Flag + [CoreFile._F_BIN, CoreFile._F_UBUF, CoreFile._F_RST];
  f.stream := BI;
999:
end ;


function GetStreamPointer{(var f: filetype): FileInf};

begin
    GetStreamPointer := (f.stream:>FileInf);
end ;


procedure StrOut{(var f: filetype; var S; w: int; len: word)};

var
  count, lim, n: int16;
  Left: boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if w < 0 then
    begin
    Left := true;
    w := -w;
    end
  else
    Left := false;
  count := w-len;
  if not Left then
    while count > 0 do
      begin
      (f.bufferptr:>CharPtr)^ := ' ';
      put(f);
      count := count-1;
      end;
  n := 0;
  if w = 0 then
    w := maxint16;
  if w < len then
    lim := w
  else
    lim := len;
  while n < lim do
    begin
    (f.bufferptr:>CharPtr)^ := (S:>CharArray)[n];
    put(f);
    n := n+1;
    end;
  while count > 0 do                  (* count = 0 if right *)
    begin
    (f.bufferptr:>CharPtr)^ := ' ';
    put(f);
    count := count-1;
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure putback(var f: filetype);

var
  St: PasCore.FileInf;
  stat: int16;
  LAheadPtr: PasCore.CharPtr;
begin
  St := (f.stream:>PasCore.FileInf);
  St^.Cnt := St^.Cnt + 1;
  (St^.Ptr:>word) := (St^.Ptr):>word - 1;
  f.bufferptr := St^.Ptr;
end;

procedure InStr{(var f: filetype; var s: maxstring; len: word)};

var
  count: int16;
label
  555;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  count := 1;
  if not (Device in f.state) then
    begin
    while (count <= len) and (not((EOLinBuffer in f.state) or IsEOF(f))) do
      begin
      s[count] := (f.bufferptr:>CharPtr)^;
      get(f);
      count := count+1;
      end;
    end
  else
    begin
    while (count <= len) do
      begin
      get(f);
      if (count = 1) and ((EOLinBuffer in f.state) or IsEOF(f)) then
        begin
        putback(f);
        goto 555;
        end;
      s[count] := (f.bufferptr:>CharPtr)^;
      count := count+1;
      if (EOLinBuffer in f.state) or IsEOF(f) then
        goto 555;
      end;
    end;
555:
  s[0] := chr(count-1);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

function IsDevice{(var f: filetype): boolean};

begin
  IsDevice := CoreFile._F_DEV in (f.stream:>FileInf)^.Flag
end;

procedure CloseFiles;
var
  f: filetype;
begin
(*%F _WINDOWS *)
  Flush(PasLib._output);
  Flush(PasLib._input);
(*%E *)
  while lastfile <> nil do
    begin
      f.state := lastfile^.state;
      f.stream := lastfile^.stream;
      f.handle := lastfile^.handle;
      f.name := lastfile^.name;
      CloseFile(f);
      if TempFile in f.state then
        Erase(f);
      lastfile := lastfile^.next;
    end;
end;

begin
  Seps := [chr(9), chr(10), chr(13), chr(26), ' '];
  LastTempExt := '0000.$$$';
end .
