(* Release 3.00 *)
(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*# module(implementation=>off) *)
(*%F _fdata *)
(*# call(seg_name => null) *)
(*# data(seg_name => null) *)
(*%E *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT PasDos;

(*%F _OS2 *)
IMPORT  SPAWN, PasCore, CoreIO, CoreFile, CoreMath, CoreMain;
(*%E *)
(*%T _OS2 *)
IMPORT  SPAWN, PasCore, Dos, CoreIO, CoreFile, CoreMath, CoreMain, Kbd, Vio;
(*%E *)

procedure Terminate{(P : ProcType; VAR C: ProcType)}; in PasLow;
function  SetJmp{(VAR Lbl: LongLabel) : word}; in PasLow;
procedure LongJmp{(VAR Lbl: LongLabel; result: word)}; in PasLow;
function  LongToBcd{(A: real)  : PackedBcd}; in PasLow;
function  BcdToLong{(A: PackedBcd) : real}; in PasLow;
procedure harderr{(handler: HardHandler)}; in PasLow;
procedure hardresume{(code: word)}; in PasLow;
procedure hardretn{(code: word)}; in PasLow;
function  ProtectedMode{: boolean}; in PasLow;
procedure SetExitCode{(code: word)}; in PasLow;
function  GetInProgramFlag{: byte}; in PasLow;
procedure SetInProgramFlag{(f: byte)}; in PasLow;
procedure CpuId{(var r : CpuRec )}; in PasLow;

(*%F _OS2 *)
function  DosExitCode{: word}; in PasLow;
procedure Intr{(IntNo: byte; var Regs: Registers)};  in PasLow;
procedure MsDos{(var Regs: Registers)}; in PasLow;
(*%E *)

type
  A3 = array [0..2] of byte;
  StrType = array [byte] of char;
  StrPtr = ^StrType;
const
  Ln = A3(0DH, 0AH, 0);

(*%T _OS2 *)
var
  RCode: word;
(*%E *)
type
  CharArray = array [1..255] of char;
  CharArrayPtr = ^ CharArray;
  PathStr = array [0..80] of char;


(*%T _OS2 *)
procedure NotSupported;

begin
  RunTimeError(CoreSig._FatalErrorPos, 0FAH, 'OS2 Library: Function Not Supported');
end;

procedure MsDos{(var Regs: Registers)};

begin
  NotSupported;
end;

procedure Intr{(IntNo: int16; var Regs: Registers)};

begin
  NotSupported;
end;

(*%E *)

procedure WriteErrorString(var Err: string[high]);

var
  r: int16;
begin
    r := CoreIO._write(1, ((adr(Err[1])):>CoreFile.StreamPtr), length(err));
    r := CoreIO._write(1, ((adr(Ln)):>CoreFile.StreamPtr), 2)
end ;


function SysErrno{: word};

var
    EP: CoreSig.ErrnoPtr;
begin
    EP:=CoreSig._errno__;
    SysErrno := EP^ ;
end ;

procedure RunTimeErrorHandler(ErrAdd: integer; Code: word; Msg: string[high]);

begin
    WriteErrorString(Msg);
    CoreSig._FatalError(ErrAdd, Code);
end ;

function  ParamCount{: word};

begin
  ParamCount := CoreMain._argc-1;
end;

function  ParamStr{(index: word): maxstring};

var
  t: maxstring;
  n: word;
  c: char;
label
  555;
begin
  n := 0;
  if index < CoreMain._argc then
    begin
    while n < 255 do
      begin
      c := (CoreMain._argv[index]:>StrPtr)^[n];
      if c = chr(0) then
        goto 555;
      n := n + 1;
      t[n] := c;
      end;
555:
    end;
  t[0] := chr(n);
  ParamStr := t;
end;

function EnvCount{: integer};

var
  n: integer;
begin
  n := 0;
  while (CoreMain._env_var[n] <> nil) and ( n < 32) do
    n := n + 1;
  EnvCount := n;
end;

function EnvStr{(Index: integer): maxstring};

var
  s: maxstring;
  l: int16;
  cp: CharArrayPtr;
  c: char;
label
  555, 999;
begin
  cp := CoreMain._env_var[Index - 1];
  if (cp = nil) or ( Index >= 32) then
    begin
    EnvStr := NilStr;
    goto 999
    end
  else
    begin
    l := 1;
    while (l < 255) do
      begin
      c := cp^[l];
      if c = chr(0) then
        goto 555;
      s[l] := c;
      l := l + 1;
      end;
555:
    s[0] := chr(l - 1);
    EnvStr := s;
    end;
999:
end;

(*%F _OS2 *)
procedure Exec{( Path, Command: maxstring)};

var
    Params: array [0..2] of address;
    APath, ACommand: DosPathStr;
    d: int16;
begin
    d := CoreSig._seterrno(0);
    StrToZ(Path, APath);
    StrToZ(Command, ACommand);
    Params[0]:=ADR(APath);
    Params[1]:=ADR(ACommand);
    Params[2]:=nil;
    d := SPAWN._beget(ADR(APath), ADR(Params), nil, 1);
end;


procedure GetDate{(var Year, Month, Day, DayOfWeek: word)};

var
  R: Registers;
begin
  R.AH := 2AH;
  MsDos(R);
  Year := R.CX;
  Month := R.DH;
  Day := R.DL;
  DayOfWeek := R.AL;
end;

procedure SetDate{(Year, Month, Day : word)};

var
  R: Registers;
begin
  R.AH := 2BH;
  R.CX := Year;
  R.DH := Month;
  R.DL := Day;
  MsDos(R);
end;

procedure GetTime{(var Hour, Minute, Second, Hund: word)};

var
  R: Registers;
begin
  R.AH := 2CH;
  MsDos(R);
  Hour := R.CH;
  Minute := R.CL;
  Second := R.DH;
  Hund := R.DL;
end;

procedure SetTime{(Hour, Minute, Second, Hund: word)};

var
  R: Registers;
begin
  R.AH := 2DH;
  R.CH := Hour;
  R.CL := Minute;
  R.DH := Second;
  R.DL := Hund;
  MsDos(R);
end;
(*%E *)

(*%T _OS2 *)
procedure Exec{( Path, Command: maxstring)};

var
    Params: array [0..2] of address;
    APath, ACommand: DosPathStr;
begin
    StrToZ(Path, APath);
    StrToZ(Command, ACommand);
    Params[0]:=ADR(APath);
    Params[1]:=ADR(ACommand);
    Params[2]:=nil;
    RCode := SPAWN._beget(ADR(APath), ADR(Params), nil, 80H);
end;

function DosExitCode{: word};

begin
  DosExitCode := Rcode;
end;


procedure GetDate{(var Year, Month, Day, DayOfWeek: word)};

var
  D: Dos.DATE_TIME;
begin
  Dos.GetDateTime(D);
  Year := D.year;
  Month := D.month;
  Day := D.day;
  DayOfWeek := D.weekday;
end;

procedure SetDate{(Year, Month, Day : word)};

var
  D: Dos.DATE_TIME;
begin
  Dos.GetDateTime(D);
  D.year := Year;
  D.month := Month;
  D.day := Day;
  Dos.SetDateTime(D);
end;

procedure GetTime{(var Hour, Minute, Second, Hund: word)};

var
  D: Dos.DATE_TIME;
begin
  Dos.GetDateTime(D);
  Hour := D.hours;
  Minute := D.minutes;
  Second := D.seconds;
  Hund := D.hundredths;
end;

procedure SetTime{(Hour, Minute, Second, Hund: word)};

var
  D: Dos.DATE_TIME;
begin
  Dos.GetDateTime(D);
  D.hours := Hour;
  D.minutes := Minute;
  D.seconds := Second;
  D.hundredths := Hund;
  Dos.SetDateTime(D);
end;

(*%E *)

function GetEnv{(EnvVar: string): string};

var
  AVar: DosPathStr;
  s: maxstring;
  SPtr: address;
  l: int16;
  cp: CharArrayPtr;
  c: char;
label
  555;
begin
  StrToZ(EnvVar, AVar);
  Sptr := CoreMain.getenv(adr(AVar));
  if SPtr = nil then
    GetEnv := NilStr
  else
    begin
    cp := SPtr:>CharArrayPtr;
    l := 1;
    while (l < 255) do
      begin
      c := cp^[l];
      if c = chr(0) then
        goto 555;
      s[l] := c;
      l := l + 1;
      end;
555:
    s[0] := chr(l - 1);
    GetEnv := s;
    end;
end;

(*%T _OS2 *)

var
  nullp : Dos.SIGHANDLER;
  nullac : word;

procedure EnableBreakCheck;
var r : word;
begin
  r := Dos.SetSigHandler((0:>Dos.SIGHANDLER),nullp,nullac,0,Dos.SIG_CTRLC);
  r := Dos.SetSigHandler((0:>Dos.SIGHANDLER),nullp,nullac,0,Dos.SIG_CTRLBREAK);
end ;

procedure DisableBreakCheck;
var r : word;
begin
  r := Dos.SetSigHandler(nullp,nullp,nullac,1,Dos.SIG_CTRLC);
  r := Dos.SetSigHandler(nullp,nullp,nullac,1,Dos.SIG_CTRLBREAK);
end;

procedure Delay{(ms: word)};
var r : word;
begin
  r := Dos.Sleep(ms);
end ;

(*********************** Directory Control functions **************************)

procedure ChDir{(s: string[high])};

var
  n: DosPathStr;
  res: word;
begin
  SetIOR(0);
  StrToZ(s, n);
  if (s.length >= 2) and (s[2] = ':') then
    begin
    Caps(s);
    res := Dos.SelectDisk(ord(s[1]) - ord('A') + 1);
    if (res <> 0) and IOCheck then
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F9H, 'ChDir : Invalid Path');
    end;
  res := Dos.ChDir(n, 0);
  SetIOR(res);
  if (res <> 0) and IOCheck then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F9H, 'ChDir : Invalid Path');
end;

procedure GetDir{(d: byte; var s: string[high])};

var
  n, res, sz, drive: word;
  dnum: integer;
  t: packed array [0..79] of char;
begin
  sz := size(t);
  res := Dos.QCurDir(0, faradr(t), sz);
  if res <> 0 then
    SetIOR(res)
  else
    begin
    SetIOR(0);
    Dos.QCurDisk(drive, dnum);
    s[1] := chr(drive - 1 + ord('A'));
    s[2] := ':';
    s[3] := '\';
    n := 4;
    while (n <= high) and (t[n - 4] <> chr(0)) do
      begin
      s[n] := t[n - 4];
      n := n + 1;
      end;
    s.length := n - 1;
    end;
end;

procedure MkDir{(s: string[high])};

var
  n: DosPathStr;
  res: word;
begin
  SetIOR(0);
  StrToZ(s, n);
  res := Dos.MkDir(n, 0);
  SetIOR(res);
  if (res <> 0) and IOCheck then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F7H, 'MkDir : Invalid Path');
end;

procedure RmDir{(s: string[high])};

var
  n: DosPathStr;
  res: word;
begin
  StrToZ(s, n);
  res := Dos.RmDir(n, 0);
  SetIOR(res);
  if (res <> 0) and IOCheck then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F8H, 'RmDir : Invalid Path');
end;

procedure TransString(var S: SearchRec);

var
  n: word;
begin
  n := 0;
  while ord(S.Name[n]) <> 0 do
    n := n + 1;
  Move(S.Name[0], S.Name[1], n);
  S.Name[0] := chr(n);
end;

procedure FindFirst{(Path: string[high]; Attr: word; var S: SearchRec)};

begin
  NotSupported;
end;

procedure FindNext{(var S: SearchRec)};

begin
  NotSupported;
end;

function KeyPressed{: boolean} ;
var r : word ; k : Kbd.KEYINFO;
begin
   if LastChar = chr(0) then
     KeyPressed := true
   else
     begin
     k.kchar := 0C;
     k.scan := 0;
     k.nlsShift := 0;
     r := Kbd.Peek(k,0);
     KeyPressed := (k.scan<>0) or (k.kchar<>Chr(0));
     end;
end ;


function RdKey{: CHAR};
var k : Kbd.KEYINFO; r : word; c:char;
begin
  if LastChar = chr(0) then
    begin
    LastChar := chr(0FFH) ;
    RdKey := chr(LastScan) ;
    end
  else
    begin
    r := Kbd.CharIn( k,0,0 );
    if (k.kchar=chr(0E0H)) then k.kchar:=CHR(0);
    LastChar := k.kchar ;
    LastScan := k.scan ;
    RdKey := LastChar ;
    end;
end;

function  RdChar{: CHAR};
var r : word; C : char;
begin
  if LastChar = chr(0) then
    RdChar := RdKey
  else
    begin
    C := RdKey;
    if C<>CHR(0) then
      r := Vio.WrtTTY(C,1,0);
    RdChar := C ;
    end;
end ;

function KBFlags{: KBFlagSet} ;
var
  ks : Kbd.KBDINFO;
begin
  ks.b := size(ks);
  if Kbd.GetStatus(ks,0)=0 then
    KBFlags := (ks.state:>KBFlagSet)
  else
    KBFlags := (0:>KBFlagSet) ;
end ;


(*%E *)

(*%F _OS2 *)
procedure EnableBreakCheck;
begin
  CoreSig.EnableBreakCheck;
end ;


procedure DisableBreakCheck;
begin
  CoreSig.DisableBreakCheck;
end ;

procedure Delay{(ms: word)};
begin
  CoreIO.delay(ms);
end ;

var
  EnhancedBIOS : boolean ;


function KeyPressed{: boolean} ;

var
  R : Registers;
begin
   if LastChar = chr(0) then
     KeyPressed := true
   else
     begin
     R.AH := 1;
     if EnhancedBIOS then
       R.AH := 11H;
     Intr(16H, R);
     KeyPressed := (ZeroFlag and R.Flags) = 0 ;
     end ;
end ;

function RdKey{: CHAR};

var
  R : Registers;
begin
  if LastChar = chr(0) then
    begin
    LastChar := chr(0FFH) ;
    RdKey := chr(LastScan) ;
    end
  else
    begin
    if EnhancedBIOS then
      begin
      R.AH := 10H ;
      Intr(16H, R);
      if (R.AL=0E0H)and(R.AH<>0) then
        R.AL := 0;
      end
    else
      begin
      R.AH := 0 ;
      Intr(16H, R);
      end ;
    LastChar := chr(R.AL) ;
    LastScan := R.AH ;
    RdKey := LastChar ;
    end;
end ;



function RdChar{: CHAR};
(* reads and echoes char (if not extended) *)

var
  C : char ;
  R : Registers;
begin
  if LastChar = chr(0) then
    RdChar := RdKey
  else
    begin
    C := RdKey;
    if C<>CHR(0) then
      begin
      R.AH := 0AH;
      R.AL := ord(C);
      R.BH := 0;
      R.CX := 1;
      Intr(10H, R);
      end;
    RdChar := C ;
    end;
end ;

function KBFlags{: KBFlagSet} ;
var
  R: Registers;
begin
   R.AH := 2 ;
   Intr(16H, R);
   KBFlags := (R.AL:>KBFlagSet) ;
end ;

procedure BiosIOInit ;
var
  R : Registers ;
  i : word;
label
  555;
begin
  LastScan    := 0 ;
  LastChar    := chr(0FFH) ;
  EnhancedBIOS := false;
  (* Check for enhanced BIOS *)
  R.AX := 5FFH ;
  R.CX := 0FFFFH ;
  Intr(16H, R);     (* Put FFFF into Kbd buffer *)
  if R.AL=0 then
    begin
    i := 256 ;
    while true do
      begin
      R.AH := 11H ;
      Intr(16H, R);     (* And try and read it back *)
      if (ZeroFlag and R.Flags) <> 0 then
        goto 555;
      R.AH := 10H ;
      Intr(16H, R);     (* And try and read it back *)
      if (R.AX=0FFFFH) or (i=0) then
        goto 555;
      end ;
555:
    if R.AX=0FFFFH then
      EnhancedBIOS := TRUE ;
    end ;
end ;

(*********************** Directory Control functions **************************)

procedure ChDir{(s: string[high])};

var
  R: PasDos.Registers;
  n: DosPathStr;
begin
  StrToZ(s, n);
  if (s.length >= 2) and (s[2] = ':') then
    begin
    Caps(s);
    R.AH := 0EH ;
    R.DL := ord(s[1]) - ord('A');
    PasDos.MsDos(R);
    end;
  R.AH := 3BH;
  R.DX := Ofs(n);
  R.DS := Seg(n);
  PasDos.MsDos(R);
  if (R.Flags and 1) <> 0 then
    if not IOCheck then
      SetIOR(PasDos.SysErrno)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F9H, 'ChDir : Invalid Path')
  else
    SetIOR(0)
end;

procedure GetDir{(d: byte; var s: maxstring)};

var
  R: PasDos.Registers;
  n: word;
  t: packed array [0..79] of char;
begin
  R.AH := 47H;
  R.SI := Ofs((adr(t))^);
  R.DS := Seg(t);
  R.DL := d;
  PasDos.MsDos(R);
  if (R.Flags and 1) <> 0 then
    SetIOR(PasDos.SysErrno)
  else
    begin
    SetIOR(0);
    R.AH := 19H;
    PasDos.MsDos(R);
    s[1] := chr(R.AL + ord('A'));
    s[2] := ':';
    s[3] := '\';
    n := 4;
    while (n < high) and (t[n - 4] <> chr(0)) do
      begin
      s[n] := t[n - 4];
      n := n + 1;
      end;
    s[0] := chr(n - 1);
    end;
end;

procedure MkDir{(s: string[high])};

var
  R: PasDos.Registers;
  n: DosPathStr;
begin
  StrToZ(s, n);
  R.AH := 39H;
  R.DX := Ofs(n);
  R.DS := Seg(n);
  PasDos.MsDos(R);
  if (R.Flags and 1) <> 0 then
    if not IOCheck then
      SetIOR(PasDos.SysErrno)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F7H, 'MkDir : Invalid Path')
  else
    SetIOR(0)
end;

procedure RmDir{(s: string[high])};

var
  R: PasDos.Registers;
  n: DosPathStr;
begin
  StrToZ(s, n);
  R.AH := 3AH;
  R.DX := Ofs(n);
  R.DS := Seg(n);
  PasDos.MsDos(R);
  if (R.Flags and 1) <> 0 then
    if not IOCheck then
      SetIOR(PasDos.SysErrno)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F8H, 'RmDir : Invalid Path')
  else
    SetIOR(0)
end;

procedure TransString(var S: SearchRec);

var
  n: word;
begin
  n := 0;
  while ord(S.Name[n]) <> 0 do
    n := n + 1;
  Move(S.Name[0], S.Name[1], n);
  S.Name[0] := chr(n);
end;


procedure FindFirst{(Path: string[high]; Attr: word; var S: SearchRec)};

var
  p: DosPathStr;
  d: int16;
begin
  d := CoreSig._seterrno(0);
  StrToZ(Path, p);
  d := CoreIO._dos_findfirst(adr(p), Attr, S);
  if d = 0 then
    TransString(S)
  else
    S.name := '';
  SetIOR(d);
end;



procedure FindNext{(var S: SearchRec)};

var
  d: int16;
begin
  d := CoreSig._seterrno(0);
  d := CoreIO._dos_findnext(S);
  if d = 0 then
    TransString(S)
  else
    S.name := '';
  SetIOR(d);
end;

(*%E *)

procedure InstallFloatHandler{(H: FloatErrHandler)};

var
  R: CoreSig.SigProcType;
begin
  R := CoreSig.signal(8, H);
end;

begin
(*%F _OS2 *)
(*%F _WINDOWS *)
  BiosIOInit;
(*%E *)
(*%E *)
(*%T _OS2 *)
  LastScan    := 0 ;
  LastChar    := chr(0FFH) ;
(*%E*)
  NilStr[0] := chr(0);
(*%T _OS2 *)
  RCode := 0;
  nullp := (farnil:>Dos.SIGHANDLER);
  nullac := 0;
(*%E *)
  RunTimeError := RunTimeErrorHandler;
end .

