(* Release 3.00 *)
(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*%F _fdata *)
(*# call(seg_name => null) *)
(*# data(seg_name => null) *)
(*%E *)
(*# module(implementation=>off) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT Paslib;

IMPORT PasDos,PasCore,CoreMem,CoreIO,CoreFile,CoreSig,CoreMain,CoreMath (*%T _mthread *), PasProc, CoreProc (*%E *)(*%T _OS2 *), Dos(*%E *)(*%T _WINDOWS *), Windows(*%E *);


(*# save *)
(*%T _DLL *)
(*# call(seg_name=>PASLIBDLL) *)
(*%E *)
procedure HALT; in PasLow;
function  _setjump; in PasLow;
procedure _longjump; in PasLow;
procedure FillChar{(var x; count: word; ch)}; in PasLow;
procedure Move{(var source, dest; count: word)}; in PasLow;
function  ScanR{(var Dest; Count: word; Value: byte) : word};  in PasLow;
function  ScanL{(var Dest: Count: word; Value: byte) : word};  in PasLow;
function  ScanNeR{(var Dest: Count: word; Value: byte) : word}; in PasLow;
function  ScanNeL{(var Dest: Count: word; Value: byte) : word}; in PasLow;
function  Compare{(Source,Dest: address; Len: word) : word}; in PasLow;
function  CharPos{(Source: string[high]; c: char) : word}; in PasLow;
function  RCharPos{(Source: string[high]; c: char) : word}; in Paslow;
procedure Caps{(s1: string[high])}; in PasLow;
procedure Lows{(s1: string[high])}; in PasLow;
function  Pos{(substr, s: string[high]): byte}; in PasLow;
function  NextPos{(substr, s: string[high]; place: byte): byte}; in PasLow;
function  _strcompare; in paslow;
(*# restore *)

const
  Digits     = ['0' .. '9'];
  Signs      = [ '+', '-'];
  RealStuff  = ['.', 'e', 'E'];
  CharStuff  = ['a' .. 'Z'];
  TrueStr    = 'TRUE';
  FalseStr   = 'FALSE';
  IntChars   = Digits + Signs;
  RealChars  = Digits + Signs + RealStuff;
  StrChars   = CharStuff;


var
  IOR    : word;
(*%T _mthread *)
  IORArray: array [0..CoreProc.MaxProcess-1] of word;
(*%E *)

const
  StdFile = 0;
  EndOfLine = chr(0DH);
  Active = -2;


function _concat{(s1,s2:string255):string255};
var i,j:word;
begin
  i := 1;
  while (i<=255) and (i<=length(s1)) do
        begin
          _concat[i] := s1[i];
          i:= i+1;
        end;
  j :=1;
  while (i<=255) and (j<=length(s2)) do
        begin
           _concat[i] := s2[j];
           i:= i+1;
           j:=j+1;
        end;
  _concat[0]:= chr(i-1);
end;


(************************ Internal Memory functions ***************************)

procedure _allocate;

var
  Res: address;
label
  111;
begin
  if s = 0 then
    s := 2;
111:
(*%T _WINDOWS *)
(*%T _fptr *)
      Res := adr(CoreMem._fheaptop);
(*%E *)
(*%E *)
  if ClearOnAllocate then
(*%F _WINDOWS *)
      Res := CoreMem.calloc(1, s)
(*%E *)
(*%T _WINDOWS *)
      (Res:>Windows.HANDLE) := Windows.LocalAlloc(Windows.LMEM_FIXED+Windows.LMEM_ZEROINIT, s)
(*%E *)
  else
(*%F _WINDOWS *)
      Res := CoreMem.malloc(s);
(*%E *)
(*%T _WINDOWS *)
      (Res:>Windows.HANDLE) := Windows.LocalAlloc(Windows.LMEM_FIXED, s);
(*%E *)
  if Res = nil then
    case HeapError(s) of
      0 :
         PasDos.RunTimeError(CoreSig._FatalErrorPos, 34H, 'new: Out Of Memory');
      2 :
          goto 111;
      1 :
      end;
  p := Res;
end;

procedure _deallocate;
begin
    if p=nil then
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 35H, 'dispose: Invalid Pointer');
(*%F _WINDOWS *)
    CoreMem.free(p);
(*%E *)
(*%T _WINDOWS *)
    if Windows.LocalFree(p:>Windows.HANDLE) <> 0 then;
(*%E *)
    p:= nil;
end;


(********************************* I/O Extensions **************************)

procedure SetIOR{(code: word)};

var
  t: word;
begin
(*%T _mthread *)
  t := CoreProc._getTID;
  IORArray[t] := code;
(*%E *)
(*%F _mthread *)
  IOR := code;
(*%E *)
end;

function IOresult{(): word};
var
  t: word;
begin
(*%T _mthread *)
  t := CoreProc._getTID;
  IOresult := IORArray[t];
(*%E*)
(*%F _mthread *)
  IOresult := IOR;
(*%E*)
end ;

procedure Flush{(var f: filetype)};

var
  ret: int16;
  BI: PasCore.FileInf;
  Pos: integer;
label
  999;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  BI := (f.stream:>PasCore.FileInf);
  if (BI^.Flag = []) or (BI^.Flag * [CoreFile._F_ERR] <> []) then
    PasCore.ErrorCheck(8, 0, 'Flush : File Error', PasDos.NilStr)
  else if (CoreFile._F_OUT in BI^.Flag) then
    begin
    if (App in f.state) then
      PasCore.FindEOF(f);
    ret := PasCore.FlsBuf(BI, (Acrt in f.state));       (* flush output buffer *)
    if ret = -1 then
      PasCore.ErrorCheck(8, 0, 'Flush : Write Error', PasDos.NilStr)
    end
  else if (BI^.Flag * [CoreFile._F_DEV] = []) then
    begin
    Pos := CoreIO.tell(f.handle);                   (* input stream *)
    if BI^.Pback <> 0 then
      Pos := Pos-1;
    Pos := Pos-BI^.Cnt;
    Pos := CoreIO.lseek(f.handle, Pos, CoreIO.SEEK_SET);
    BI^.Ptr := BI^.Base;
    end;
  BI^.Pback := 0;                        (* reset buffer *)
  BI^.Cnt := 0;
  BI^.Flag := BI^.Flag + [CoreFile._F_RST];
  BI^.Flag := BI^.Flag - [CoreFile._F_OUT, CoreFile._F_IN];
  f.bufferptr := BI^.Base;
  f.state := f.state - [EOLinBuffer];
999:
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

function  FilePos{(var f): integer};

var
  BI: PasCore.FileInf;
  pos: integer;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if (not(initialized in f.state)) or (TextFile in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(107)
(*%E *)
(*%F _mthread *)
      IOR := 107
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F2H, 'FilePos : Invalid File')
  else
    begin
    BI := f.stream:>PasCore.FileInf;
    if f.mode = wm then
      Flush(f);
    pos := CoreIO.tell(f.handle);
    if not (CoreFile._F_RST in BI^.Flag) then
      begin
      if BI^.PBack <> 0 then
        pos := pos - 1;
      pos := pos - (BI^.Cnt + f.objectsize);
      end;
    FilePos := pos div f.objectsize;
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

function  FileSize{(var f): integer};

var
  save, size: integer;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if (not(initialized in f.state)) or (TextFile in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(107)
(*%E *)
(*%F _mthread *)
      IOR := 107
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F3H, 'FileSize : Invalid File')
  else
    begin
    Flush(f);
    save := CoreIO.tell(f.handle);
    size := CoreIO.lseek(f.handle, 0, 2);
    save := CoreIO.lseek(f.handle, save, 0);
    FileSize := size;
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure Seek{(var f; pos: integer)};

var
  dis: integer;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if (not(initialized in f.state)) or (TextFile in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(107)
(*%E *)
(*%F _mthread *)
      IOR := 107
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F4H, 'Seek : Invalid File')
  else
    begin
    Flush(f);
    pos := pos * f.objectsize;
    dis := CoreIO.lseek(f.handle, pos, 0);
    if (f.mode = rm) and (not (Device in f.state)) then
      get(f);
    end;
    f.state := f.state + [Seeked];
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure Erase{(var f: filetype)};

var
  fn : DosPathStr;
begin
(*%T _mthread *)
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  StrToZ(f.Name,fn);
  if(CoreIO.unlink(adr(fn)) = -1) then
    PasCore.ErrorCheck(0EH, 0, 'Erase : ', f.Name);
end ;

procedure PackTime{(var DT: DateTime; var Time: integer)};

var
  T: integer;
begin
  T := DT.Sec;
  T := T + (DT.Min << 5);
  T := T + (DT.Hour << 11);
  T := T + (DT.Day << 16);
  T := T + (DT.Month << 21);
  T := T + (DT.Year << 25);
  TIme := T;
end;

procedure UnpackTime{(Time: integer; var DT: DateTime)};

begin
  DT.Year :=  (Time and 0FE000000H) >> 25;
  DT.Month := (Time and 001E00000H) >> 21;
  DT.Day :=   (Time and 0001F0000H) >> 16;
  DT.Hour :=  (Time and 0F800H) >> 11;
  DT.Min :=   (Time and 007E0H) >> 5;
  DT.Sec :=   (Time and 0001FH);
end;


procedure Rename{(var f; newname: maxstring)};

var
  on: DosPathStr;
  nn: DosPathStr;
begin
  StrToZ(f.name, on);
  StrToZ(newname, nn);
  if CoreIO.rename(adr(on), adr(nn)) = -1 then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(PasDos.SysErrno)
(*%E *)
(*%F _mthread *)
      IOR := PasDos.SysErrno
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F5H, 'Rename : Invalid File')
  else
    begin
(*%T _mthread *)
    SetIOR(0);
(*%E *)
(*%F _mthread *)
    IOR := 0;
(*%E *)
    f.name := newname;
    end;
end;

(*%F _OS2 *)

function  Exists{(var f: filetype): boolean};

var
  R: PasDos.Registers;
  n: word;
begin
  if Assigned in f.state then
    begin
    n := length(f.name) + 1;
    f.name[n] := chr(0);
    R.AX := 4300H;
    R.DX := Ofs(f.name[1]);
    R.DS := Seg(f.name);
    PasDos.MsDos(R);
    Exists := ((R.Flags and 1) = 0);
    end
  else
    Exists := false;
end;

procedure Truncate{(var f)};

var
  Pos: integer;
  R: PasDos.Registers;
begin
  Pos := FilePos(f);
  Seek(f, Pos);
  R.AH := 40H;
  R.BX := f.handle;
  R.CX := 0;
  PasDos.MsDos(R);
  if (R.Flags and 1) <> 0 then
(*%T _mthread *)
    SetIOR(PasDos.SysErrno)
(*%E *)
(*%F _mthread *)
    IOR := PasDos.SysErrno
(*%E *)
  else
(*%T _mthread *)
    SetIOR(0);
(*%E *)
(*%F _mthread *)
    IOR := 0;
(*%E *)
end;


procedure GetFAttr{(var f; var Attr: word)};

var
  R: PasDos.Registers;
  d: int16;
begin
  d := CoreSig._seterrno(0);
  R.AH := 43H;
  R.AL := 0;
  R.DS := Seg((f:>filetype).name);
  R.DX := Ofs((f:>filetype).name);
  PasDos.MsDos(R);
  Attr := R.CX;
end;

procedure SetFAttr{(var f; Attr: word)};

var
  R: PasDos.Registers;
  d: int16;
begin
  d := CoreSig._seterrno(0);
  R.AH := 43H;
  R.AL := 1;
  R.DS := Seg((f:>filetype).name);
  R.DX := Ofs((f:>filetype).name);
  R.CX := Attr;
  PasDos.MsDos(R);
end;

procedure GetFTime{(var f; var Time: longint)};

var
  R: PasDos.Registers;
  d: int16;
begin
  d := CoreSig._seterrno(0);
  R.AH := 57H;
  R.AL := 0;
  R.BX := (f:>filetype).handle;
  PasDos.MsDos(R);
  Time := R.DX << 16;
  Time := Time + R.CX ;
end;

procedure SetFTime{(var f; Time: longint)};

var
  R: PasDos.Registers;
  d: int16;
begin
  d := CoreSig._seterrno(0);
  R.AH := 57H;
  R.AL := 1;
  R.BX := (f:>filetype).handle;
  R.DX := Time >> 16;
  R.CX := Time and maxword;
  PasDos.MsDos(R);
end;
(*%E *)

(*%T _OS2 *)

procedure GetFAttr{(var f; var Attr: word)};

var
  name: DosPathStr;
begin
  StrToZ((f:>filetype).name, name);
  CoreSig._seterrno(Dos.QFileMode(name, Attr, 0));
end;

procedure SetFAttr{(var f; Attr: word)};

var
  name: DosPathStr;
begin
  StrToZ((f:>filetype).name, name);
  CoreSig._seterrno(Dos.SetFileMode(name, Attr, 0));
end;

type
  FileInfoType = record
                   FileDate, FileTime, AccessDate, AccessTime, WriteDate, WriteTime: word;
                   FileSize, FileAlloc: integer;
                   Attrib: byte;
                 end;

procedure GetFTime{(var f; var Time: longint)};

var
  buf: FileInfoType;
begin
  CoreSig._seterrno(Dos.QFileInfo((f:>filetype).handle, 1, faradr(buf), size(buf)));
  Time := buf.FileDate << 16;
  Time := Time + buf.FileTime;
end;

procedure SetFTime{(var f; Time: longint)};

var
  buf: FileInfoType;
begin
  Dos.QFileInfo((f:>filetype).handle, 1, faradr(buf), size(buf));
  buf.FileDate := Time >> 16;
  buf.FileTime := Time and maxword;
  CoreSig._seterrno(Dos.SetFileInfo((f:>filetype).handle, 1, faradr(buf), size(buf)));
end;

function  Exists{(var f: filetype): boolean};

var
  at, n, res: word;
begin
  if Assigned in f.state then
    begin
    n := length(f.name) + 1;
    f.name[n] := chr(0);
    at := 0;
    res := Dos.QFileMode(f.name[1], at, 0);
    Exists := (res = 0);
    end
  else
    Exists := false;
end;


procedure Truncate{(var f)};

var
  Pos: integer;
begin
  Pos := FilePos(f);
(*%T _mthread *)
  SetIOR(Dos.NewSize(F.handle,Pos));
(*%E *)
(*%F _mthread *)
  IOR := Dos.NewSize(F.handle,Pos);
(*%E *)
end;

(*%E *)

(************************** Interface I/O functions ***************************)

procedure _wrint;
var
  s : convstring;
  OK : boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if (w < 0) and (IsoFormatting) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 36H, '_wrint: Illegal Parameter');
  IntToStr(i, s, 10, OK);
  if w < s.length then
    w := s.length;
  if OK then
    PasCore.StrOut(_output, s[1], w, s.length)
  else
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 37H, '_wrint: Conversion Error');
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _wrchar;
var
  s: string[1];
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 38H, '_wrchar: Illegal Parameter');
  s[1] := c;
  PasCore.StrOut(_output, s[1], w, 1);
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _wrbool;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 39H, '_wrbool: Illegal Parameter');
  if b then
    PasCore.StrOut(_output, adr(TrueStr)^, w, 4)
  else
    PasCore.StrOut(_output, adr(FalseStr)^, w, 5);
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _wrastr;

begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 3AH, '_wrastr: Illegal Parameter');
  PasCore.StrOut(_output, s, w, high-low+1);
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _wrcstr;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 3BH, '_wrcstr: Illegal Parameter');
  PasCore.StrOut(_output, s, w, l);
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _wrreal;
var
  OK, Left: boolean;
  l: word;
  s: string[32];
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if ((d < 1) and (d <> -29)) or ((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 3CH, '_wrreal: Illegal Parameter');
  if w < 0 then
    begin
    Left := true;
    w := -w;
    end
  else
    Left := false;
  RealToStr(r,d,w,s,OK);
  l := s.length;
  if OK then
    begin
    if w < l then
      w := l;
    if Left then
      w := -w;
    PasCore.StrOut(_output, s[1], w, l)
    end
  else
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 3DH, '_wrreal: Conversion Error');
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _wrln;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  PasCore.WrLn(_output);
  if PasCore.IsDevice(_output) then
    Flush(_output);
  _output.state := _output.state + [EOLinBuffer];
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _page;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  (_output.bufferptr:>PasCore.CharPtr)^ :=  chr(12);
  put(_output);
  if PasCore.IsDevice(_output) then
    Flush(_output);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrint;
var
  s : convstring;
  OK : boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if (w < 0) and (IsoFormatting) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 3EH, '_f_wrint: Illegal Parameter');
  IntToStr(i, s, 10, OK);
  if w < s.length then
    w := s.length;
  if OK then
    PasCore.StrOut(f, s[1], w, s.length)
  else
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 3FH, '_f_wrint: Conversion Error');
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrchar;
var
  s: packed array [0..0] of char;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 61H, '_f_wrchar: Illegal Parameter');
  s[0] := c;
  PasCore.StrOut(f, s, w, 1);
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrbool;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 62H, '_f_wrbool: Illegal Parameter');
  if b then
    PasCore.StrOut(f, adr(TrueStr)^, w, 4)
  else
    PasCore.StrOut(f, adr(FalseStr)^, w, 5);
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrastr;

begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 63H, '_f_wrastr: Illegal Parameter');
  PasCore.StrOut(f, s, w, high-low+1);
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrcstr;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 64H, '_f_wrcstr: Illegal Parameter');
  PasCore.StrOut(f, s, w, l);
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrreal;
var
  OK, Left: boolean;
  l: word;
  s: string[32];
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if ((d < 1) and (d <> -29)) or ((w < 0) and (IsoFormatting)) then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 65H, '_f_wrreal: Illegal Parameter');
  if w < 0 then
    begin
    Left := true;
    w := -w;
    end
  else
    Left := false;
  RealToStr(r,d,w,s,OK);
  l := s.length;
  if OK then
    begin
    if w < l then
      w := l;
    if Left then
      w := -w;
    PasCore.StrOut(f, s[1], w, l)
    end
  else
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 66H, '_f_wrreal: Conversion Error');
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrln;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  PasCore.WrLn(f);
  if PasCore.IsDevice(f) then
    Flush(f);
  f.state := f.state + [EOLinBuffer];
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_page;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  (f.bufferptr:>PasCore.CharPtr)^ :=  chr(12);
  put(f);
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_wrbin;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  Move(v, f.bufferptr^, f.objectsize);
  put(f);
  if PasCore.IsDevice(f) then
    Flush(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _rdint;
var
  S : string[80];
  OK: boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if CoreIO.O_DEVICE in CoreFile._openfd[_input.handle] then
    PasCore.ReadDeviceItem(_input, S, IntChars)
  else
    PasCore.ReadFileItem(_input, S, IntChars);
  i := StrToInt(S, 10, OK);
  if not OK then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(106)
(*%E *)
(*%F _mthread *)
      IOR := 106
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 67H, '_rdint : Invalid Integer');
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure _rdchar;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if Device in _input.state then
    begin
    get(_input);
    c := (_input.bufferptr:>PasCore.CharPtr)^;
    end
  else
    begin
    c := (_input.bufferptr:>PasCore.CharPtr)^;
    get(_input);
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _rdbool;
var S : string[80];
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if CoreIO.O_DEVICE in CoreFile._openfd[_input.handle] then
    PasCore.ReadDeviceItem(_input, S, StrChars)
  else
    PasCore.ReadFileItem(_input, S, StrChars);
  b := S = 'TRUE';
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure _rdstr{var s:maxstring;len:word};
var
    i:word;
    found:boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  PasCore.InStr(_input, s, len);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _rdreal;
var
  S : string[80];
  OK: boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if CoreIO.O_DEVICE in CoreFile._openfd[_input.handle] then
    PasCore.ReadDeviceItem(_input, S, RealChars)
  else
    PasCore.ReadFileItem(_input, S, RealChars);
  r := StrToReal(S, OK);
  if not OK then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(106)
(*%E *)
(*%F _mthread *)
      IOR := 106
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 68H, '_rdreal : Invalid Real Number');
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure _rdln;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  PasCore.RdLn(_input);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;


procedure _f_rdint;
var
  S : string[80];
  OK: boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if CoreIO.O_DEVICE in CoreFile._openfd[f.handle] then
    PasCore.ReadDeviceItem(f, S, IntChars)
  else
    PasCore.ReadFileItem(f, S, IntChars);
  i := StrToInt(S, 10, OK);
  if not OK then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(106)
(*%E *)
(*%F _mthread *)
      IOR := 106
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 69H, '_f_rdint : Invalid Integer');
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure _f_rdchar;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if Device in f.state then
    begin
    get(f);
    c := (f.bufferptr:>PasCore.CharPtr)^;
    end
  else
    begin
    c := (f.bufferptr:>PasCore.CharPtr)^;
    get(f);
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_rdbool;
var S : string[80];
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if CoreIO.O_DEVICE in CoreFile._openfd[f.handle] then
    PasCore.ReadDeviceItem(f, S, StrChars)
  else
    PasCore.ReadFileItem(f, S, StrChars);
  b := S = 'TRUE';
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end ;

procedure _f_rdstr{var s:maxstring;len:word};
var
    i:word;
    found:boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  PasCore.InStr(f, s, len);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_rdln;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  PasCore.RdLn(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_rdbin;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  move(f.bufferptr^,v,f.objectsize);
  get(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _f_rdreal;
var
  S: string[32];
  OK: boolean;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
(*%T _mthread *)
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if CoreIO.O_DEVICE in CoreFile._openfd[f.handle] then
    PasCore.ReadDeviceItem(f, S, RealChars)
  else
    PasCore.ReadFileItem(f, S, RealChars);
  r := StrToReal(S, OK);
  if not OK then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(106)
(*%E *)
(*%F _mthread *)
      IOR := 106
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 6AH, '_f_rdreal : Invalid Real Number');
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;


procedure assign;
begin
  if not (Initialized in f.state) then
    begin
    if length(name) = 0 then
      f.name := 'CON'
    else
      f.name := name;
    f.state := f.state + [Assigned];
    end
  else
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 6BH, 'assign: File Already Open');
end;

procedure flushstdout; (* closedown procedure when no files used *)
var
  ret: int16;
  BI: PasCore.FileInf;
begin
  BI := (PasLib._output.stream:>PasCore.FileInf);
  if (CoreFile._F_OUT in BI^.Flag) then
    ret := PasCore.FlsBuf(BI, (Acrt in PasLib._output.state));       (* flush output buffer *)
  BI^.Flag := BI^.Flag - [CoreFile._F_OUT];
  BI^.Pback := 0;                        (* reset buffer *)
  BI^.Cnt := 0;
  BI^.Flag := (BI^.Flag + [CoreFile._F_RST]) - [CoreFile._F_OUT, CoreFile._F_IN];
end;


var
  cdp: Procedure;  (* closedown procedure *)

procedure linkfile(t:PasCore.oftp);
begin
  t^.next := PasCore.lastfile;
  PasCore.lastfile := t;
  cdp := PasCore.CloseFiles;
end;

procedure _rewrite;
var
  t: PasCore.oftp;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if Initialized in f.state then
    close(f);
  if Assigned in f.state then
    begin
    PasCore.Create(f);
    f.state := f.state + [Initialized];
    end
  else if not (ACrt in f.state) then
    begin
    PasCore.CreateTemp(f);
    f.state := f.state + [Initialized, TempFile];
    end;
  f.objectsize := rs;
  if IsText then
    f.state := f.state + [TextFile];
  if not (ACrt in f.state) then
    PasCore.AssignBuffer(f)
  else
    PasDos.AssignBuffer(f, true);
  new(t);
  t^.handle := f.handle;
  t^.state := f.state;
  t^.stream := f.stream;
  t^.name := f.name;
  linkfile(t);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
  f.mode := wm;
end;

procedure _append;
var
  t: PasCore.oftp;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  if Initialized in f.state then
    close(f);
  if (Assigned in f.state) and (IsText) then
    begin
    PasCore.Open(f, 2);
    f.state := f.state + [Initialized, App, TextFile];
    f.objectsize := rs;
    PasCore.AssignBuffer(f);
    new(t);
    t^.handle := f.handle;
    t^.state := f.state;
    t^.stream := f.stream;
    t^.name := f.name;
    linkfile(t);
    f.mode := wm;
    end
  else
    if not IOCheck then
(*%T _mthread *)
      SetIOR(102)
(*%E *)
(*%F _mthread *)
      IOR := 102
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F6H, 'Append: File Not Assigned');
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _reset;
var
  t: PasCore.oftp;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if not (Initialized in f.state) then
    begin
    if not(Assigned in f.state) then
      if not IOCheck then
(*%T _mthread *)
        SetIOR(102)
(*%E *)
(*%F _mthread *)
        IOR := 102
(*%E *)
      else
        PasDos.RunTimeError(CoreSig._FatalErrorPos, 6CH, 'reset: No File Name');
    if not (ACrt in f.state) then
      PasCore.Open(f, FileMode);
    f.state := f.state + [Initialized];
    f.objectsize := rs;
    if not (ACrt in f.state) then
      PasCore.AssignBuffer(f)
    else
      PasDos.AssignBuffer(f, false);
    if IsText then
      f.state := f.state + [TextFile];
    new(t);
    t^.handle := f.handle;
    t^.state := f.state;
    t^.name := f.name;
    t^.stream := f.stream;
    linkfile(t);
    end
  else if not (ACrt in f.state) then
    PasCore.Reset(f);
  f.mode := rm;
  if not  (Device in f.state) then
    get(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure put;
var
  St: PasCore.FileInf;
  Stat: int16;
  Pos: Integer;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if not (Initialized in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(103)
(*%E *)
(*%F _mthread *)
      IOR := 103
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0EBH, 'put: File Undefined');
  St := (f.stream:>PasCore.FileInf);
  if Seeked in f.state then
    begin
    if f.mode = rm then
      begin
      Pos := CoreIO.tell(f.handle);                   (* input stream *)
      Pos := Pos-St^.Cnt-f.objectsize;
      Pos := CoreIO.lseek(f.handle, Pos, CoreIO.SEEK_SET);
      St^.Cnt := 0;
      St^.Flag := St^.Flag + [CoreFile._F_RST];
      St^.Flag := St^.Flag - [CoreFile._F_OUT, CoreFile._F_IN];
      St^.Ptr := St^.Base;
      f.mode := wm;
      end;
    f.state := f.state - [Seeked];
    end;
  if f.mode <> wm then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(105)
(*%E *)
(*%F _mthread *)
      IOR := 105
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 6DH, 'put: Invalid Mode');
  f.state := f.state - [EOLinBuffer];
  f.bufferptr := St^.Ptr;
  Stat := Active;
  if St^.Cnt = 0 then
    begin
    if (not (ACrt in f.state)) and (App in f.state) then
      PasCore.FindEOF(f);
    Stat := PasCore.FlsBuf(St, (Acrt in f.state));
    if (Stat = -1) or (Stat = 0) then
      if not IOCheck then
(*%T _mthread *)
        SetIOR(101)
(*%E *)
(*%F _mthread *)
        IOR := 101
(*%E *)
      else
        PasDos.RunTimeError(CoreSig._FatalErrorPos, 6EH, 'put: Write Error');
    f.bufferptr := St^.Base;
    end;
  if Stat = Active then
    begin
    (St^.Ptr:>word) := (St^.Ptr):>word + f.objectsize;
    f.bufferptr := St^.Ptr;
    St^.Cnt := St^.Cnt - f.objectsize;
    if St^.Cnt = 0 then
      begin
      if (not (ACrt in f.state)) and (App in f.state) then
        PasCore.FindEOF(f);
      Stat := PasCore.FlsBuf(St, (Acrt in f.state));
      if (Stat = -1) or (Stat = 0) then
        if not IOCheck then
(*%T _mthread *)
          SetIOR(101)
(*%E *)
(*%F _mthread *)
          IOR := 101
(*%E *)
        else
          PasDos.RunTimeError(CoreSig._FatalErrorPos, 6FH, 'put: Write Error');
      f.bufferptr := St^.Base;
      end;
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure _bindfile{(f:filetype;n:word)};
var
  name: namestring;
begin
  if (n < CoreMain._argc) and (CoreMain._argv[n] <> nil) then
    begin
    PasCore.sptr_to_string(name, CoreMain._argv[n]);
    assign(f, name);
    end;
end ;


procedure get;

var
  St: PasCore.FileInf;
  stat: int16;
  LAheadPtr: PasCore.CharPtr;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if not (Initialized in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(103)
(*%E *)
(*%F _mthread *)
      IOR := 103
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0ECH, 'get: File Undefined');
  if Seeked in f.state then
    begin
    f.mode := rm;
    f.state := f.state - [Seeked];
    end;
  if f.mode <> rm then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(104)
(*%E *)
(*%F _mthread *)
      IOR := 104
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E1H, 'get: Invalid Mode');
  St := (f.stream:>PasCore.FileInf);
  if (CoreFile._F_EOF in St^.flag) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(100)
(*%E *)
(*%F _mthread *)
      IOR := 100
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E2H, 'get: End Of File')
  else
    begin
    f.bufferptr := St^.Ptr;
    f.state := f.state - [EOLinBuffer];
    St^.Cnt := St^.Cnt - f.objectsize;
    if St^.Cnt < 0 then
      begin
      stat := PasCore.FilBuf(St, (Acrt in f.state));
      if stat < 0 then
        PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E3H, 'get: Read Error');
      f.bufferptr := St^.Base;
      St^.Cnt := St^.Cnt - f.objectsize;
      end
    else
      begin
      (St^.Ptr:>word) := (St^.Ptr):>word + f.objectsize;
      f.bufferptr := St^.Ptr;
      end;
    if (TextFile in f.state) then
      begin
      if (Device in f.state) then
        begin
          LAheadPtr := f.bufferptr;
          (LAheadPtr:>word) := (LAheadPtr:>word)+1;
          if (St^.Cnt <> 0) and (LAheadPtr^ = chr(0DH)) then
            f.state := f.state + [EOLinBuffer];
        end;
      if (f.bufferptr:>PasCore.CharPtr)^ = chr(0DH) then
        get(f)
      else if (f.bufferptr:>PasCore.CharPtr)^ = chr(0AH) then
        begin
        (f.bufferptr:>PasCore.CharPtr)^ := ' ';
        f.state := f.state + [EOLinBuffer]
        end;
      end;
    end;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

procedure simpleget(var f:filetype);

var
  St: PasCore.FileInf;
  stat: int16;
  LAheadPtr: PasCore.CharPtr;
begin
  St := (f.stream:>PasCore.FileInf);
  f.bufferptr := St^.Ptr;
  f.state := f.state - [EOLinBuffer];
  St^.Cnt := St^.Cnt - f.objectsize;
  if St^.Cnt < 0 then
    begin
    stat := PasCore.FilBuf(St, (Acrt in f.state));
    f.bufferptr := St^.Base;
    St^.Cnt := St^.Cnt - f.objectsize;
    end
  else
    begin
    (St^.Ptr:>word) := (St^.Ptr):>word + f.objectsize;
    f.bufferptr := St^.Ptr;
    end;
  if (f.bufferptr:>PasCore.CharPtr)^ = chr(0DH) then
    simpleget(f)
  else if (f.bufferptr:>PasCore.CharPtr)^ = chr(0AH) then
    begin
    (f.bufferptr:>PasCore.CharPtr)^ := ' ';
    f.state := f.state + [EOLinBuffer]
    end;
end;



procedure close;
var
  t, prev: PasCore.oftp;
label
  999;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if not (Initialized in f.state) then
    if not IOCheck then
      begin
(*%T _mthread *)
      SetIOR(103);
(*%E *)
(*%F _mthread *)
      IOR := 103;
(*%E *)
      goto 999;
      end
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E4H, 'close: Invalid Operation');
  if (f.mode = wm) and (TextFile in f.state) and (not(EOLinBuffer in f.state)) then
    PasCore.WrLn(f);
  if not (Acrt in f.state) then
    PasCore.CloseFile(f);
  if TempFile in f.state then
    Erase(f);
  if Assigned in f.state then
    f.state := [Assigned]
  else
    f.state := [];
  t := PasCore.lastfile;
  prev := PasCore.lastfile;
  while t <> nil do
    begin
      if t^.handle = f.handle then
        begin
          if t = PasCore.lastfile then
            PasCore.lastfile := t^.next
          else
            prev^.next := t^.next;
          dispose(t);
          goto 999;
        end;
      prev := t;
      t := t^.next;
    end;
999:
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;


var
  oc: PasDos.ProcType;

procedure closedown;
begin
  cdp;
  oc;
end;


function  _eoln;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if PasCore.IsEOF(_input) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(100)
(*%E *)
(*%F _mthread *)
      IOR := 100
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E5H, 'eoln: End Of File');
  _eoln := EOLinBuffer in _input.state;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

function  _f_eoln;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if not (Initialized in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(103)
(*%E *)
(*%F _mthread *)
      IOR := 103
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E6H, 'eoln: Invalid File');
  if PasCore.IsEOF(f) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(100)
(*%E *)
(*%F _mthread *)
      IOR := 100
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E7H, 'eoln: End Of File');
  _f_eoln := EOLinBuffer in f.state;
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;


function  _eof;
begin
(*%T _mthread *)
  PasProc.Lock;
(*%E *)
  _eof := PasCore.IsEOF(_input);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;

function  _f_eof;
begin
(*%T _mthread *)
  PasProc.Lock;
  SetIOR(0);
(*%E *)
(*%F _mthread *)
  IOR := 0;
(*%E *)
  if not (Initialized in f.state) then
    if not IOCheck then
(*%T _mthread *)
      SetIOR(100)
(*%E *)
(*%F _mthread *)
      IOR := 100
(*%E *)
    else
      PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E8H, 'eof: Invalid Operation')
  else
    _f_eof := PasCore.IsEOF(f);
(*%T _mthread *)
  PasProc.Unlock;
(*%E *)
end;


procedure InitStandardFile(var f: filetype; h: int16; m: ifilemode);

begin
  f.handle  := h;
  f.state := [Initialized, TextFile];
  f.mode := m;
  f.stream := adr(CoreFile._iob[h]);
  f.bufferptr := CoreFile._iob[h].Base;
  f.objectsize := 1;
  if CoreIO.O_DEVICE in CoreFile._openfd[h] then
    f.state := f.state + [Device]
  else if m = rm then
    simpleget(f);
end;

(***************************** Math functions *********************************)

type
  a = record
        f1:0..255;
        p:address;
      end;

function ln{r:longreal:longreal};
begin
  if r <= 0.0 then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0E9H, 'ln: Illegal Parameter');
  ln := CoreMath.logl(r);
end;

function log10{r:longreal:longreal};
begin
  log10 := CoreMath.log10l(r);
end;

function pow{x, y:longreal:longreal};
begin
  pow := CoreMath.powl(x, y);
end;

function sin{r:longreal:longreal};
begin
  sin := CoreMath.sinl(r);
end;

function cos{r:longreal:longreal};
begin
  cos := CoreMath.cosl(r);
end;

function exp{r:longreal:longreal};
begin
  exp := CoreMath.expl(r);
end;

function sqrt{r:longreal:longreal};
begin
  if r < 0 then
    PasDos.RunTimeError(CoreSig._FatalErrorPos, 0EAH, 'sqrt: Illegal Parameter');
  sqrt := CoreMath.sqrtl(r);
end;

function arctan{r:longreal:longreal};
begin
  arctan := CoreMath.atanl(r);
end;

function frac{r:longreal:longreal};
var
  dummy: longreal;
begin
  frac := CoreMath.fmodl(r, dummy);
end;

function sqr{r:longreal:longreal};

begin
  sqr := r*r;
end ;

function   arccos{(x: longreal): longreal};

begin
  arccos := CoreMath.acosl(x);
end;

function   arcsin{(x: longreal): longreal};

begin
  arcsin := CoreMath.asinl(x);
end;

function   arctan2{(x: longreal; y: longreal): longreal};

begin
  arctan2 := CoreMath.atan2l(x, y);
end;

function   cosh{(x: longreal): longreal};

begin
  cosh := CoreMath.coshl(x);
end;

function   sinh{(x: longreal): longreal};

begin
  sinh := CoreMath.sinhl(x);
end;

function   tanh{(x: longreal): longreal};

begin
  tanh := CoreMath.tanhl(x);
end;

function   tan{(x: longreal): longreal};


begin
  tan := CoreMath.tanl(x);
end;

function   frexp{(x: longreal; var expo: int16): longreal};

begin
  frexp := CoreMath.frexpl(x, expo);
end;


function   hypot{(x, y: longreal): longreal};

begin
  hypot := CoreMath.hypotl(x, y);
end;



(************************* Random Number functions ***************************)

const
  HistoryMax = 54;
var
  HistoryPtr : word;
  LowerPtr   : word;
var
  History    : array [0..HistoryMax] of word;

procedure SetUpHistory(Seed: word);

var
  x : integer;
  i : word;
begin
  RandSeed := Seed;
  HistoryPtr := HistoryMax;
  LowerPtr := 23;
  x := Seed;
  i := 0;
  repeat
    x := (x*3141592621+17);
    History[i] := x div 10000H;
    i := i + 1;
  until i>HistoryMax;
end ;

function random{(range: word): word};

var
  res: word;
begin
  if HistoryPtr = 0 then
    if LowerPtr = 0 then
      SetUpHistory(12345)
    else
      begin
      HistoryPtr := HistoryMax;
      LowerPtr   := LowerPtr-1;
      end
  else
    begin
    HistoryPtr := HistoryPtr-1;
    if LowerPtr = 0 then
      LowerPtr := HistoryMax
    else
      LowerPtr := LowerPtr-1;
    end;
  res := History[HistoryPtr]+History[LowerPtr];
  History[HistoryPtr] := res;
  random :=  res mod Range;
end;

(*%F _OS2 *)
procedure randomize;

var
  R : PasDos.Registers;
begin
  R.AH := 2CH;
  PasDos.MsDos(R);
  SetUpHistory(R.DX+R.CX);
end;
(*%E *)
(*%T _OS2 *)
procedure randomize;

var
  D: Dos.DATE_TIME;
begin
  Dos.GetDateTime(D);
  SetUpHistory(D.seconds + D.hundredths);
end;
(*%E *)

(*********************** Memory Allocation functions **************************)

procedure FreeMem{(var p: address; size: word)};

begin
(*%F _WINDOWS *)
  CoreMem.free(p);
(*%E *)
(*%T _WINDOWS *)
  if Windows.LocalFree(p:>Windows.HANDLE) <> 0 then;
(*%E *)
  p := nil;
end;


procedure GetMem{(var p: address; size: word)};

var
  Res: address;
label
  111;
begin
  if size = 0 then
    size := 2;
111:
(*%T _WINDOWS *)
(*%T _fptr *)
  Res := adr(CoreMem._fheaptop);
(*%E *)
(*%E *)
(*%F _WINDOWS *)
  Res := CoreMem.malloc(size);
(*%E *)
(*%T _WINDOWS *)
  (Res:>Windows.HANDLE) := Windows.LocalAlloc(Windows.LMEM_FIXED, size);
(*%E *)
  if Res = nil then
    case HeapError(size) of
      0 :
         PasDos.RunTimeError(CoreSig._FatalErrorPos, 0F1H, 'GetMem: Out Of Memory');
      2 :
          goto 111;
      1 :
      end;
  p := Res;
end;

function  MaxAvail{: integer};

var
  av: integer;
begin
(*%T _fptr *)
(*%F _OS2 *)
  av := CoreMem._fblockavail;
  if av < 4 then
    av := 0
  else
    av := av - 4;
  MaxAvail := av;
(*%E *)
(*%T _OS2 *)
  MaxAvail := 07FFFFFFFH;
(*%E *)
(*%E *)
(*%F _fptr *)
  av := CoreMem._memmax;
  if av < 3 then
    av := 0
  else
    av := av - 3;
  MaxAvail := av;
(*%E *)
end;

function  MemAvail{: integer};

begin
(*%T _fptr *)
  MemAvail := CoreMem.farcoreleft;
(*%E *)
(*%F _fptr *)
  MemAvail := CoreMem.nearcoreleft;
(*%E *)
end;


(************************* Error Handling functions **************************)

function HeapErrorHandler(size: word): int16;


begin
  HeapErrorHandler := 0;
end;

(************************* String Handling functions **************************)

type
  BA = array [0..1] of byte;
  ConvIntType = array ['0'..'F'] of byte;
  A3 = array [0..2] of byte;
const
  DivCon  = BA(0,4);
  ConvStr = '0123456789ABCDEF';
  ConvInt = ConvIntType( 0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15);

type
  CharArray = array [1..255] of char;
  CharArrayPtr = ^ CharArray;

procedure ConvertArrayToString(cs: array [low..high: int16] of char; t: address);

var
    p: PasCore.StrPtr;
begin
    Move(cs, t^, high);
    p := t;
    p^[high] := chr(0);
end;


procedure CheckBase(var b: word);
begin
  if b < 2  then b := 2;
  if b > 16 then b := 16;
end ;

procedure Reverse(var s: string[high]);
var
  T : char;
  h, l : word;
begin
  h := length(s);
  if s[1] = '-' then
    l := 2            (* leading sign / space *)
  else
    l := 1;
  while l < h do
    begin
    T := s[l];
    s[l] := s[h];
    s[h] := T;
    l := l+1;
    h := h-1;
    end
end ;

procedure IntToStr{(V: integer; var S: string[high]; Base: word; var OK: boolean)};
var
  i : word;
  b   : integer;
label 555;
begin
  OK := TRUE;
  CheckBase(Base);
  b := Base::integer;
  i := 1;
  if V < 0 then
    begin
    S[i] := '-';
    V := -V;
    i := i+1;
    end;
  while true do
  begin
    if i > high then
      begin
      OK := FALSE;
      goto 555;
      end;
    S[i] := ConvStr[ (V MOD b)+1 ];
    i := i+1;
    V := V DIV b;
    if V = 0 then goto 555
  end;
555:
  s[0] := chr(i-1);
  Reverse(s);
end ;


function StrToCI(var S: string[high]; Base: word; var OK: boolean) : integer;
var
  i,l   : word;
  b,t,y : integer;
  c     : char;
  x     : byte;
begin
  OK := true;
  CheckBase( Base );
  b := Base;
  i := 1;
  l := S.length;
  if (S[i] = '-') or (S[i] = '+') then
    i := i+1;
  t := 0;
  if i = l+1 then OK := FALSE;
  while (i <= l) do
    begin
    c := S[i];
    if (c < '0') or (c > 'F') then OK := FALSE;
    x := ConvInt[c];
    if (x > b-1 ) or (t > (MAX(integer)-x) DIV b) then OK := FALSE;
    t := t*b+x;
    i := i+1;
    end;
  StrToCI := t;
end ;


function StrToInt{(var S: string[high]; Base: word; var OK: boolean) : integer};
var
  t : integer;
label
  999;
begin
  OK := TRUE;
  t  := StrToCI(S,Base,OK);
  if t > 7FFFFFFFH then OK := FALSE;
  if S[1] = '-' then
    begin
    StrToInt := -t;
    goto 999
    end
  else
    begin
    StrToInt := t;
    goto 999
    end;
999:
end ;

function StrToReal{(var S: string[high]; var OK: boolean) : longreal};
var
  c,expsign : char;
  exp,after : int16;
  i, l      : word;
  res,p10   : longreal;
  Neg       : boolean;
const
  Zero = 0.0;
label 999;
begin
  OK  := TRUE;
  i := 1;
  l := S.length;
  if l = 0 then
    begin
    OK := FALSE;
    goto 999;
    end;
  c   := S[i];
  Neg := FALSE;
  if c = '+' then
    i := i+1
  else
    begin
    if c = '-' then
    begin
      i := i+1;
      Neg := TRUE
    end
    end;
  res := 0.0;
  c := S[i];
  while (c <> '.') and (i <= l) do
    begin
    if (c > '9') or (c < '0') then
      begin
      c := '.' ;
      i := i-1
      end
    else
      begin
      res := res * 10.0 + ord(c) - ord('0');
      i := i+1;
      c := S[i]
      end
    end;
  after := 0;
  i := i+1;
  c := S[i];
  while ( i <= l ) and ( c <> 'E' ) do
    begin
    if ( c > '9' ) or ( c < '0' ) then
      begin
      OK := FALSE;
        StrToReal := Zero;
        goto 999
      end;
    res := res * 10.0 + ord(c) - ord('0');
    i := i+1;
    after := after+1;
    c := S[i];
  end;
  if c = 'E' then
    begin
    i := i+1;
    expsign := S[i];
    if expsign = '+' then
      i := i+1
    else if expsign = '-' then i := i+1;
    c := S[i];
    exp := 0;
    while i <= l do
      begin
      if ( c > '9' ) or ( c < '0' ) then
        begin
        OK := FALSE;
        StrToReal := Zero;
        goto 999
        end;
      exp := exp*8 + exp*2 + ( ord(c) - ord('0') );
      i := i+1;
      c := S[i];
    end;
    if expsign = '-' then exp := -exp
  end
  else
    exp := 0;
  exp := exp - after;
  p10 := 1.0;
  for i := 1 to abs(exp) do
    p10 := p10 * 10.0;
  if Neg then res := -res;
  if exp < 0 then
    StrToReal := res / p10
  else
    StrToReal := res * p10;
999:
end ;

procedure RealCvt(x: longreal; n: int16; var dec: int16; var sign: boolean;
                  var buf: packed array [low..high: int16] of char);
var
  bcd: packed array [0..9] of char;
  zero, norm: longreal;
  i,k, nc: int16;
  tmp: char;
label
  555;
begin
  zero := 0.0;
  if  x < zero then
    begin
    x := -x;
    sign := true;
    end
  else
    sign := false;

  if  x = zero then
    k := -10000
  else
    k := 1 + trunc(CoreMath.floor( CoreMath.log10(x) + 0.001 ));

  while true do
    begin
    norm := x;
    if  k <> -10000 then
      norm := norm * CoreMath._pow_int(10.0, 18-k);
    CoreMath._bcd( norm, nearadr(bcd));

    if k = -10000 then
      begin
      k := 1;
      goto 555;
      end;
    if ((bcd[8]:>byte) >> 4 ) <>0  then
      goto 555;
    k := k - 1;
    end;
555:
  dec := k;
  i := 8;
  nc := low;
  while n > 1 do
    begin
    tmp := bcd[i];
    i := pred(i);
    buf[nc+1] := chr(ord('0') + (ord(tmp) and 15));
    buf[nc] := chr(ord('0') + ((tmp:>byte) >> 4));
    nc := nc + 2;
    n := n - 2;
    end;
  if n <> 0 then
    begin
    tmp := bcd[i];
    buf[nc] := chr(ord('0') + (tmp:>byte) >> 4);
    end;
end;

procedure InsertStr(var S: string[high]; pos: int16);

var
  cur: int16;
begin
  cur := high - 1;
  while cur >= pos do
    begin
    S[cur+1] := S[cur];
    cur := cur - 1;
    end;
  S[pos] := '1';
  S.length := S.length + 1;
end;


procedure RealToStr{(RN: longreal; Digits: int16; var Width: int16;
                   var S: string[high];
                   var OK: boolean)};

var
  np, nq: int16;
  tl: word;
  extemp: convstring;
  out_str: packed array [1..18] of char;
  t, round: char;
  dec: int16;
  EXP, sign: boolean;
  fd, r, l: int16;
  noround, tzeros: boolean;
  prec: int16;
label
  555, 777, 888;
begin
    OK := true;
    np := 1;
    nq := 1;
    if Digits = -29 then
      begin
      EXP := true;
      if Width = 0 then
        Width := 14;
      prec := Width - 8;
      if prec < 1 then
        prec := 1;
      end
    else
      begin
      EXP := false;
      prec := Digits;
      end;
    RealCvt(RN, 18, dec, sign, out_str);
    if sign then
      begin
      S[np] := '-';
      np := np+1;
      end
    else if EXP then
      begin
      S[np] := ' ';
      np := np+1;
      end;
    fd := np;

    if EXP then
      begin
      EXP := true;		
      S[np] := out_str[nq];         (* get first digit and decimal point *)
      S[np+1] := '.';
      np := np + 2;
      nq := nq + 1;
      end
    else
      begin
      EXP := false;
      if dec <= 0 then               (* if negative exponent pad *)
        begin
        S[np] := '0';
        np := np + 1;
        r := dec;
        S[np] := '.';
        np := np + 1;
        while r < 0 do
          begin
          prec := prec - 1;
          if prec < 0 then
            begin
            nq := -1;
            goto 555;
            end;
          S[np] := '0';
          r := r + 1;
          np := np+1;
          end;
555:
        end
      else                           (* positive exponent *)
        begin
        r:= dec;
        while r > 0 do
          begin
	  t := out_str[nq];
	  nq := nq + 1;
	  if nq > 17 then
            t := '0';
          S[np] := t;
          np := np + 1;
          r := r - 1;
          end;
        S[np] := '.';
        np := np + 1;
        end;
      end;
(***************************************************************************
*   This paragraph copies the digits to the right of the decimal point     *
*   to the limit of precison, padding with 0s if necessary.                *
***************************************************************************)

    noround := false;
    tzeros := true;
    while prec > 0 do
      begin
      if nq > 17 then
        begin
        noround := true;
        goto 777;
        end;
      S[np] := out_str[nq];
      np := np + 1;
      nq := nq + 1;
      prec := prec - 1;
      end;
777:
    if prec > 0 then
      begin                                 (* pad to precision if necessary *)
      noround := true;
      while prec > 0 do
        begin
	S[np] := '0';
	prec:= prec - 1;
	np:= np + 1;
        end;
      end;
(***************************************************************************
*   This paragraph rounds the copied number if any digits remain unused.   *
***************************************************************************)

    if nq <> -1 then
      begin
      round := out_str[nq];
      if( not noround) and ((round >= '0') and (round <= '9')) then     (* round if any digits remain *)
        begin
        r := np-1;
        if round >= '5' then
          begin
          while r >= fd-1 do
            begin
            if S[r] = '.' then	   (* skip decimal point *)
              r := r - 1;
            S[r] := chr(ord(S[r]) + 1);
            if S[r] > '9' then
              begin
              S[r] :='0';
              r := r - 1;
              end
            else
              goto 888;                 (* no carry *)
            if r < fd then
              begin
              if EXP then	   (* handle high order carry *)
                begin
                S[r+1] := '1';
                dec := dec + 1;
                end
              else
                begin
                InsertStr(S, fd);
  	      np := np + 1;
                end;
              goto 888;
              end;
            end;
  888:
          end;
        end;
      end;
(***************************************************************************
*   If required, this paragraph converts the exponent to ASCII string and  *
*   copies it to the target buffer.                                        *
***************************************************************************)

    if EXP then
      begin
      S[np] :='E';
      np := np + 1;
      dec := dec - 1;
      if dec < 0 then
        begin
        S[np] := '-';
        dec := abs(dec)
        end
      else
        S[np] :='+';
      np := np + 1;
      IntToStr(dec, extemp, 10, OK);
      l := length(extemp);
      r := 3 - l;
      if r < 0  then
        begin
        r := 0;
        OK := false;
        end;
      tl := 3 - r;
      while r <> 0 do
        begin
        S[np] := '0';
        r := r - 1;
        np := np + 1;
        end;
      r := 1;
      while r <= tl do
        begin
        S[np] := extemp[r];
	np := np + 1;
	r  := r + 1;
	end;
      end;
    S.length := np - 1;
    if EXP then
      Width := np - 1;
end;

procedure Insert{(source: string[highs]; var s: string[hight]; index: word)};

var
  sl, dl, mnum, mpos, ht : word;
begin
  dl := s.length;
  sl := source.length;
  ht := hight;
  if index>dl then index := dl+1;
  if (index <> 0) and (index <= ht) and (sl<>0) then
    begin
    if sl>ht-index+1 then sl := ht-index+1;
    mpos := index + sl;
    mnum := dl - index + 1;
    if mpos+mnum > ht+1 then
      mnum := ht+1 - mpos;
    if mnum>0 then
      Move(s[index], s[mpos], mnum);
    Move(source[1], s[index], sl);
    s.length := index-1+sl+mnum;
    end;
end;


function  Copy{(s: string[high]; index: word; count: word): maxstring};

var
  i, l, r, n: word;
  rs: maxstring;
begin
  l := length(s);
  n := 1;
  if (index <> 0) and (count <> 0) and (l >= index) then
    begin
    i := index - 1;
    r := l - i;
    if r < count then
      count := r;
    while n <= count do
      begin
      rs[n] := s[i + n];
      n := n + 1;
      end;
    end;
  rs[0] := chr(n - 1);
  Copy := rs;
end;

procedure Delete{(var s: string[high]; index: word; count: word)};

var
  l: word;
  mpos: word;
begin
  l := length(s);
  if (index <> 0) and (index <= l) and (l <> 0) then
    begin
    if index + count > l then
      s[0] := chr(index-1)
    else
      begin
      mpos := index + count;
      Move(s[mpos], s[index], l - mpos + 1);
      s[0] := chr(l - count);
      end;
    end;
end;

function  Match{(Source: string[highs]; Pattern: string[highp]) : boolean};

  function  Rmatch(var s: string[highs]; i: word;
                   var p: string[highp]; j: word) : boolean;

   (* s = to be tested ,    i = position in s *)
   (* p = pattern to match ,j = position in p *)

  var
    matched    : boolean;
    k, ls, lp  : word;
  label
    999;
  begin
    lp := p.length;
    if lp = 0 then
      begin
      Rmatch := true;
      goto 999;
      end;
    ls := s.length;
    while true do
      begin
      if (i > ls) and (j > lp) then
        begin
        Rmatch := true;
        goto 999;
        end
      else if (j > lp) then
        begin
        Rmatch := false;
        goto 999;
        end
      else if (p[j] = '*') then
        begin
        k := i;
        if (j >= lp) then
          begin
          Rmatch := true;
          goto 999;
          end
        else
          begin
          while true do
            begin
            matched := Rmatch(s,k,p,j+1);
            if matched or (k > ls) then
              begin
              rmatch := matched;
              goto 999;
              end;
            k := k + 1;
            end;
          end
        end
      else if ((p[j]='?') and (i <= ls)) or (cap(p[j]) = cap(s[i])) then
        begin
        i := i + 1;
        j := j + 1;
        end
      else
        begin
        rmatch := false;
        goto 999;
        end;
     end;
999:
   end ;

begin
  Match := Rmatch(Source,1,Pattern,1);
end;

procedure StrToZ{(name: string[high]; var fn: array of char)};

var
  l: word;
begin
  l:=length(s);
  if l > size(fn) then
    l := 0
  else
    Move(s[1], fn, l);
  fn[l+low] := chr(0);
end ;



begin
  IOCheck := TRUE;
  PasCore.lastfile := nil;
  FileMode := 2;
(*%T _mthread *)
  IORArray[1] := 0;
(*%E *)
(*%T _mthread *)
  IOR := 0;
(*%E *)
  HeapError := HeapErrorHandler;
  IsoFormatting := true;
  IOBufferSize := DefaultBufferSize;
(*%F _WINDOWS *)
  InitStandardFile(_input, 0, rm);
  InitStandardFile(_output, 1, wm);
(*%E *)
  ClearOnAllocate := false;
  cdp := flushstdout;
  PasDos.Terminate(closedown,oc);
end .

