(* Release 3.00 *)

(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*%F _fdata *)
(*# call(seg_name => null) *)
(*# data(seg_name => null) *)
(*%E *)
(*# module(implementation=>off) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)


IMPLEMENTATION UNIT PasPMD;

(*%F _OS2 *)
IMPORT CoreSig, CoreIO, CoreMain;
(*%E *)
(*%T _OS2 *)
IMPORT Dos, CoreSig, CoreIO, CoreMain;
(*%E *)

type SegHeader = record
        frame: word;
        SegSize: word;
        FilePos: integer;
        BucketSizes: array [0..15] of word;
     end;

(*%T _OS2 *)
    SelInfo = record
        selector, size: word;
    end;

const
    MAX_SELS = 256;
var
    selectors: array [0..MAX_SELS] of SelInfo;
(*%E *)

type
    PathStr = packed array [0..128] of char;
var
    ErrMsg, DumpName: namestring;

(*%T _OS2 *)
function  Os2Write(handle: word; buffer: faraddress; count: word): word;

var
    NumWrit: word;
begin
    if Dos.Write(handle, buffer, count, NumWrit) = 0 then
        Os2Write := NumWrit
    else
        Os2Write := maxword;
end ;

function  GetSelectors: word;

var
    CurSel: word;
    attempt, size: word;
label
    999;
begin
    CurSel:=0;
    attempt:=0FH;
    while attempt <> 0FFFFH do
        begin
        size := CorePMD.lsl(attempt);
        if size <> 0 then
            begin
            selectors[CurSel].size:=size+1;
            selectors[CurSel].selector:=attempt;
            CurSel := CurSel + 1;
            if CurSel = MAX_SELS then
                goto 999;
            end;
         attempt := attempt + 10H;
         end;
    attempt:=07H;
    while attempt <> 0FFF7H do
        begin
        size := CorePMD.lsl(attempt);
        if size <> 0 then
            begin
            selectors[CurSel].size:=size+1;
            selectors[CurSel].selector:=attempt;
            CurSel := CurSel + 1;
            if CurSel = MAX_SELS then
                goto 999;
            end;
         attempt := attempt + 10H;
         end;
    GetSelectors := CurSel;
999:
end ;

function WriteStruct(var State: ProcessState; fh: int16): int16;

begin
    if Os2Write(fh, FarADR(State), SIZE(ProcessState)) <> SIZE(ProcessState) then
        WriteStruct := -1
    else
        WriteStruct := 0;
end ;
(*%E *)

(*%F _OS2 *)
function WriteStruct(var State: ProcessState; fh: int16): int16;

begin
    if CoreIO._write(fh, ADR(State), SIZE(ProcessState)) <> SIZE(ProcessState) then
        WriteStruct := -1
    else
        WriteStruct := 0;
end ;
(*%E *)

function  compress(var header: SegHeader; fh: int16): int16;

var
    SegSize, Source: integer;
    offset: word;
    OutSize, BucketNo, BucketSize, NumWritize, NumWrit: word;
label
    999;
begin
    SegSize:= header.SegSize;
    if SegSize = 0 then
        SegSize:=10000H;
    offset:=0;
    BucketNo:=0;
    while SegSize > 0 do
        begin
        if SegSize > 1000H then
            OutSize:=1000H
        else
            OutSize:= SegSize;
        Source := header.frame;
        Source := (Source<<16)+offset;
        BucketSize:= CorePMD._Pack(OutSize, (Source):>faraddress);
        header.BucketSizes[BucketNo]:=BucketSize;
(*%F _OS2 *)
        if CoreIO._dos_write(fh, FarADR(CorePMD._p), BucketSize, NumWrit) <> 0 then
(*%E *)
(*%T _OS2 *)
        if Os2Write(fh, FarADR(CorePMD._p), BucketSize) <> BucketSize then
(*%E *)
            begin
            compress := -1;
            goto 999;
            end;
        SegSize := SegSize - 1000H;
        offset := offset + 1000H;
        BucketNo := BucketNo + 1;
        end;
    compress := 0;
999:
end ;

(*%F _OS2 *)
procedure WriteCore(fh: int16; top, bottom: word);

var
    h: SegHeader;
    TotalParas: word;
    Segment: word;
    SegTotal: word;
    SegNum: word;
    NumToWrite: word;
    dis: integer;
label
    555;
begin
    Segment:=bottom;
    SegNum:=0;
    TotalParas:=top-bottom;
    SegTotal:=(TotalParas+0FFFH) DIV 01000H;
    dis := CoreIO.lseek(fh, SIZE(ProcessState)+SIZE(word)+(SIZE(SegHeader)*SegTotal)-1, 0);
    CoreIO._write(fh, ADR(Segment), 1);
    while true do
        begin
        if TotalParas = 0 then
            goto 555;
        h.frame:=Segment;
        if TotalParas < 1000H then
            NumToWrite:=TotalParas
        else
            NumToWrite:= 1000H;
        h.SegSize:=NumToWrite<<4;
        h.FilePos:=CoreIO.lseek(fh, 0, 2);
        if compress(h, fh) = -1 then
            begin
            SegTotal:=0;
            goto 555;
            end;
        dis := CoreIO.lseek(fh, (SIZE(ProcessState)+SIZE(word)+SIZE(SegHeader)*SegNum), 0);
        SegNum := SegNum + 1;
        CoreIO._write(fh, ADR(h), SIZE(SegHeader));
        Segment := Segment + NumToWrite;
        TotalParas := TotalParas - NumToWrite;
        end;
555:
    dis := CoreIO.lseek(fh, (SIZE(ProcessState)), 0);
    CoreIO._write(fh, ADR(SegTotal), SIZE(word));
end ;

procedure _PMDbody{(var state: ProcessState)};

type
    A2 = array [0..1] of char;
var
    dis, fh: int16;
    Ln: A2;
    DN: array [0..80] of char;
begin
    Ln[0]:= chr(0DH);
    Ln[1]:= chr(0AH); (* NB *)
    if CoreMain._argc <> 0 then
        Move(CoreMain._argv[0]^, state.ProgName, size(state.ProgName));
    StrToZ(DumpName, DN);
    fh:=CoreIO._creat_trunc(adr(DN), 0);
    if fh >= 0 then
        begin
        dis := CoreIO._write(2, ADR(ErrMsg), Length(ErrMsg));
        dis := CoreIO._write(2, ADR(Ln), 2);
        if WriteStruct(state, fh) = 0 then
            WriteCore(fh, state.TopLim, state.PSP);
        dis := CoreIO._close(fh);
        end;
end ;
(*%E *)

(*%T _OS2 *)
procedure WriteCore(fh: int16);

var
    h: SegHeader;
    Segment, SegTotal: word;
    dis: integer;
label
    555;
begin
    Segment:=0;
    SegTotal:=GetSelectors;
    dis := CoreIO.lseek(fh, ((SIZE(ProcessState)+SIZE(word)+(SIZE(SegHeader)*SegTotal))-1), 0);
    dis := Os2Write(fh, FarADR(Segment), 1);
    while true do
        begin
        if Segment = SegTotal then
            goto 555;
        h.frame:=selectors[Segment].selector;
        h.SegSize:=selectors[Segment].size;
        h.FilePos:=CoreIO.lseek(fh, 0, 2);
        if compress(h, fh) = -1 then
            begin
            SegTotal:=0;
            goto 555;
            end;
        dis := CoreIO.lseek(fh, (SIZE(ProcessState)+SIZE(word)+SIZE(SegHeader)*Segment), 0);
        dis := Os2Write(fh, FarADR(h), SIZE(SegHeader));
        Segment := Segment + 1;
        end;
555:
    dis := CoreIO.lseek(fh, (SIZE(ProcessState)), 0);
    dis := Os2Write(fh, FarADR(SegTotal), SIZE(word));
end ;

procedure _PMDbody{(var state: ProcessState)};

type
    A2 = array [0..1] of char;
var
    dis, fh: word;
    action: word;
    Ln: A2;
    DN: array [0..80] of char;
begin
    Ln[0]:= chr(0DH);
    Ln[1]:= chr(0AH); (* NB *)
    if CoreMain._argc <> 0 then
        Move(CoreMain._argv[0]^, state.ProgName, size(state.ProgName));
    StrToZ(DumpName, DN);
    if Dos.Open(DN, fh, action, 0,
                0, 012H, 012H, 0) = 0 then
        begin
        dis := Os2Write(2, FarADR(ErrMsg[1]), Length(ErrMsg));
        dis :=  Os2Write(2, FarADR(Ln), 2);
        if WriteStruct(state, fh) = 0 then
            WriteCore(fh);
        dis := CoreIO._close(fh);
        end;
end ;
(*%E *)

procedure UserFatalError{(ErrorCode: word)};

begin
    CoreSig._FatalError(CoreSig._FatalErrorPos, ErrorCode);
end ;


begin
    includePMD:=1;
    ErrMsg := 'Runtime Error - Creating PM_DUMP.$$$';
    DumpName := 'PM_DUMP.$$$';
end.

