(* Release 3.00 *)
(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*# module(implementation=>off) *)
(*%F _fdata *)
(*# call(seg_name => null) *)
(*# data(seg_name => null) *)
(*%E *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT PasRed;

IMPORT PasLib, PasCore, PasDos, CoreIO, CoreMain(*%T _OS2 *), Dos (*%E *);

type
   StrArray = array [0..1024] of char;
   StrPtr  = ^ PathStr ;
   OpenMode = ( OMopen, OMcreate, OMopenrw ) ;

const
  StrTabSize = 1024 ;
  StrTabMax  = StrTabSize-1 ;

var
  StrTab      : ARRAY [0..StrTabMax] OF CHAR ;
  FilesBase   : word ;
  NoOfStrings : word ;
  LastDelPtr  : word ;
  StrTabPtr   : word ;

const
   MaxNoOfConversions = 50 ;


var
   NoOfConversions : word ;
   Conversion      : ARRAY[1..MaxNoOfConversions] OF word ;
   IOR             : word ;


function  ZLen(s : array[low..high: int16] of char ) : word;

var
  L: word;
begin
  L := 0;
  while s[L] <> 0C do
    L := L + 1;
  Zlen := L;
end;

function  AddText(s : array[low..high: int16] of char ) : word;

var
  len : word ;
  p   : word ;
label
  999;
begin
  len := Zlen(s);
  if (len+StrTabPtr+1 >= size(StrTab)) then
    begin
    AddText := 0 ;
    goto 999;
    end;
  p := StrTabPtr ;
  Move(s,StrTab[StrTabPtr],len) ;
  StrTabPtr := StrTabPtr + len ;
  StrTab[StrTabPtr] := 0C ;
  StrTabPtr := StrTabPtr + 1 ;
  AddText := p ;
999:
end ;


const
  FileBuffSize = 4096 ;
  FileBuffMax  = FileBuffSize-1 ;

type
  FileBuffPtr  = ^char ;
var
  FileBuff     : FileBuffPtr ;
  FileBuffBase : FileBuffPtr ;

function  OpenTextFile ( name : PathStr) : boolean ;
var
  s  : PathStr ;
  fb : FileBuffPtr ;
  os : DosPathStr;
label
  999;
begin
  StrToZ(name, os);
  TextFile := CoreIO._pasopen(adr(os), 0) ;
  if TextFile = -1 then
    begin
    OpenTextFile := false;
    goto 999;
    end;
  PasLib._allocate(fb, FileBuffSize+1) ;
  FileBuffBase := fb ;
  FileBuff := fb ;
  (FileBuff:>word) := (FileBuff:>word) + FileBuffSize;
  OpenTextFile := true ;
999:
end ;




procedure ReadTextLn ( var l : array[low..high: int16] of char) ;

var
  c : char ;
  i : word ;

function  ReadTextChar: char ;

var
  count : word ;
  fbp   : FileBuffPtr ;
begin
  (FileBuff:>word) := (FileBuff:>word) + 1;
  if (FileBuff:>word) - (FileBuffBase:>word) >= FileBuffSize then
    begin
    FileBuff := FileBuffBase;
    count := CoreIO._read(TextFile,FileBuff,FileBuffSize) ;
    if count<>FileBuffSize then
      begin
      fbp := FileBuffBase;
      (fbp:>word) := (fbp:>word) + count ;
      fbp^ := chr(26) ;
      end ;
    end ;
  ReadTextChar := FileBuff^ ;
end ;

label
  555;
begin
   i := low ;
   FileBuff := FileBuff ;
   repeat (* clear LFs *)
     if (FileBuff:>word) - (FileBuffBase:>word) >= FileBuffMax then
       c := ReadTextChar
     else
       begin
       (FileBuff:>word) := (FileBuff:>word) + 1;
       c := FileBuff^ ;
       end ;
   until c <> chr(10) ;
   if c = chr(26) then
     begin
     l[0] := c ;
     i := i + 1 ;  (* check for EOF *)
     end
   else
     begin
     while true do
       begin
       if (c >= ' ') and (i< high) then
         begin
         l[i] := c ;
         i := i + 1 ;
         end
       else if (c = CHR(13)) or (c=CHR(26)) then
         goto 555;  (* EOF treated as end of line *)
       if (FileBuff:>word) - (FileBuffBase:>word) >= FileBuffMax then
         c := ReadTextChar
       else
         begin
         (FileBuff:>word) := (FileBuff:>word) + 1;
         c := FileBuff^ ;
         end ;
       end ;
     end ;
555:
   l[i] := 0C ;
end ;

procedure CloseTextFile ;

begin
  if TextFile <> -1 then
    CoreIO._close(TextFile) ;
  Paslib._deallocate(FileBuffBase, FileBuffSize+1) ;
end ;

(*%F _OS2 *)
function  DosCall ( var R : PasDos.Registers ) : boolean ;
begin
  PasDos.MsDos(R) ;
  if 1 and R.Flags = 0 then
    DosCall := true
  else
    DosCall := false;
end ;
(*%E *)

function  GetDosVersion: word;

begin
  GetDosVersion := CoreMain._osmajor;
end ;


procedure ExpandPath{(path : PathStr; var fullpath : PathStr)} ;

VAR
  i,p,l : word ;
  c     : char ;
  hp    : word ;
  lim   : word ;
  R     : PasDos.Registers ;
  ps    : string[14];
  po    : PathStr;
  plen  : word;
(*%T _OS2 *)
  drive, Lt: word;
  map: integer;
(*%E *)
label
  555, 777, 999;
BEGIN
  plen := path.length;
  if (plen < 2) or (path[2] <> ':') then
    begin
(*%F _OS2 *)
    R.AH := 19H ;
    PasDos.MsDos(R) ;
    po[1] := chr(ord('A')+R.AL) ;
(*%E *)
(*%T _OS2 *)
    Dos.QCurDisk(Drive, Map);
    po[1] := chr(ord('A')+Drive-1) ;
(*%E *)
    p := 1 ;
    end
  else
    begin
    po[1] := CAP(path[1]) ;
    p := 3 ;
    end ;
  po[2] := ':' ;
  po[3] := '\' ;
  if path[p] <> '\' then
    begin
(*%F _OS2 *)
    R.DL := ord(po[1])-ord('A')+1 ;
    R.DS := Seg(po) ;
    R.SI := Ofs(po[4]) ;
    R.AH := 47H ;
    if DosCall(R) then
      begin
      po[0] := 0C ;
      goto 999 ;
      end ;
(*%E *)
(*%T _OS2 *)
    Drive := ord(po[1])-ord('A')+1 ;
    Lt := 77;
    Dos.QCurDir(Drive, FarADR(po[4]), Lt);
(*%E *)
    i := 1;
    while po[i] <> 0C do
      i := i + 1;
    if (i > 3) then
      po[i] := '\' ;
    end
  else
    begin
    i := 3 ;
    p := p + 1 ;
    end ;
  po[0] := chr(i);
  while true do
    begin
    i := 1 ;
    lim := 8 ;
    while true do
      begin
      if (p > 254 ) then
        begin
        ps[i] := '\' ;
        i :=  i + 1;
        goto 555;
        end ;
      c := path[p] ;
      p :=  p + 1 ;
      if (p > (plen+1)) or (c='\') then
        begin
        ps[i] := '\' ;
        i :=  i + 1;
        goto 555;
        end;
      if (c = '.') then
        begin
        ps[i] := c   ;
        i := i + 1;
        lim := 3;
        end
      else if (lim > 0) then
        begin ps[i] := c   ;
        i := i + 1;
        lim := lim - 1;
        end ;
      end ;
555:
    ps.length := i - 1 ;
    if (i > 1) then
      begin
      if ps[1] = '.' then                    (* .. = parent *)
        begin
        if (i = 4)and (ps[2]='.') then
          begin
          l := po.length - 1 ;
          if l > 2 then
            while (po[l-1] <> '\') do
              l :=  l - 1;
          po[0] := chr(l-1) ;
          end
        else if i>3 then
           po := po + ps;
        end
      else
         po := po + ps;
      end ;
    if P > plen then
      goto 777;
  end ;
777:
  l := po.length ;
  IF (l > 3) and (po[l] = '\') then
    po[0] := chr(l-1);
  fullpath := po ;
  Caps(fullpath) ;
999:
end ;

function  AbsolutePath ( name : PathStr) : boolean ;
begin
  AbsolutePath := (name[1]='\')or(name[2]=':');
end ;

procedure SplitPath{(path : PathStr ; var head,tail : PathStr)} ;

var
  L : word ;
  c : char ;
  i : word ;
label
  555;
begin
   i := path.length ;
   while true do
     begin
     if (i=0) then
       goto 555;
     i := i - 1 ;
     c := path[i] ;
     if (c='\') then
       goto 555;
     if (c=':') then
       begin
       i := i + 1 ;
       goto 555
       end ;
     end ;
555:
   head := Copy(path,1,i) ;
   if c='\' then
     i := i + 1 ;
   tail := Copy(path,i,size(PathStr)) ;
   Caps(head) ;
   Caps(tail) ;
end ;

procedure MakePath{( var path : PathStr ; head,tail : PathStr )};
var
  l : word ;
begin
  ExpandPath(head,path);
  l := path.length ;
  if (path[l]<>'\') then
    begin
    if (tail[1]<>'\') then
      begin
      path[l+1] := '\' ;
      path.length := path.length + 1 ;
      end ;
    end
  else if (tail[1]='\') then
    path.length := path.length - 1 ;
  path := path + tail;
  ExpandPath(path,path) ;
end ;

function  ExtensionPos(var s : PathStr) : word ;

var
  c : char ;
  l,i : word ;
begin
  l := s.length;
  if l=0 then
    ExtensionPos := maxword
  else
    begin
    i := l ;
    repeat
      c := s[i] ;
      i :=  i - 1 ;
    until (i=0) or (c='\') or (c=':') or (c='.') ;
    if (c='.') then
      ExtensionPos :=  i
    else
      ExtensionPos := maxword ;
    end;
end ;


procedure AddExtension{(var s : PathStr ; ext : ExtStr )};

begin
  if ExtensionPos(s) = maxword then
    begin
    s := s + '.' ;
    if (ext[1]> ' ') then
      s := s + ext;
    end ;
end ;

procedure RemoveExtension{( var s : PathStr )};

var
  p : word ;
begin
  p := ExtensionPos(s) ;
  if p<>maxword then
    s.length := p ;
end ;


procedure ChangeExtension{ (var s : PathStr ; ext : ExtStr )} ;
begin
  RemoveExtension(s) ;
  AddExtension(s,ext) ;
end ;

function  IsExtension{( s : PathStr ; ext : ExtStr ) : boolean};
var
  es: PathStr;
begin
  es := '*.' + ext;
  IsExtension := Match(s, es);
end ;

function  FindAndOpenPath (name : string[high];
                                   om      : OpenMode ;
                                   var fullname  : PathStr ;
                                   var h       : word ) : boolean ;
var
  l      : word;
  i,p    : word;
  len    : word;
  sp     : StrPtr ;
  path   : PathStr ;
  pstr   : PathStr;
  amatch : boolean ;
  savep  : word;

  function a_to_s(var P: PathStr; sp: StrPtr): word;

  var
    i: word;
  begin
    i := 0;
    while sp^[i] <> 0C do
      begin
      P[i + 1] := sp^[i];
      i := i + 1;
      end;
    P.length := i;
    a_to_s := i;
  end;

  function  TestFileExists (name : PathStr): boolean ;
  var
    path  : PathStr ;
    found : boolean ;
    fn    : DosPathStr;
  begin
    ExpandPath(name,path) ;
    if om=OMcreate then
      found := true
    else
      begin
      StrToZ(path, fn);
      h :=  CoreIO._pasopen(adr(fn), 0) ;
      found := (h <> Null) ;
      end ;
    IF found then
      fullname := path ;
    TestFileExists := found ;
  end  ;


label
  999, 555;
begin
  amatch := false ;
  h := Null ;
  IF AbsolutePath(name) then
    i := NoOfConversions
  else
    i := 0 ;
  while true do
    begin
    i := i + 1 ;
    if i>NoOfConversions then
      begin
      if not amatch then
        if TestFileExists ( name ) then
          FindAndOpenPath := true
        else
          FindAndOpenPath := false;
      goto 999;
      end ;
    p := Conversion[i] ;
    sp := ADR(StrTab[p]) ;
    len := a_to_s(pstr, sp);
    if Match(name,pstr) then
      begin
      amatch := TRUE ;
      while true do
        begin
        p := p + len + 1;
        sp := ADR(StrTab[p]) ;
        len := a_to_s(pstr, sp);
        if len = 0 then
          goto 555;
        MakePath(path,pstr,name) ;
        if TestFileExists ( path ) then
          begin
          FindAndOpenPath := true;
          goto 999;
          end ;
        end ;
555:
      end ;
    end ;
999:
end ;


function  FindPath{(name : PathStr ; var fullname : PathStr ) : boolean} ;

var
  h : word ;
  b : boolean ;
begin
  b := FindAndOpenPath(name,OMopen,fullname,h) ;
  if h<>Null then
    CoreIO._close(h) ;
  FindPath := b ;
end ;

function  FindNewPath{(name : PathStr ; var fullname  : PathStr ) : boolean} ;

var
  h : word ;
  b : boolean ;
begin
  b := FindAndOpenPath(name,OMcreate,fullname,h) ;
  if h<>Null then
    CoreIO._close(h) ;
  FindNewPath := b;
end;


procedure DelLeading (VAR R : array [low..high: int16] of char ) ;
begin
  while (R[0]>0C)and(R[0]<=' ') do
    Move(R[1],R[0], high-1);
end;

procedure ToUpper (VAR R : array [low..high: int16] of char ) ;

var
  n: int16;
begin
  n := low;
  while R[n] <> 0C do
   begin
   if (R[n] >= 'a') and (R[n] <= 'z') then
     R[n] := chr(ord(R[n]) - 20H);
     n := n + 1
   end;
end;

procedure Item(var R: array[lowr..highr: int16] of char;
                   S: array[lows..highs: int16] of char;
                   T: PasCore.CHARSET; N: word);
var
  I,J  : word;
  HR,L : word;
label
  555;
begin
  I := 0;
  L := ZLen(S);
  while true do
    begin
    while (I < L) and (S[I] in T) do I := I + 1;  (* Skip separators *)
    if (N = 0) or (I = L) then goto 555;
    N := N - 1;
    while (I < L) and (not (S[I] in T)) do I := I + 1;  (* Skip item *)
    end;
555:
  J  := 0;
  HR := highr;
  while (I < L) and (not (S[I] IN T)) and (J <= HR) do
    begin
    R[J] := S[I];
    I := I + 1;
    J := J + 1;
    end;
  if (J <= HR) then
    R[J] := chr(0);
end;

procedure ItemS(var R: array[lowr..highr: int16] of char;
                S: array[lows..highs: int16] of char;
                T: string[hight]; w: word);

var
  CS : PasCore.CHARSET;
  I  : word;
begin
  I  := T.length;
  CS := [];
  while I>0 do
    begin
    CS := CS + [ T[I] ];
    I := I - 1;
    end;
  Item(R,S,CS,w);
end ;

procedure ReadRedirectionFile{ ( name : PathStr)};
type
  Str3 = string[3] ;
var
  line  : array[0..255] of char ;
  item  : array[0..64] of char ;
  outp  : boolean ;
  pat   : word ;
  j,n,l,i : word ;
  path  : PathStr ;
  d:  boolean;
label
  555, 999;
begin
  NoOfConversions := 0 ;
  d:= FindExePath(name,TRUE,path);
  if not OpenTextFile(path) then
    goto 999;
  outp := true ;
  while true do
    begin
    ReadTextLn(line) ;
    if line[0]=CHR(26) then
      goto 555;
    ToUpper(line) ;
    DelLeading(line) ;
    ItemS(item,line,' ,=;',0) ;
    if item[0]<>0C then
      begin
      NoOfConversions := NoOfConversions + 1;
      Conversion[NoOfConversions] := AddText(item) ;
      i := 0 ;
      repeat
        i := i + 1 ;
        ItemS(item,line,' =,;',i) ;
        n := AddText(item) ;
      until item[0]=0C ;
      end ;
    if NoOfConversions=MaxNoOfConversions then
      goto 555 ;
    end ;
555:
  CloseTextFile ;
  StrTabPtr := 1 ;
999:
end ;


function  FindExePath{ ( path    : PathStr ;
                        ovl     : boolean ;
                        var outpath : PathStr ) : boolean} ;

var
  fp      : PathStr ;
  str     : StrPtr ;
  l       : word ;
  envpath : PathStr ;
  n, j    : word ;
label
  555, 999;
begin
  outpath := path ;
  if FindPath(path,outpath) then
    begin
    FindExePath := true ;
    goto 999;
    end ;
  if AbsolutePath(path) then
    begin
    FindExePath := false ;
    goto 999;
    end ;
  if ovl AND (GetDosVersion >= 3H) then
    begin
    fp := PasDos.ParamStr(0);
    l := fp.length;
    while true do
      begin
      if l=0 then
        goto 555;
      l := l - 1;
      if fp[l]='\' then
        goto 555;;
      end;
555:
    fp.length := l;
    MakePath(fp,fp,path) ;
    if FindPath(fp,outpath) then
      begin
      FindExePath := true ;
      goto 999;
      end ;
    end;
  envpath:= PasDos.GetEnv('PATH') ;
  l := envpath.length ;
  n := 1;
  while n <= l do
    begin
    j := 1;
    while (envpath[n] <> ';') and (n <= l) do
      begin
      fp[j] := envpath[n];
      n := n + 1;
      j := j + 1;
      end;
    fp.length := j - 1;
    n := n + 1;
    MakePath(fp,fp,path) ;
    if FindPath(fp,outpath) then
      begin
      findexepath := true;
      goto 999;
      end ;
    end ;
  findexepath := false;
999:
end ;

procedure Init ;

var
  RedFile: string[80];
begin
  NoOfConversions := 0 ;
  StrTab[0] := 0C ;
  StrTabPtr := 1 ;
  LastDelPtr := 0 ;
  NoOfStrings := 0 ;
  RedFile := PasDos.GetEnv('TSRED');
  if RedFile.length = 0 then
    RedFile := 'TS.RED';
  ReadRedirectionFile(RedFile);
end ;

begin
  Init ;
end .

