(* Release 3.00 *)
(* Copyright (C) 1990..1991 Jensen & Partners International *)

IMPLEMENTATION UNIT PasWin;
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)


IMPORT PasLib, PasDos, CoreFile, CoreWind, CoreMem,
       (*%T _mthread *) PasProc, CoreProc, (*%E *)
       (*%T _OS2 *) Vio, Kbd, (*%E *)
       CoreSig ;

const

  MSDOS = NOT _OS2;

  CGASnow = false;  (* Set To true To Enable CGA Snow Check *)

  ShadowAttr = 07H;


{ inline for speed }
inline function Max(x,y : word): word;
begin
  if x<y then
    Max := y
  else
    Max := x
end;


inline function Min(x,y : word): word;
begin
  if x>y then
    Min := y
  else
    Min := x
end;


(*--------------------------------------------------------------------*)
(* Multi Process Stuff                                                *)
(*--------------------------------------------------------------------*)
(*%T _mthread *)
type
  FocusPtr = ^FocusRec;
  FocusRec = record
              win   : WinPtr;
              next  : FocusPtr;
            end;
var
  Foci: array [0..CoreProc.MaxProcess-1] of FocusPtr;

function Focus;
begin
  Focus := Foci[CoreProc._getTID]^.win;
end;
(*%E *)

(*--------------------------------------------------------------------*)
(* OS Dependant routines                                              *)
(*--------------------------------------------------------------------*)

VAR
  CursorState: HWCursorState;

(*%T MSDOS*)


procedure  OSMoveCursor(x,y : word);
var
  R    : PasDos.Registers;
begin
  R.AH := 2;
  R.BH := CoreWind._activepage;
  R.DL := x;
  R.DH := y;
  PasDos.Intr(10H, R);
  CursorState.x := x; CursorState.y := y;
end;

procedure  OSCursorOn(on : boolean);
var
  R    : PasDos.Registers;
  mode : word;
begin
  if on then
    mode := CursorState.lines
  else
    mode := 2000H;
  R.AH := 1;
  R.CX := mode;
  PasDos.Intr(10H,R);
  CursorState.on := on;
end ;

(*%E*)

(*%T _OS2*)
var
  OSCursorLines : Vio.CURSORINFO;

procedure  OSMoveCursor(x,y : word);
var   r : word;
begin
  r := Vio.SetCurPos(y,x,0);
  CursorState.x := x; CursorState.y := y;
end ;


procedure  OSCursorOn(on : boolean);
var
  r    : word;
  mode : Vio.CURSORINFO;
begin
  mode := OSCursorLines;
  mode.cstart := CursorState.lines div 256;
  mode.cend := CursorState.lines mod  256;
  if not on then
    mode.attr := -1;
  r := Vio.SetCurType( mode,0);
  CursorState.on := on;
end ;

(*%E*)

function CharWord( ch : char; f,b : Color):word;
begin
  CharWord := ((ord(b)<<12)+(ord(f)<<8)+ord(ch));
end ;


type

  MaxLine = array[0..AbsMaxX] of word;

(*--------------------------------------------------------------------*)
implementation of ScrRect;
(*--------------------------------------------------------------------*)

       function SubRect{ ( var r2 : ScrRect ) : boolean};
       begin
         SubRect := ((r2.Left<=Left)and(r2.Right>=Right)and(r2.Top<=Top)and(r2.Bottom>=Bottom));
       end ;

       function AreaSize {: word};
       begin
         AreaSize := Width*Depth*2;
       end ;

       procedure SaveArea{(buf : address; maxsize : word)};
       var
         y,ws : word;
       label
         999;
       begin
         ws := Width;
         for y := Top to Bottom do
           begin
           ws := Min(ws,maxsize DIV 2);
           if ws=0 then
             goto 999;
           CoreWind._screentobuffer(Left,y,buf,ws);
           maxsize := maxsize - ws*2;
           (buf:>word) := buf:>word  + (ws*2);
           end;
       999:
       end;

       procedure RestoreArea{(buf : address; maxsize : word)};
       var
         y,ws : word;
       label
         999;
       begin
         ws := Width;
         for y := Top to Bottom do
           begin
           ws := Min(ws,maxsize DIV 2);
           if ws=0 then
             goto 999;
           CoreWind._buffertoscreen(Left,y,buf,ws);
           maxsize := maxsize - (ws*2);
           (buf:>word) := buf:>word + (ws*2);
           end;
       999:
       end;

       procedure WriteRel{( rx,ry : word; var chs; wds : word)};
       (* rx and ry are relative, 1,1 is top left corner *)
       begin
         if wds>0 then
           CoreWind._buffertoscreen(Left+rx-1,Top+ry-1,adr(chs),wds);
       end ;

       procedure ReadRel{ ( rx,ry : word; var chs; wds : word)};
       (* rx and ry are relative, 1,1 is top left corner *)
       begin
         if wds>0 then
           CoreWind._screentobuffer(Left+rx-1,Top+ry-1,adr(chs),wds);
       end;

       procedure Clip{ (var x,y : word)};
       begin
         x := Min(Max(x,1),Width);
         y := Min(Max(y,1),Depth);
       end;


       procedure Open{(x,y,w,d : word)};
       begin
         x := Min(x,MaxX);
         y := Min(y,MaxY);
         Left := x;
         Top := y;
         Right := x+w-1;
         Bottom := y+d-1;
         if Right>MaxX then
           begin
           w := w - (Right-MaxX);
           Right := MaxX;
           end;
         if Bottom>MaxY then
           begin
           d := d - (Bottom-MaxY);
           Bottom := MaxY;
           end;
         Width := w;
         Depth := d;
       end;

       procedure Fill{( chw : word )};
       var i : word;
           buff : MaxLine;
       begin
         for i := 1 to Width do
           buff[i-1] := chw;
         for i := 1 to Depth do
           WriteRel(1,i,buff,Width);
       end;

       procedure FillChar{ ( ch : char ; f,c : Color)};
       begin
         Fill(CharWord(ch,f,c));
       end;

       procedure FillAttr{ ( at : byte )};
       var i,j : word;
           buff : array[0..AbsMaxX] of
             record
               ch : char;
               at : BYTE;
             end;
       begin
         for i := 1 to Depth do
           begin
           ReadRel(1,i,buff,Width);
           for j := 1 to Width do
             buff[j-1].at := at;
           WriteRel(1,i,buff,Width);
           end;
       end;

begin
  Width := 0; Depth := 0;
end;


(*--------------------------------------------------------------------*)
implementation of  Win;
(*--------------------------------------------------------------------*)

    procedure Open{ ( x,y,w,d : word; f,b : Color)};
    var
      temp : word;
    begin
      ScrRect.Open(x,y,w,d);
      if (adr(SELF)<>adr(Screen))and(not SubRect(Screen)) then
         PasDos.RunTimeError(CoreSig._FatalErrorPos, 01H, 'PasWin.Open: Invalid parameters');
      Fore := f;
      Back := b;
      CX := 1;
      CY := 1;
      if (Focus=NIL) then
        CursorIsOn := true
      else
        CursorIsOn := Focus^.CursorIsOn;
      WrapOn := true;
      NextFocus := NIL;  (* Not used for mthread *)
      SELF.MakeFocus;
      if SELF is PopUpWin THEN
        (SELF::PopUpWin).Capture;
      if (adr(SELF)<>adr(Screen)) then
        Clear(clear_screen);
    end ;

    procedure MakeFocus;
    (*%T _mthread *)
      var fr : FocusPtr;
          tid : word;
    (*%E*)
    begin
      if Focus<>adr(SELF) then
        begin
        (*%T _mthread *)
          New(fr);
          fr^.win := adr(SELF);
          tid := CoreProc._getTID;
          fr^.next := Foci[tid];
          Foci[tid] := fr;
        (*%E*)
        (*%F _mthread *)
          NextFocus := Focus;
          Focus := adr(SELF);
        (*%E*)
        SELF.UpdateCursor;
        end;
    end;

    (*%F _mthread *)
    procedure Defocus;
    var f,pf : WinPtr;
    begin
       f := Focus;
       pf := NIL;
       repeat
          if (f = adr(SELF)) then
            begin
            if pf=NIL then
              Focus := NextFocus
            else
              pf^.NextFocus := NextFocus;
            f := NIL;
            end
          else
            begin
            pf := f;
            f := f^.NextFocus;
            end;
       until f=NIL;
       NextFocus := Nil;
       if Focus=Nil then
         Screen.MakeFocus;  { must have a focus! }
    end;
    (*%E*)

    (*%T _mthread *)
    procedure Defocus;
    var f,pf : FocusPtr;
        tid  : word;
    begin
       tid := CoreProc._getTID;
       f := Foci[tid];
       pf := NIL;
       repeat
         if f^.win=ADR(SELF) then
           begin
           if pf=NIL then
             Foci[tid] := f^.next
           else
             pf^.next := f^.next;
           Dispose(f);
           f := NIL;
           end
         else
           begin
           pf := f;
           f := f^.next;
           end;
       until f=NIL;
       NextFocus := Nil;
    end;
    (*%E*)

    procedure UpdateCursor;
    begin
      if Screen.CursorIsOn and CursorIsOn and (Focus=ADR(SELF)) then
         OSMoveCursor(CX+Left-1,CY+Top-1);
    end ;


    procedure Scroll{ ( smode : ScrollMode )};
    var
      line   : MaxLine;
      space  : word;
      yv,yt   : word;
      inc    : int16;
      i      : word;
    begin
      if smode=scroll_up then
        begin
        yv := 1;
        yt := Depth;
        inc := 1
        end
      else
        begin
        yv := Depth;
        yt := 1;
        inc := -1;
        end;
      repeat
        begin
        yv := yv+inc;
        ReadRel(1,yv,line,Width);
        yv := yv-inc;
        WriteRel(1,yv,line,Width);
        yv := yv+inc;
        end;
        until yv=yt;
      space := CharWord(' ',Fore,Back);
      for i := 1 to Width do
        line[i-1] := space;
      WriteRel(1,yv,line,Width);
      SELF.UpdateCursor;
    end ;

    procedure Clear{ ( cmode : ClearMode )};
    var
      line : MaxLine;
      space : word;
      xv,xt,yv,wv,dv,i : word;
    begin
      xv := 1;
      xt := Width;
      yv := CY;
      dv := 1;
      case cmode of
        clear_screen:
          begin
          dv := Depth;
          yv := 1;
          CX := 1;
          CY := 1; (* reset cursor position *)
          UpdateCursor;
          end;
        clear_eol:
          xv := CX;
        clear_bol:
          xt := CX-1;
        clear_line:
      end;
      if xt>=xv then
        begin
        wv := xt-xv+1;
        space := CharWord(' ',Fore,Back);
        for i := 1 to wv do
          line[i-1] := space;
        for i := 1 to dv do
          WriteRel(xv,yv+i-1,line,wv);
        end;
    end;

    procedure WriteStr{ ( s : string[high] )};

    var
      attr : word;

      procedure  WriteC ( C : char);
      var
        cw : word;
      begin
        if C = CHR(7) then
          (* Bell *) (* No-op in this implementation *)
        else if C = CHR(8) then
          begin
          if CX>1 then
            begin
            CX := CX - 1;
            WriteC(' ');
            CX := CX - 1;
            end;
          end
        else if C = CHR(10) then
          begin
          if CY=Depth then
            Scroll(scroll_up)
          else
            CY := CY + 1;
          end
        else if C = CHR(12) then
          Clear(clear_screen)
        else if C = CHR(13) then
          CX := 1
        else
          begin
          if CX<=Width then
            begin
            cw := attr+ord(C);
            WriteRel(CX,CY,cw,1);
            if (CX=Width) and WrapOn then
              begin
              WriteC(CHR(13));
              WriteC(CHR(10))
              end
            else
              CX := CX + 1;
            end;
          end;
      end;

    var buff : MaxLine;
        bp   : word;
        i    : word;
        c    : char;
    begin
      attr := CharWord(0C,Fore,Back);
      i := 1;
      bp := 0;
      repeat
        if i>s.length then c := chr(0) else c := s[i];
        i := i + 1;
        if (c>=' ') and (bp+CX<Width) then
          begin
          buff[bp] := ord(c)+attr;
          bp := bp + 1;
          end
        else
          begin
          if bp>0 then
            begin
            WriteRel(CX,CY,buff,bp);
            CX := CX + bp;
            bp := 0;
            end;
          if c<>chr(0) then WriteC(c);
          end;
      until c=CHR(0);
      SELF.UpdateCursor;
    end;

    procedure WriteStrAt{ ( x,y : word; s : string[high] )};
    var
      savex,savey : word;
    begin
      savex := CX;
      savey := CY;
      if x<>0 then
        CX := x;
      if y<>0 then
        CY := y;
      WriteStr(s);
      CX := savex;
      CY := savey;
      SELF.UpdateCursor;
    end;

    procedure ReadStr { ( var s : string[high]) } ;
    (* Simple field input with editing *)
    var
      ins     : boolean ;
      k       : char ;
      x,p,l : word ;
    begin
      if SELF is PopUpWin THEN
        (SELF::PopUpWin).PopUp
      else
        MakeFocus;
      x := CX ;
      p := 1 ;
      ins := true ; (* Insert mode *)
      s.length := 0;
      repeat
        l := s.length ;
        if l+x>Width+1 then begin l := Width-x+1; s.length := l; end;
        if p>l+1 then p := l+1;
        WriteStr(s) ; Clear(clear_eol);
        CX := x+p-1;
        UpdateCursor;
        k := PasDos.RdKey;
        if k = CHR(0) then  (* Extended character *)
          begin
          k := PasDos.RdKey;
          case k of
            CHR(75) : k := CHR(19) ;   (* LeftArr  -> ^S *)
            CHR(77) : k := CHR(4)  ;   (* RightArr -> ^D *)
            CHR(71) : k := CHR(1)  ;   (* Home     -> ^A *)
            CHR(79) : k := CHR(6)  ;   (* End      -> ^F *)
            CHR(83) : k := CHR(7)  ;   (* Del      -> ^G *)
            CHR(82) : k := CHR(22) ;   (* Ins      -> ^V *)
            else ;
            end ;
          end;
        case k of
          ' '..'~' : begin
                     if ins then
                        Insert(k,s,p)
                     else
                        begin
                        if p>l then
                          S := S+k
                        else
                          S[p] := k ;
                        end;
                        p := p+1 ;
                     end;
          CHR(1)   : p := 1 ;                 (* Home    *)
          CHR(6)   : p := l+1 ;               (* End     *)
          CHR(19)  : if p>1 then p:=p-1;      (* Left    *)
          CHR(4)   : if p<=l then p:=p+1;     (* Right   *)
          CHR(7)   : if p<=l then             (* Del     *)
                       Delete(S,p,1) ;
          CHR(8)   : if p>1 then              (* BackSpace *)
                     begin
                       p := p-1; Delete(S,p,1) ;
                     end ;
          CHR(22)  : ins := NOT ins ;         (* Toggle Ins/Ovr *)
          CHR(13)  : begin
                     X := 1;
                     if CY=Depth then
                       begin
                       if Depth>1 then Scroll(scroll_up);
                       end
                     else
                       CY := CY + 1;
                     end;
        else;
        end ;
        cx := X;
        UpdateCursor;
      until k in ReadStrTermKeys;
    end;

begin
  Initialize;
end; (* Win *)

(*--------------------------------------------------------------------*)
implementation  of FramedWin;
(*--------------------------------------------------------------------*)

    procedure Open{ ( x,y,w,d : word; f,b : Color )};
    begin
      border[top_edge].Open(x,y-1,w,1);
      border[bottom_edge].Open(x,y+d,w,1);
      border[left_edge].Open(x-1,y-1,1,d+2);
      border[right_edge].Open(x+w,y-1,1,d+2);
      border[right_shadow].Open(x+w+1,y,2,d+2);
      border[bottom_shadow].Open(x+1,y+d+1,w,1);
      framemode := no_frame;
      Win.Open(x,y,w,d,f,b);
    end ;

    function AreaSize{:word};
    var
      e,em : EdgeKind;
      as : word;
    begin
      as := ScrRect.AreaSize;
      for e := top_edge to bottom_shadow do
        as := as + border[e].AreaSize;
      AreaSize :=  as;
    end;

    procedure SaveArea{(buf : address; maxsize : word)};
    var lv : word;
        e : EdgeKind;
    begin
      lv := Min(maxsize,ScrRect.AreaSize);
      ScrRect.SaveArea(buf,lv);
      for e := top_edge to bottom_shadow do
        begin
        maxsize :=  maxsize - lv;
        (buf:>word) := buf:>word + lv;
        lv := Min(maxsize,border[e].AreaSize);
        border[e].SaveArea(buf,lv);
        end;
    end;

    procedure RestoreArea{(buf : address; maxsize : word)};
    var lv : word;
        e : EdgeKind;
    begin
      lv := Min(maxsize,ScrRect.AreaSize);
      ScrRect.RestoreArea(buf,lv);
      for e := top_edge to bottom_shadow do
        begin
        maxsize :=  maxsize - lv;
        (buf:>word) := buf:>word + lv;
        lv := Min(maxsize,border[e].AreaSize);
        border[e].RestoreArea(buf,lv);
        end;
    end;


    procedure FrameDraw{ (bordef : BorderDef;
                          borf, borb : Color;
                          shadowed : boolean ) };
    var i : word;
        c : char;
        ch : word;
    begin
      border[top_edge].Fill(CharWord(bordef[2],borf,borb));
      border[bottom_edge].Fill(CharWord(bordef[7],borf,borb));
      with border[left_edge] do
        begin
        for i := 1 to Depth do
          begin
          if i=1 then
            c := bordef[1]
          else if i=Depth then
            c := bordef[6]
          else
            c := bordef[4];
          ch := CharWord(c,borf,borb);
          WriteRel ( 1,i,ch,1);
          end;
        end ;
      with border[right_edge] do
        begin
        for i := 1 to Depth do
          begin
          if i=1 then
            c := bordef[3]
          else if i=Depth then
            c := bordef[8]
          else
            c := bordef[5];
          ch := CharWord(c,borf,borb);
          WriteRel ( 1,i,ch,1);
          end;
        end ;
      if shadowed then
        begin
        border[right_shadow].FillAttr(ShadowAttr);
        border[bottom_shadow].FillAttr(ShadowAttr);
        framemode := shadowed_frame
        end
      else
        framemode := normal_frame;
    end;

    procedure FrameWrite { ( s   : string[high];
                           attop : boolean;
                           x   : word;
                           f,b : Color ) } ;
    var buff : MaxLine;
        i    : word;
        e    : EdgeKind;
        attr : word;
    begin
      if framemode <> no_frame then
        begin
        attr := CharWord(0C,f,b);
        for i := 1 to s.length do
          buff[i-1] := attr+ord(s[i]);
        if attop then
          e := top_edge
        else
          e := bottom_edge;
        if x=frameleft then
          x := Width-s.length
        else if x=framecenter then
          x := (Width-s.length) div 2+1;
        if (x>width)or(x=0) then
          x := 1;
        border[e].WriteRel ( x,1,buff,s.length);
        end;
    end;

  begin
  end ; (* FramedWin *)


procedure ToggleHidden(VAR w : PopUpWin);
var as : word;
    p : address;
begin
  p := w._savbuf;
  w._savbuf := NIL;
  w.Capture;
  as := w.AreaSize;
  w.RestoreArea(p,as);
  FreeMem(p,as);
  w.Hidden := not w.Hidden;
end;



(*--------------------------------------------------------------------*)
implementation  of PopUpWin;
(*--------------------------------------------------------------------*)

    procedure Capture;
    var as : word;
    begin
      as := AreaSize;
      if _savbuf= nil then
        GetMem(_savbuf,as);
      SaveArea(_savbuf,as);
    end;

    procedure PopUp;
    begin
      if Hidden then
        begin
        ToggleHidden(SELF);
        MakeFocus;
        UpdateCursor;
        end;
    end;



    procedure Hide;
    begin
      if not Hidden then
        begin
        ToggleHidden(SELF);
        Defocus;
        Focus^.UpdateCursor;
        end;
    end;

    procedure MoveWin { (x,y : word) };
    var
      w,d : word;
    begin
      w := Width; d := Depth;
      Hide;
      border[top_edge].Open(x,y-1,w,1);
      border[bottom_edge].Open(x,y+d,w,1);
      border[left_edge].Open(x-1,y-1,1,d+2);
      border[right_edge].Open(x+w,y-1,1,d+2);
      border[right_shadow].Open(x+w+1,y,2,d+2);
      border[bottom_shadow].Open(x+1,y+d+1,w,1);
      ScrRect.Open(x,y,w,d);
      PopUp;
    end;

    procedure Open { ( x,y,w,d : word; f,b : Color ) };
    begin
       _savbuf := NIL;
       Hidden := false;
       FramedWin.Open(x,y,w,d,f,b);
    end;

    procedure Close;
    begin
        Hide;
        FreeMem(_savbuf,AreaSize);
    end;

  begin
  end; (* PopUpWindow *)

(*--------------------------------------------------------------------*)
(* Hardware Cursor routines                                           *)
(*--------------------------------------------------------------------*)


procedure CursorOn;
begin
  OSCursorOn(true);
  Focus^.UpdateCursor;
end;

procedure CursorOff;
begin
  OSCursorOn(false);
end;


procedure SaveHWCursor {(VAR state : HWCursorState)};    (* Saves current state *)
begin
  state := CursorState;
end;

procedure RestoreHWCursor {(state : HWCursorState)}; (* sets current state *)
begin
  CursorState := state;
  OSMoveCursor(state.x,state.y);
  OSCursorOn(state.on);
end;


(*--------------------------------------------------------------------*)
(* Default Procedures (e.g. methods applied to Focus)                 *)
(* (Together with all normal IO functions)                            *)
(*--------------------------------------------------------------------*)


procedure GotoX { ( x : word )} ;
begin
  Focus^.CX := x;
  Focus^.UpdateCursor;
end;

procedure GotoY {( y : word )};
begin
  Focus^.CY := y;
  Focus^.UpdateCursor;
end;

procedure GotoXY {( x,y : word )};
begin
  Focus^.CX := x;
  Focus^.CY := y;
  Focus^.UpdateCursor;
end;


function WhereX {: word};
begin
  WhereX := Focus^.CX;
end;

function WhereY {: word};
begin
  WhereY := Focus^.CY;
end;

procedure Foreground {( c : Color )};
begin
  Focus^.Fore := c;
end;

procedure Background {( c : Color )};
begin
  Focus^.Back := c;
end;

procedure Scroll {( mode : ScrollMode )};
begin
  Focus^.Scroll(mode);
end;

procedure Clear {( mode : ClearMode )};
begin
  Focus^.Clear(mode);
end;


procedure WriteStrAt {( x,y : word ; s : string[high] )};
begin
  Focus^.WriteStrAt(x,y,s);
end;

procedure WriteStr {( s : string[high] )};
begin
  Focus^.WriteStr(s);
end;

procedure ReadStr { ( var s : string[high]) } ;
begin
  Focus^.ReadStr(s);
end;


procedure FrameDraw {( bordef : BorderDef;borf, borb : Color; shadowed : boolean ) } ;
begin
  if Focus^ is FramedWin then
    (Focus^::FramedWin).FrameDraw(bordef,borf,borb,shadowed);
end;

procedure FrameWrite {( s   : string[high];
                       attop : boolean;
                       x   : word;
                       fore,back : Color )};
begin
  if Focus^ is FramedWin then
    (Focus^::FramedWin).FrameWrite(s,attop,x,fore,back);
end;


(*--------------------------------------------------------------------*)

type
  ByteArray = array [0..DefaultBufferSize-1] of char;
  ByteArrayPtr = ^ByteArray;

function  WriteCrt(H: int16; Buffer: CoreFile.StreamPtr; Count: int16): int16;


var
  s : string[80];
begin
  WriteCrt := Count;
  while Count>0 do
    begin
    if Count>80 then
      s.length := 80
    else
      s.length := Count;
    Count := Count-s.length;
    Move(Buffer^,s[1],s.length);
    (Buffer:>Word):=(Buffer:>Word)+s.length;
    WriteStr(s);
    end;
end;

VAR
  readbuffp : word;
  readbuff : string[AbsMaxX+1];

function ReadCrt(H: int16; Buffer: CoreFile.StreamPtr; Count: int16): int16;
type
  CharArray = array [0..9999] of char;
  CharArrayPtr = ^CharArray;
var
  i,j : word;
begin
  i := 0;
  if readbuffp>readbuff.length then
    begin
    Focus^.ReadStr(readbuff);
    readbuffp := 1;
    end;
  while (i<Count)and(readbuffp<=readbuff.length) do
    begin
    (Buffer:>CharArrayPtr)^[i] := readbuff[readbuffp];
    i := i+1;
    readbuffp := readbuffp+1;
    end;
  if i<Count then
    begin
    (Buffer:>CharArrayPtr)^[i] := CHR(0DH);
    i := i+1;
    (Buffer:>CharArrayPtr)^[i] := CHR(0AH);
    i := i+1;
    end;
  ReadCrt := i;
end;

procedure CrtAssignBuffer(var f: filetype; write: boolean);

var
  BI: ^ CoreFile.CStream;
  BufferSize: word;
begin
  new(BI);
  if f.objectsize > DefaultBufferSize then
    BufferSize := f.objectsize
  else
    BufferSize := ( DefaultBufferSize DIV f.objectsize)  * f.objectsize;
  BI^.Ptr := CoreMem.malloc(BufferSize);
  BI^.Size := BufferSize;
  BI^.Base := BI^.Ptr;
  f.bufferptr := BI^.Ptr;
  BI^.Cnt := 0;
  BI^.Pback := 0;
  BI^.Handle := f.handle;
  BI^.Flag := [CoreFile._F_DEV];
  if write then
    BI^.Flag := BI^.Flag + [CoreFile._F_READ, CoreFile._F_WRIT]
  else
    BI^.Flag := BI^.Flag + [CoreFile._F_READ];
  BI^.Flag := BI^.Flag + [CoreFile._F_BIN, CoreFile._F_UBUF, CoreFile._F_RST];
  f.stream := BI;
end ;



(*--------------------------------------------------------------------*)

procedure Initialize;
begin
  (* Not currently used as Module initialize performs screen initialization *)
end;

procedure InitializeModule;
var
  R : PasDos.Registers ;
  res : word;
(*%T _mthread *)
  fr  : FocusPtr;
  i   : word;
(*%E*)
begin
(*%T MSDOS*)
  CoreWind._initscreentype(CGASnow);
  R.AH := 3;
  R.BH := CoreWind._activepage;
  PasDos.Intr(10H,R);
  if (R.CH<20H)and(R.CL>0)  then
    CursorState.lines := R.CX
  else
    CursorState.lines := 0607H ;
(*%E*)
(*%T _OS2*)
  CoreWind._initscreentype(CGASnow);
  res := Vio.GetCurType( OSCursorLines,0);
  CursorState.lines := OSCursorLines.cstart*256+OSCursorLines.cend;
(*%E*)
  MaxY := CoreWind._getscreendepth-1;
  MaxX := AbsMaxX;
  if MaxY>AbsMaxY then
    MaxY := AbsMaxY;
  (*%T _mthread *)
    New(fr);
    fr^.next := NIL;
    fr^.win := NIL;
    for i := 0 to CoreProc.MaxProcess-1 do Foci[i] := fr;
  (*%E*)
  (*%F _mthread *) Focus := NIL; (*%E*)
  Screen.Open(0,0,MaxX+1,MaxY+1,White,Black);
  OSMoveCursor(0,0);
  OSCursorOn(true);
  Screen.UpdateCursor;
  PasDos.AssignBuffer := CrtAssignBuffer;
  PasDos.read  := ReadCrt;
  PasDos.write := WriteCrt;
  PasLib._output.state := PasLib._output.state + [Acrt];
  PasLib._input.state := PasLib._input.state + [Acrt];
  readbuff.length := 0;
  readbuffp := 1;
  ReadStrTermKeys := [CHR(13)];
end;

begin
  InitializeModule;
end.
