(* Release 3.00 *)
(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*# call(seg_name => null) *)
(*# module(implementation=>off) *)
(*# data(seg_name => null) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT TurboCrt;

(*%F _OS2 *)
IMPORT PasLib, PasDos, CoreFile, CoreMem, CoreSig, PasDos;
(*%E *)
(*%T _OS2 *)
IMPORT PasLib, PasDos, CoreFile, CoreMem, CoreSig, PasDos, Dos;
(*%E *)

type
  FileInf = ^ CoreFile.CStream;

procedure  NoSound; in paslow;
procedure  Sound; in paslow;

var
  BreakSet: boolean;

procedure CrtError(code: word);

begin

end;

type
  ByteArray = array [0..DefaultBufferSize-1] of byte;
  ByteArrayPtr = ^ByteArray;

function  WriteCrt(H: int16; Buffer: CoreFile.StreamPtr; Count: int16): int16;


var
  n, c: int16;
begin
  n := 0;
  while n < Count do
    begin
    c := CoreClip._c_putch((Buffer:>ByteArrayPtr)^[n]);
    n := n + 1;
    end;
  WriteCrt := n;
end;

function ReadCrt(H: int16; Buffer: CoreFile.StreamPtr; Count: int16): int16;

var
  n: int16;
  c: byte;
label
  555;
begin
  n := 0;
  Count := Count -1;
  while n < Count do
    begin
    c := CoreClip.getche;
    (Buffer:>ByteArrayPtr)^[n] := c;
    n := n + 1;
    if c = 0DH then
      begin
      c := CoreClip._c_putch(0AH);
      (Buffer:>ByteArrayPtr)^[n] := 0AH;
      n := n + 1;
      goto 555;
      end;
    end;
555:
  ReadCrt := n;
end;

procedure CrtAssignBuffer(var f: filetype; write: boolean);

var
  BI: FileInf;
  BufferSize: word;
label
  999;
begin
  new(BI);
  if f.objectsize > DefaultBufferSize then
    BufferSize := f.objectsize
  else
    BufferSize := ( DefaultBufferSize DIV f.objectsize)  * f.objectsize;
  if BI = nil then
    begin
    CrtError(1);
    goto 999
    end;
  BI^.Ptr := CoreMem.malloc(BufferSize);
  if BI^.Ptr = nil then
    begin
    CrtError(2);
    BI^.Size := 0
    end
  else
    BI^.Size := BufferSize;
  BI^.Base := BI^.Ptr;
  f.bufferptr := BI^.Ptr;
  BI^.Cnt := 0;
  BI^.Pback := 0;
  BI^.Handle := f.handle;
  BI^.Flag := [CoreFile._F_DEV];
  if write then
    BI^.Flag := BI^.Flag + [CoreFile._F_READ, CoreFile._F_WRIT]
  else
    BI^.Flag := BI^.Flag + [CoreFile._F_READ];
  BI^.Flag := BI^.Flag + [CoreFile._F_BIN, CoreFile._F_UBUF, CoreFile._F_RST];
  f.stream := BI;
999:
end ;

procedure VarCheck;

begin
  if (CheckBreak) and (not(BreakSet)) then
    begin
    PasDos.EnableBreakCheck;
    BreakSet := true;
    end
  else if (not(CheckBreak)) and (BreakSet) then
    begin
    PasDos.DisableBreakCheck;
    BreakSet := false;
    end;
end;

procedure  ClrEol;

begin
  CoreClip.clreol;
end;

procedure  ClrScr;

begin
  VarCheck;
  CoreClip.clrscr;
end;

procedure  DelLine;

begin
  VarCheck;
  CoreClip.delline;
end;

procedure  GotoXY{(x, y: byte)};

begin
  VarCheck;
  CoreClip.gotoxy(x, y);
end;

procedure  HighVideo;

begin
  VarCheck;
  CoreClip.highvideo;
end;

procedure  InsLine;

begin
  VarCheck;
  CoreClip.insline
end;

procedure  LowVideo;

begin
  VarCheck;
  CoreClip.lowvideo;
end;

procedure  NormVideo;

begin
  VarCheck;
  CoreClip.normvideo;
end;

procedure  TextBackground{(color: byte)};

begin
  VarCheck;
  CoreClip.textbackground(color);
end;

procedure  TextColor{(color: byte)};

begin
  VarCheck;
  CoreClip.textcolor(color);
end;

procedure  TextMode{(mode: word)};

begin
  VarCheck;
  CoreClip.textmode(mode);
end;

function   wherex{: byte};

begin
  VarCheck;
  wherex := CoreClip.wherex;
end;

function   wherey{: byte};

begin
  VarCheck;
  wherey := CoreClip.wherey;
end;

procedure  window{(left, top, right, bottom: byte)};

begin
  VarCheck;
  CoreClip.window(left, top, right, bottom);
end;

function   KeyPressed{: boolean};

begin
  VarCheck;
  KeyPressed := CoreClip.kbhit <> 0;
end;

function   ReadKey{: char};

begin
  VarCheck;
  ReadKey := chr(CoreClip.getch);
end;

procedure  AssignCrt{(var f: filetype)};

begin
  f.state := f.state + [ACrt, Device];
end;

begin
  CheckBreak := false;
  BreakSet := false;
  CheckEOF := false;
  CheckSnow := false;
  CoreClip.directvideo := false;
  PasDos.AssignBuffer := CrtAssignBuffer;
  PasDos.read  := ReadCrt;
  PasDos.write := WriteCrt;
  PasLib._output.state := PasLib._output.state + [Acrt];
  PasLib._input.state := PasLib._input.state + [Acrt];
end.
