(* Release 3.00 *)
(* Copyright (C) 1989..1991 Jensen & Partners International *)

(*# module(implementation=>off) *)
(*# call(seg_name => null) *)
(*# data(seg_name => null) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT TurboDos;

(*%F _OS2 *)
IMPORT  CoreSig;
(*%E *)
(*%T _OS2 *)
IMPORT  Dos, CoreSig;
(*%E *)

(*%F _OS2 *)
function DiskFree{(Drive: word): integer}; in PasLow;

function DiskSize{(Drive: word): integer};  in PasLow;

function DosVersion{: word}; in PasLow;

procedure Keep{(ExitCode: word)}; in PasLow;
(*%E *)

type
  CharArray = array [1..255] of char;
  CharArrayPtr = ^ CharArray;
var
  NilStr: string[1];

(*%T _OS2 *)
procedure NotSupported;

begin
  PasDos.RunTimeError(CoreSig._FatalErrorPos, 0FAH, 'OS2 Library: Function Not Supported');
end;

type
  QFSInfoType = record
                  Id, SectorsPerUnit, TotalUnits, UnitsAvail: integer;
                  BytesPerSector: word;
                end;

function DiskFree{(Drive: word): integer};

var
  buf: QFSInfoType;
begin
  Dos.QFSInfo(drive, 1, faradr(buf), size(buf));
  DiskFree := buf.SectorsPerUnit * buf.BytesPerSector * buf.UnitsAvail;
end;


function DiskSize{(Drive: word): integer};

var
  buf: QFSInfoType;
begin
  Dos.QFSInfo(drive, 1, faradr(buf), size(buf));
  DiskSize := buf.SectorsPerUnit * buf.BytesPerSector * buf.TotalUnits;
end;


function DosVersion{: word};

var
  version: word;
begin
  Dos.GetVersion(version);
  DosVersion := version;
end;

procedure Keep{(ExitCode: word)};

begin
  NotSupported;
end;

function FExpand{(path : PathStr): PathStr};

var
  i,p,l : word ;
  c     : char ;
  hp    : word ;
  lim   : word ;
  ps    : string[32] ;
  po, fullpath : PathStr ;
  Drive, Len: word;
  Map: integer;
label
  555, 777, 999;
begin
  i := 0 ;
  hp := length(path) ;
  IF (hp=0) or (path[2]<>':') or (path[0]=0C) then
    begin
    Dos.QCurDisk(Drive, Map);
    po[1] := CHR(ord('A')+Drive-1) ;
    p := 1 ;
    end
  else
    begin
    po[1] := CAP(path[1]) ;
    p := 3 ;
    end;
  po[2] := ':' ;
  po[3] := '\' ;
  po[0] := chr(3);
  if path[p]<>'\' then
    begin
    Drive := ord(po[0])-ord('A')+1 ;
    Len := 77;
    Dos.QCurDir(Drive, farADR(po[4]), Len);
    i := 1;
    while po[i] <> chr(0) do
      i := i + 1;
    po[0] := chr(i - 1);
    if (i>3) then
      begin
      po[i] := '\' ;
      i := i + 1 ;
      po[0] := succ(po[0]);
      end ;
    end
  else
    begin
    i := 4 ;
    p := p + 1;
    end;
  po[i] := CHR (0) ;
  while true do
    begin
    i := 1 ;
    lim := 9 ;
    while true do
      begin
      if (p>hp) then
        begin
        ps[i] := '\' ;
        c := chr(0);
        i := i + 1;
        goto 555;
        end ;
      c := path[p] ;
      p := p + 1 ;
      if (c=0C) or (c='\') then
        begin
        ps[i] := '\' ;
        i := i + 1;
        goto 555;
        end;
      if (c='.') then
        begin
        ps[i] := c;
        i := i + 1;
        lim := 4;
        end
      else if (lim>1) then
        begin
        ps[i] := c ;
        i := i + 1;
        lim := lim - 1 ;
        end ;
      end ;
555:
    ps[i] := 0C ;
    ps[0] := chr(i - 1);
    if (i>2) then
      begin
      if ps[1] = '.' then                    (* .. = parent *)
        begin
        IF (i=4) and( ps[2]='.') then
          begin
          l := Length(po) ;
          if l>3 then
            while (po[l-1]<>'\') do
              l := l - 1;
          po[l] := 0C ;
          po[0] := chr(l - 1);
          end
        else if i<>3 then
          po := po + ps;
        end
      else
        po := po + ps;
      end ;
    if c=0C then
      goto 777;
    end;
777:
  l := Length(po) ;
  if (l>3) and (po[l] = '\') then
    begin
    po[l] := 0C ;
    po[0] := pred(po[0]);
    end;
  fullpath := po;
999:
  Caps(fullpath);
  FExpand := fullpath;
end ;
(*%E *)

(*%F _OS2 *)
function FExpand{(path : PathStr): PathStr};

var
  i,p,l : word ;
  c     : char ;
  hp    : word ;
  lim   : word ;
  R     : Registers ;
  ps    : string[32] ;
  po, fullpath : PathStr ;
label
  555, 777, 999;
begin
  with R do
    begin
    i := 0 ;
    hp := length(path) ;
    IF (hp=0) or (path[2]<>':') or (path[0]=0C) then
      begin
      AH := 19H ;
      MsDos(R) ;
      po[1] := CHR(ord('A')+AL) ;
      p := 1 ;
      end
    else
      begin
      po[1] := CAP(path[1]) ;
      p := 3 ;
      end;
    po[2] := ':' ;
    po[3] := '\' ;
    po[0] := chr(3);
    if path[p]<>'\' then
      begin
      DL := ord(po[1])-ord('A')+1;
      DS := Seg(po) ;
      SI := Ofs(po[4]) ;
      AH := 47H ;
      MsDos(R);
      if DosError <> 0 then
        begin
        fullpath[0] := chr(0) ;
        goto 999;
        end ;
      i := 1;
      while po[i] <> chr(0) do
        i := i + 1;
      po[0] := chr(i - 1);
      if (i>3) then
        begin
        po[i] := '\' ;
        i := i + 1 ;
        po[0] := succ(po[0]);
        end ;
      end
    else
      begin
      i := 4 ;
      p := p + 1;
      end;
    po[i] := CHR (0) ;
    while true do
      begin
      i := 1 ;
      lim := 9 ;
      while true do
        begin
        if (p>hp) then
          begin
          ps[i] := '\' ;
          c := chr(0);
          i := i + 1;
          goto 555;
          end ;
        c := path[p] ;
        p := p + 1 ;
        if (c=0C) or (c='\') then
          begin
          ps[i] := '\' ;
          i := i + 1;
          goto 555;
          end;
        if (c='.') then
          begin
          ps[i] := c;
          i := i + 1;
          lim := 4;
          end
        else if (lim>1) then
          begin
          ps[i] := c ;
          i := i + 1;
          lim := lim - 1 ;
          end ;
        end ;
555:
      ps[i] := 0C ;
      ps[0] := chr(i - 1);
      if (i>2) then
        begin
        if ps[1] = '.' then                    (* .. = parent *)
          begin
          IF (i=4) and( ps[2]='.') then
            begin
            l := Length(po) ;
            if l>3 then
              while (po[l-1]<>'\') do
                l := l - 1;
            po[l] := 0C ;
            po[0] := chr(l - 1);
            end
          else if i<>3 then
            po := po + ps;
          end
        else
          po := po + ps;
        end ;
      if c=0C then
        goto 777;
      end;
777:
    l := Length(po) ;
    if (l>3) and (po[l] = '\') then
      begin
      po[l] := 0C ;
      po[0] := pred(po[0]);
      end;
    fullpath := po;
  end ;
999:
  Caps(fullpath);
  FExpand := fullpath;
end ;
(*%E *)

procedure FSplit{(Path: PathStr; var Dir: DirStr; var Name: NameStr;
                       var Ext: ExtStr)};

var
    n, p: word;
    Name_start, Ext_start, Path_end: word;
    plen: word;
    c: char;
begin
    n := 1;
    Name_start := 1;
    Ext_start := 1;
    plen := length(Path);
    while n <= plen do
      begin
      c := Path[n];
      case c of
        '.' :
          begin
          if((n = plen) or (not((Path[n+1] = '.') or (Path[n+1] = '\') or (Path[n+1] = '/')))) then
            Ext_start := n;
          n := n+1;
          end;
        '/', '\', ':' :
          begin
          n := n+1;
          Name_start := n;
          Ext_start := 1;
          end;
        else
          n := n+1;
        end;
      end;
    Path_end := n;
    if Ext_start = 1 then
      Ext_start := n;
    n := 1;
    p := 1;
    while (n < Name_start) and (p <= size(Dir)) do
      begin
      Dir[p] := Path[n];
      p := p+1;
      n := n+1;
      end;
    Dir[0] := chr(p-1);

    n := Name_start;
    p := 1;
    while (n < Ext_start) and (p <= size(Name)) do
      begin
      Name[p] := Path[n];
      n := n+1;
      p := p+1;
      end;
    Name[0] := chr(p-1);

    p := 1;
    if(Ext_start >= Name_start) then
      begin
      n := Ext_start;
      while (n < Path_end) and (p <= size(Ext)) do
        begin
        Ext[p] := Path[n];
        n := n+1;
        p := p+1;
        end;
      end;
    Ext[0] := chr(p-1);

end;


(*%F _OS2 *)
procedure GetIntVec{(IntNo: byte; var Vector: faraddress)};

var
  R: Registers;
begin
  R.AH := 35H;
  R.AL := IntNo;
  MsDos(R);
  Vector := Ptr(R.ES, R.BX);
end;

procedure SetIntVec{(IntNo: byte; Vector: faraddress)};

var
  R: Registers;
begin
  R.AH := 25H;
  R.AL := IntNo;
  R.DS := Seg(Vector^);
  R.DX := Ofs(Vector^);
  MsDos(R);
end;

procedure GetCBreak{(var Brk: boolean)};

var
  R: Registers;
begin
  R.AH := 33H;
  R.AL := 0;
  MsDos(R);
  Brk := R.DL <> 0;
end;


procedure GetVerify{(var Ver: boolean)};

var
  R: Registers;
begin
  R.AH := 54H;
  MsDos(R);
  Ver := R.AL <> 0;
end;
(*%E *)

(*%T _OS2 *)
procedure GetIntVec{(IntNo: byte; var Vector: faraddress)};

begin
  NotSupported;
end;

procedure SetIntVec{(IntNo: byte; Vector: faraddress)};

begin
  NotSupported;
end;

procedure GetCBreak{(var Brk: boolean)};

begin
  NotSupported;
end;


procedure GetVerify{(var Ver: boolean)};

var
  state: word;
begin
  Dos.QVerify(state);
  Ver := (state = 1);
end;
(*%E *)

function DosError{: int16};

begin
  DosError := CoreSig._errno__^;
end;

procedure SwapVectors;
begin
end;


begin
  NilStr := '';
end .
